package com.anssi.ebios.command.impact
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.anssi.ebios.command.AppCommand;
	import com.anssi.ebios.event.impactevent.CreateImpactEvent;
	import com.anssi.ebios.event.impactevent.UpdateImpactEvent;
	import com.anssi.ebios.event.peopleevent.DeletePeopleEvent;
	import com.anssi.ebios.event.peopleevent.GetPeopleByIdEvent;
	import com.anssi.ebios.event.peopleevent.UpdatePeopleEvent;
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.services.ImpactService;
	import mx.managers.CursorManager;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;
	
	public class CreateImpactCommand extends AppCommand implements ICommand, IResponder
	{
		
		private var _callBack:Function;
		
		public function execute(event:CairngormEvent):void
		{
			var evt:CreateImpactEvent = (event as CreateImpactEvent);
			_callBack = evt.callBack;
			
			CursorManager.setBusyCursor();
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var impactService:ImpactService = ac.getObject("impactService", [this]) as ImpactService;
			impactService.createImpact(evt.impact);
		}
		
		public function result(data:Object):void
		{
			CursorManager.removeBusyCursor();
			if(_callBack!= null){
				_callBack(data);
			}
		}
	}
}