package com.anssi.ebios.command.impacttype
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.anssi.ebios.command.AppCommand;
	import com.anssi.ebios.event.gravitylevelevent.GetGravityLevelEvent;
	import com.anssi.ebios.event.impactevent.GetImpactEvent;
	import com.anssi.ebios.event.impacttypeevent.GetImpactTypeEvent;
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.services.GravityLevelService;
	import com.anssi.ebios.services.ImpactService;
	import com.anssi.ebios.services.ImpactTypeService;
	import mx.managers.CursorManager;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;
	
	public class GetImpactTypeCommand extends AppCommand implements ICommand, IResponder
	{
		private var _callBack:Function;
		
		public function execute(event:CairngormEvent):void
		{
			var evt:GetImpactTypeEvent = (event as GetImpactTypeEvent);
			_callBack = evt.callBack;
			
			CursorManager.setBusyCursor();
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var impactTypeService:ImpactTypeService = ac.getObject("impactTypeService", [this]) as ImpactTypeService;
			impactTypeService.getImpactType();
		}
		
		public function result(data:Object):void
		{
			CursorManager.removeBusyCursor();
			if(_callBack != null){
				_callBack(data);
			}
		}
	}
}