package com.anssi.ebios.command.openxml
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.anssi.ebios.command.AppCommand;
	import com.anssi.ebios.event.objectiveevent.GetObjectiveEvent;
	import com.anssi.ebios.event.openxmlevent.GetOpenXMLFromStringEvent;
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.services.ObjectiveService;
	import com.anssi.ebios.services.OpenXMLService;
	import mx.managers.CursorManager;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;

	public class GetOpenXMLFromStringCommand extends AppCommand implements ICommand, IResponder
	{
		public var callBack:Function;
		
		public function execute(event:CairngormEvent):void
		{
			var evt:GetOpenXMLFromStringEvent = (event as GetOpenXMLFromStringEvent);
			this.callBack = evt.callBack;
			
			CursorManager.setBusyCursor();
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var openXMLService:OpenXMLService = ac.getObject("openXMLService", [this]) as OpenXMLService;
			openXMLService.constructOpenXMLFromString(evt.strToFormat);
		}
		
		public function result(data:Object):void
		{
			CursorManager.removeBusyCursor();
			if(this.callBack != null){
				this.callBack(data);
			}
		}
	}
}