package com.anssi.ebios.command.primaryasset
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.anssi.ebios.command.AppCommand;
	import com.anssi.ebios.event.primaryassetevent.GetPrimaryAssetsXMLEvent;
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.services.PrimaryAssetService;
	
	import mx.managers.CursorManager;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;

	public class GetPrimaryAssetsXMLCommand extends AppCommand implements ICommand, IResponder
	{
		private var _callBack:Function;
		
		public function execute(event:CairngormEvent):void
		{
			var evt:GetPrimaryAssetsXMLEvent = (event as GetPrimaryAssetsXMLEvent);
			_callBack = evt.callBack;
			
			CursorManager.setBusyCursor();
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var primaryAssetService:PrimaryAssetService = ac.getObject("primaryAssetService", [this]) as PrimaryAssetService;
			primaryAssetService.getPrimaryAssetsXML();
		}
		
		public function result(data:Object):void
		{
			CursorManager.removeBusyCursor();
			if(_callBack != null){
				_callBack(data);
			}
		}
	}
}