package com.anssi.ebios.command.riskgeneration 
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.anssi.ebios.command.AppCommand;
	import com.anssi.ebios.event.riskevent.GetObjectiveRiskEvent;
	import com.anssi.ebios.event.riskgeneration.GenerateRiskEvent;
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.services.RiskGenerationService;
	
	import mx.managers.CursorManager;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;

	public class GenerateRiskCommand extends AppCommand implements ICommand, IResponder
	{
		public var callBack:Function;
		
		public function execute(event:CairngormEvent):void
		{
			var evt:GenerateRiskEvent = (event as GenerateRiskEvent);
			this.callBack = evt.callBack;
			
			CursorManager.setBusyCursor();
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var riskGenerationService:RiskGenerationService  = ac.getObject("riskGenerationService", [this]) as RiskGenerationService;
			riskGenerationService.generateRisk(evt.methodKey);
		}
		
		public function result(data:Object):void
		{
			CursorManager.removeBusyCursor();
			if(this.callBack != null){
				this.callBack(data);
			}
		}
	}
}