package com.anssi.ebios.command.securitycriteria
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.anssi.ebios.command.AppCommand;
	import com.anssi.ebios.event.parameterevent.DeleteParameterEvent;
	import com.anssi.ebios.event.securitycriteriaevent.DeleteSecurityCriteriaEvent;
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.services.SecurityCriteriaService;
	
	import mx.managers.CursorManager;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;

	public class DeleteSecurityCriteriaCommand extends AppCommand implements ICommand, IResponder
	{
		public var callBack:Function;
		
		public function execute(event:CairngormEvent):void
		{
			var evt:DeleteSecurityCriteriaEvent = (event as DeleteSecurityCriteriaEvent);
			this.callBack = evt.callBack;
			
			CursorManager.setBusyCursor();
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var securityCriteriaService:SecurityCriteriaService = ac.getObject("securityCriteriaService", [this]) as SecurityCriteriaService;
			securityCriteriaService.deleteSecurityCriteria(evt.securityCriteria);
		}
		
		public function result(data:Object):void
		{
			CursorManager.removeBusyCursor();
			if(this.callBack != null){
				this.callBack(data);
			}
		}
	}
}