package com.anssi.ebios.command.threatsource
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.anssi.ebios.command.AppCommand;
	import com.anssi.ebios.event.securityneed.GetSecurityNeedsEvent;
	import com.anssi.ebios.event.threatsourceevent.GetThreatSourceByIdEvent;
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.services.SecurityNeedService;
	import com.anssi.ebios.services.ThreatSourceService;
	
	import mx.managers.CursorManager;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;
	
	public class GetThreatSourceByIdCommand extends AppCommand implements ICommand, IResponder
	{
		
		public var callBack:Function;
		
		public function execute(event:CairngormEvent):void
		{
			var evt:GetThreatSourceByIdEvent = (event as GetThreatSourceByIdEvent);
			this.callBack = evt.callBack;
			
			CursorManager.setBusyCursor();
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var threatSourceService:ThreatSourceService = ac.getObject("threatSourceService", [this]) as ThreatSourceService;
			threatSourceService.getThreatSourceById(evt.threatSourceId);
		}
		
		public function result(data:Object):void
		{
			CursorManager.removeBusyCursor();
			if(this.callBack != null){
				this.callBack(data);
			}
		}
	}
}