package com.anssi.ebios.command.threatsource
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.anssi.ebios.command.AppCommand;
	import com.anssi.ebios.event.securityneed.GetSecurityNeedsEvent;
	import com.anssi.ebios.event.threatsourceevent.GetThreatSourceEvent;
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.services.SecurityNeedService;
	import com.anssi.ebios.services.ThreatSourceService;
	
	import mx.managers.CursorManager;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;
	
	public class GetThreatSourceCommand extends AppCommand implements ICommand, IResponder
	{

		public var callBack:Function;
		
		public function execute(event:CairngormEvent):void
		{
			var evt:GetThreatSourceEvent = (event as GetThreatSourceEvent);
			this.callBack = evt.callBack;
			
			CursorManager.setBusyCursor();
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var threatSourceService:ThreatSourceService = ac.getObject("threatSourceService", [this]) as ThreatSourceService;
			threatSourceService.getThreatSource();
		}
		
		public function result(data:Object):void
		{
			CursorManager.removeBusyCursor();
			if(this.callBack != null){
				this.callBack(data);
			}
		}
	}
}