package com.anssi.ebios.command.workstructure
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.anssi.ebios.command.AppCommand;
	import com.anssi.ebios.event.workstructureevent.GetWorkStructureEvent;
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.services.WorkStructureService;
	
	import mx.managers.CursorManager;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;

	public class GetWorkStructureCommand extends AppCommand implements ICommand, IResponder
	{
		private var _callBack:Function;
		
		public function execute(event:CairngormEvent):void
		{
			var evt:GetWorkStructureEvent = (event as GetWorkStructureEvent);
			_callBack = evt.callBack;
			
			CursorManager.setBusyCursor();
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var workStructureService:WorkStructureService = ac.getObject("workStructureService", [this]) as WorkStructureService;
			workStructureService.getWorkStructureList();
		}
		
		public function result(data:Object):void
		{
			CursorManager.removeBusyCursor();
			if(_callBack != null){
				_callBack(data);
			}
		}
	}
}