package com.anssi.ebios.control {
	
	import com.adobe.cairngorm.control.FrontController;
	import com.anssi.ebios.command.action.AffectStagesToDeliverableCommand;
	import com.anssi.ebios.command.action.GetActionByKeyCommand;
	import com.anssi.ebios.command.action.GetActionCommand;
	import com.anssi.ebios.command.action.GetActionLightCommand;
	import com.anssi.ebios.command.action.GetStagesByDeliverableCommand;
	import com.anssi.ebios.command.action.GetStagesCommand;
	import com.anssi.ebios.command.action.GetStagesTreeCommand;
	import com.anssi.ebios.command.action.IsStudyStagesDefinedCommand;
	import com.anssi.ebios.command.action.UpdateActionRegleCommand;
	import com.anssi.ebios.command.action.UpdateStageCommand;
	import com.anssi.ebios.command.actionplan.GetActionPlanCommand;
	import com.anssi.ebios.command.actionplan.GetComplementarySecurityMeasureByIdCommand;
	import com.anssi.ebios.command.actionplan.UpdateComplementarySecurityMeasureCommand;
	import com.anssi.ebios.command.audit.GetAuditCommand;
	import com.anssi.ebios.command.audit.GetAuditLightCommand;
	import com.anssi.ebios.command.audit.LaunchAuditCommand;
	import com.anssi.ebios.command.defenceline.GetDefenceLineCommand;
	import com.anssi.ebios.command.deliverable.CreateDeliverableCommand;
	import com.anssi.ebios.command.deliverable.GetDeliverableByIdCommand;
	import com.anssi.ebios.command.deliverable.GetDeliverableCommand;
	import com.anssi.ebios.command.deliverable.GetDeliverableToProductCommand;
	import com.anssi.ebios.command.deliverable.UpdateDeliverableCommand;
	import com.anssi.ebios.command.deliverable.UpdateDeliverableListCommand;
	import com.anssi.ebios.command.fearedevent.AddOneImpactToFearedEventCommand;
	import com.anssi.ebios.command.fearedevent.AddThreatSourceToFearedEventCommand;
	import com.anssi.ebios.command.fearedevent.GetFearedEventByGravityCommand;
	import com.anssi.ebios.command.fearedevent.GetFearedEventByIdCommand;
	import com.anssi.ebios.command.fearedevent.GetFearedEventLightCommand;
	import com.anssi.ebios.command.fearedevent.GetFearedEventsCommand;
	import com.anssi.ebios.command.fearedevent.UpdateFearedEventCommand;
	import com.anssi.ebios.command.gravitylevel.DeleteGravityLevelCommand;
	import com.anssi.ebios.command.gravitylevel.GetGravityLevelCommand;
	import com.anssi.ebios.command.gravitylevel.GetGravityLevelLightCommand;
	import com.anssi.ebios.command.gravitylevel.UpdateGravityLevelCommand;
	import com.anssi.ebios.command.image.DeleteImageCommand;
	import com.anssi.ebios.command.image.GetImageCommand;
	import com.anssi.ebios.command.image.UpdateImageCommand;
	import com.anssi.ebios.command.impact.CreateImpactCommand;
	import com.anssi.ebios.command.impact.DeleteImpactCommand;
	import com.anssi.ebios.command.impact.GetImpactByIdCommand;
	import com.anssi.ebios.command.impact.GetImpactCommand;
	import com.anssi.ebios.command.impact.UpdateImpactCommand;
	import com.anssi.ebios.command.impacttype.GetImpactTypeCommand;
	import com.anssi.ebios.command.importstudy.MapXMLtoSQLcommand;
	import com.anssi.ebios.command.indicator.CreateIndicatorCommand;
	import com.anssi.ebios.command.indicator.DeleteIndicatorCommand;
	import com.anssi.ebios.command.indicator.DeleteIndicatorLevelCommand;
	import com.anssi.ebios.command.indicator.GetIndicatorByIdCommand;
	import com.anssi.ebios.command.indicator.GetIndicatorCommand;
	import com.anssi.ebios.command.indicator.UpdateIndicatorCommand;
	import com.anssi.ebios.command.information.GetInformationCommand;
	import com.anssi.ebios.command.likelihoodlevel.DeleteLikelihoodLevelCommand;
	import com.anssi.ebios.command.likelihoodlevel.GetLikelihoodLevelCommand;
	import com.anssi.ebios.command.likelihoodlevel.GetLikelihoodLevelLightCommand;
	import com.anssi.ebios.command.likelihoodlevel.UpdateLikehoodLevelCommand;
	import com.anssi.ebios.command.objective.GetObjectiveCommand;
	import com.anssi.ebios.command.openxml.GetOpenXMLFromStringCommand;
	import com.anssi.ebios.command.parameter.CreateParameterCommand;
	import com.anssi.ebios.command.parameter.DeleteParameterCommand;
	import com.anssi.ebios.command.parameter.GetParameterByIdCommand;
	import com.anssi.ebios.command.parameter.GetParameterCommand;
	import com.anssi.ebios.command.parameter.GetParameterTypeCommand;
	import com.anssi.ebios.command.parameter.UpdateParameterCommand;
	import com.anssi.ebios.command.parameter.UpdateParameterListCommand;
	import com.anssi.ebios.command.people.AffectPeopleToStudyCommand;
	import com.anssi.ebios.command.people.CreatePeopleCommand;
	import com.anssi.ebios.command.people.DeletePeopleCommand;
	import com.anssi.ebios.command.people.GetPeopleByIdCommand;
	import com.anssi.ebios.command.people.GetPeopleCommand;
	import com.anssi.ebios.command.people.GetRetainedPeopleCommand;
	import com.anssi.ebios.command.people.GetRetainedPeopleLightCommand;
	import com.anssi.ebios.command.people.UpdatePeopleCommand;
	import com.anssi.ebios.command.primaryasset.GetPrimaryAssetCommand;
	import com.anssi.ebios.command.primaryasset.GetPrimaryAssetLightCommand;
	import com.anssi.ebios.command.primaryasset.GetPrimaryAssetsXMLCommand;
	import com.anssi.ebios.command.primaryasset.SavePrimaryAssetsCommand;
	import com.anssi.ebios.command.referentiel.GetReferentielCommand;
	import com.anssi.ebios.command.requirement.CreateRequirementCommand;
	import com.anssi.ebios.command.requirement.DeleteRequirementCommand;
	import com.anssi.ebios.command.requirement.GetRequirementByIdCommand;
	import com.anssi.ebios.command.requirement.GetRequirementCommand;
	import com.anssi.ebios.command.requirement.UpdateRequirementCommand;
	import com.anssi.ebios.command.risk.GetObjectiveRiskCommand;
	import com.anssi.ebios.command.risk.GetResidualRiskCommand;
	import com.anssi.ebios.command.risk.GetResidualRiskLightCommand;
	import com.anssi.ebios.command.risk.GetRiskByIdCommand;
	import com.anssi.ebios.command.risk.GetRiskCommand;
	import com.anssi.ebios.command.risk.GetRiskExportCommand;
	import com.anssi.ebios.command.risk.GetRiskLightCommand;
	import com.anssi.ebios.command.risk.GetRiskMappingCommand;
	import com.anssi.ebios.command.risk.GetRiskResidCommand;
	import com.anssi.ebios.command.risk.GetSecurityMeasureByRiskLightCommand;
	import com.anssi.ebios.command.risk.UpdateObjectiveRiskCommand;
	import com.anssi.ebios.command.risk.UpdateRiskCommand;
	import com.anssi.ebios.command.risk.UpdateUnretainedResidualRiskCommand;
	import com.anssi.ebios.command.riskevaluation.GetRiskEvaluationCommand;
	import com.anssi.ebios.command.riskevaluation.ResetRiskEvaluationCommand;
	import com.anssi.ebios.command.riskevaluation.UpdateRiskEvaluationAssociationCommand;
	import com.anssi.ebios.command.riskevaluation.UpdateRiskEvaluationColorCommand;
	import com.anssi.ebios.command.riskgeneration.GenerateRiskCommand;
	import com.anssi.ebios.command.riskgeneration.GetRiskNumberCommand;
	import com.anssi.ebios.command.role.GetRoleCommand;
	import com.anssi.ebios.command.securitycriteria.CreateSecurityCriteriaCommand;
	import com.anssi.ebios.command.securitycriteria.DeleteSecurityCriteriaCommand;
	import com.anssi.ebios.command.securitycriteria.GetSecurityCriteriaByIdCommand;
	import com.anssi.ebios.command.securitycriteria.GetSecurityCriteriaCommand;
	import com.anssi.ebios.command.securitycriteria.GetSecurityCriteriaLightCommand;
	import com.anssi.ebios.command.securitycriteria.UpdateSecurityCriteriaCommand;
	import com.anssi.ebios.command.securitymeasure.CreateComplementarySecurityMeasureCommand;
	import com.anssi.ebios.command.securitymeasure.CreateImportSecurityMeasureCommand;
	import com.anssi.ebios.command.securitymeasure.CreateSecurityMeasureCommand;
	import com.anssi.ebios.command.securitymeasure.DeleteSecurityMeasureCommand;
	import com.anssi.ebios.command.securitymeasure.GetSecurityMeasureByIdCommand;
	import com.anssi.ebios.command.securitymeasure.GetSecurityMeasureByRiskCommand;
	import com.anssi.ebios.command.securitymeasure.GetSecurityMeasureCommand;
	import com.anssi.ebios.command.securitymeasure.GetSecurityMeasureImportCommand;
	import com.anssi.ebios.command.securitymeasure.GetSecurityMeasureLightCommand;
	import com.anssi.ebios.command.securitymeasure.GetSecurityMeasureStateECommand;
	import com.anssi.ebios.command.securitymeasure.UpdateSecurityMeasureCommand;
	import com.anssi.ebios.command.securitymeasuretype.GetSecurityMeasureTypeCommand;
	import com.anssi.ebios.command.securityneed.DeleteSecurityNeedCommand;
	import com.anssi.ebios.command.securityneed.GetSecurityNeedsCommand;
	import com.anssi.ebios.command.status.GetStatusCommand;
	import com.anssi.ebios.command.study.CreateBlankStudyCommand;
	import com.anssi.ebios.command.subject.GetSubjectCommand;
	import com.anssi.ebios.command.subject.UpdateSubjectCommand;
	import com.anssi.ebios.command.supportasset.GetSupportAssetsLightCommand;
	import com.anssi.ebios.command.supportasset.GetSupportAssetsXMLCommand;
	import com.anssi.ebios.command.supportasset.SaveSupportAssetsCommand;
	import com.anssi.ebios.command.supportassettype.GetSupportAssetsTypesCommand;
	import com.anssi.ebios.command.supportingasset.GetLinkBetweenAssetsCommand;
	import com.anssi.ebios.command.supportingasset.GetRetainedSupportingAssetCommand;
	import com.anssi.ebios.command.supportingasset.UpdateLinkBetweenAssetsCommand;
	import com.anssi.ebios.command.threat.CreateThreatCommand;
	import com.anssi.ebios.command.threat.DeleteThreatCommand;
	import com.anssi.ebios.command.threat.GetThreatByIdCommand;
	import com.anssi.ebios.command.threat.GetThreatByTBSCommand;
	import com.anssi.ebios.command.threat.GetThreatCommand;
	import com.anssi.ebios.command.threat.GetThreatTypeCommand;
	import com.anssi.ebios.command.threat.UpdateThreatCommand;
	import com.anssi.ebios.command.threatscenario.DuplicateThreatScnenarioCommand;
	import com.anssi.ebios.command.threatscenario.GetThreatScenarioByIdCommand;
	import com.anssi.ebios.command.threatscenario.GetThreatScenarioByLikelihoodLevelCommand;
	import com.anssi.ebios.command.threatscenario.GetThreatScenarioCommand;
	import com.anssi.ebios.command.threatscenario.GetThreatScenarioLightCommand;
	import com.anssi.ebios.command.threatscenario.UpdateThreatScenarioCommand;
	import com.anssi.ebios.command.threatsource.CreateThreatSourceAndRetainTypeCommand;
	import com.anssi.ebios.command.threatsource.CreateThreatSourceCommand;
	import com.anssi.ebios.command.threatsource.DeleteThreatSourceCommand;
	import com.anssi.ebios.command.threatsource.GetThreatSourceByIdCommand;
	import com.anssi.ebios.command.threatsource.GetThreatSourceCommand;
	import com.anssi.ebios.command.threatsource.GetThreatSourceListCommand;
	import com.anssi.ebios.command.threatsource.GetThreatSourceWithoutTypeCommand;
	import com.anssi.ebios.command.threatsource.UpdateThreatSourceCommand;
	import com.anssi.ebios.command.threatsourcetype.GetThreatSourceTypeByIdCommand;
	import com.anssi.ebios.command.threatsourcetype.GetThreatSourceTypeCommand;
	import com.anssi.ebios.command.threatsourcetype.UpdateThreatSourceTypeCommand;
	import com.anssi.ebios.command.vulnerability.CreateVulnerabiltyCommand;
	import com.anssi.ebios.command.vulnerability.DeleteVulnerabilityCommand;
	import com.anssi.ebios.command.vulnerability.GetVulnerabilityByIdCommand;
	import com.anssi.ebios.command.vulnerability.GetVulnerabilityByThreatTypeCommand;
	import com.anssi.ebios.command.vulnerability.GetVulnerabilityCommand;
	import com.anssi.ebios.command.vulnerability.UpdateVulnerabilityCommand;
	import com.anssi.ebios.command.vulnerabilitytype.GetVulnerabilityTypeCommand;
	import com.anssi.ebios.command.workstructure.GetWorkStructureByActionNumeroCommand;
	import com.anssi.ebios.command.workstructure.GetWorkStructureCommand;
	import com.anssi.ebios.command.workstructure.GetWorkStructureLightCommand;
	import com.anssi.ebios.command.workstructure.UpdateWorkstructureCommand;
	
	public class AppController extends FrontController {
		
		
		// A CLASSER PAR ORDRE ALPHABETIQUE
		
		public static const ADD_THREATSOURCE_TO_FEAREDEVENT_EVENT:String = "ADD_THREATSOURCE_TO_FEAREDEVENT_EVENT";
		public static const ADD_ONE_THREATSOURCE_TO_FEAREDEVENT_EVENT:String = "ADD_ONE_THREATSOURCE_TO_FEAREDEVENT_EVENT";
		public static const AFFECT_STAGES_TO_DELIVERABLE:String = "AFFECT_STAGES_TO_DELIVERABLE";
		public static const AFFECT_PEOPLE_TO_STUDY:String = "AFFECT_PEOPLE_TO_STUDY";		
		
		public static const CREATE_BLANK_STUDY:String = "CREATE_BLANK_STUDY";
		public static const CREATE_DELIVERABLE:String = "CREATE_DELIVERABLE";
		public static const CREATE_IMPACT:String = "CREATE_IMPACT";
		public static const CREATE_INDICATOR:String = "CREATE_INDICATOR";
		public static const CREATE_PARAMETER:String = "CREATE_PARAMETER";
		public static const CREATE_PEOPLE:String = "CREATE_PEOPLE";
		public static const CREATE_REQUIREMENT:String = "CREATE_REQUIREMENT";
		public static const CREATE_SECURITY_CRITERIA:String = "CREATE_SECURITY_CRITERIA";
		public static const CREATE_SECURITY_MEASURE:String = "CREATE_SECURITY_MEASURE";
		public static const CREATE_COMPLEMENTARY_SECURITY_MEASURE:String = "CREATE_COMPLEMENTARY_SECURITY_MEASURE";
		public static const CREATE_IMPORT_SECURITY_MEASURE:String = "CREATE_IMPORT_SECURITY_MEASURE";
		public static const CREATE_THREAT:String = "CREATE_THREAT";
		public static const CREATE_THREAT_SOURCE:String = "CREATE_THREAT_SOURCE";
		public static const CREATE_THREAT_SOURCE_AND_RETAIN_TYPE:String = "CREATE_THREAT_SOURCE_AND_RETAIN_TYPE";
		public static const CREATE_VULNERABILITY:String = "CREATE_VULNERABILITY";

		
		public static const DELETE_GRAVITY_LEVEL:String = "DELETE_GRAVITY_LEVEL";
		public static const DELETE_IMAGE:String = "DELETE_IMAGE";
		public static const DELETE_IMPACT:String = "DELETE_IMPACT";
		public static const DELETE_INDICATOR:String = "DELETE_INDICATOR";
		public static const DELETE_INDICATOR_LEVEL:String = "DELETE_INDICATOR_LEVEL";
		public static const DELETE_LIKELIHOOD_LEVEL:String = "DELETE_LIKELIHOOD_LEVEL";
		public static const DELETE_PARAMETER:String = "DELETE_PARAMETER";
		public static const DELETE_PEOPLE:String = "DELETE_PEOPLE";
		public static const DELETE_REQUIREMENT:String = "DELETE_REQUIREMENT";
		public static const DELETE_SECURITY_CRITERIA:String = "DELETE_SECURITY_CRITERIA";
		public static const DELETE_SECURITY_MEASURE:String = "DELETE_SECURITY_MEASURE";
		public static const DELETE_SECURITY_NEED:String = "DELETE_SECURITY_NEED";
		public static const DELETE_VULNERABILITY:String = "DELETE_VULNERABILITY";
		public static const DUPLICATE_THREAT_SCENARIO:String = "DUPLICATE_THREAT_SCENARIO";
		public static const DELETE_THREAT:String = "DELETE_THREAT";
		public static const DELETE_THREAT_SOURCE:String = "DELETE_THREAT_SOURCE";
		
		public static const GENERATE_RISK:String = "GENERATE_RISK"; 
		public static const GET_ACTION:String = "GET_ACTION";
		public static const GET_ACTION_BY_KEY:String = "GET_ACTION_BY_KEY";
		public static const GET_ACTION_PLAN:String = "GET_ACTION_PLAN";
		public static const GET_AUDIT:String = "GET_AUDIT";
		public static const GET_AUDIT_LIGHT:String = "GET_AUDIT_LIGHT";
		public static const GET_COMPLEMENTARY_SECURITY_MEASURE_BY_ID:String = "GET_COMPLEMENTARY_SECURITY_MEASURE_BY_ID";
		public static const GET_DEFENCE_LINE:String = "GET_DEFENCE_LINE";
		public static const GET_DELIVERABLE:String = "GET_DELIVERABLE";
		public static const GET_DELIVERABLE_BY_ID:String = "GET_DELIVERABLE_BY_ID";
		public static const GET_FEARED_EVENT_BY_GRAVITY:String = "GET_FEARED_EVENT_BY_GRAVITY";
		public static const GET_FEARED_EVENT_LIGHT:String = "GET_FEARED_EVENT_LIGHT";
		public static const GET_DELIVERABLE_TO_PRODUCT:String = "GET_DELIVERABLE_TO_PRODUCT";
		public static const GET_FEARED_EVENT_BY_ID:String = "GET_FEARED_EVENT_BY_ID";
		public static const GET_FEARED_EVENTS:String = "GET_FEARED_EVENTS";
		public static const GET_GRAVITY_LEVEL:String = "GET_GRAVITY_LEVEL";
		public static const GET_GRAVITY_LEVEL_LIGHT:String = "GET_GRAVITY_LEVEL_LIGHT";
		public static const GET_IMAGE:String = "GET_IMAGE";
		public static const GET_IMPACT:String = "GET_IMPACT";
		public static const GET_INFORMATION:String = "GET_INFORMATION";
		public static const GET_LINK_BETWEEN_ASSETS:String = "GET_LINK_BETWEEN_ASSETS";
		public static const GET_LIKELIHOOD_LEVEL_LIGHT:String = "GET_LIKELIHOOD_LEVEL_LIGHT";
		public static const GET_INDICATOR_BY_ID:String = "GET_INDICATOR_BY_ID";
		public static const GET_INDICATOR:String = "GET_INDICATOR";
		public static const GET_OBJECTIVE:String = "GET_OBJECTIVE";
		public static const GET_OBJECTIVE_RISK:String = "GET_OBJECTIVE_RISK";
		public static const GET_PARAMETER:String = "GET_PARAMETER";
		public static const GET_PARAMETER_BY_ID:String = "GET_PARAMETER_BY_ID";
		public static const GET_PARAMETER_TYPE:String = "GET_PARAMETER_TYPE";
		public static const GET_PEOPLE:String = "GET_PEOPLE";		
		public static const GET_PEOPLE_BY_ID:String = "GET_PEOPLE_BY_ID";
		public static const GET_PRIMARY_ASSETS_XML:String = "GET_PRIMARY_ASSETS_XML";
		public static const GET_PRIMARY_ASSET:String = "GET_PRIMARY_ASSET";
		public static const GET_PRIMARY_ASSET_LIGHT:String = "GET_PRIMARY_ASSET_LIGHT";
		public static const GET_REFERENTIEL:String = "GET_REFERENTIEL";
		public static const GET_REQUIREMENT:String = "GET_REQUIREMENT";
		public static const GET_REQUIREMENT_BY_ID:String = "GET_REQUIREMENT_BY_ID";
		public static const GET_RESIDUAL_RISK:String = "GET_RESIDUAL_RISK";
		public static const GET_RESIDUAL_RISK_LIGHT:String = "GET_RESIDUAL_RISK_LIGHT";
		public static const GET_RISK_RESID:String = "GET_RISK_RESID";
		public static const GET_RETAINED_PEOPLE:String = "GET_RETAINED_PEOPLE";
		public static const GET_RETAINED_PEOPLE_LIGHT:String = "GET_RETAINED_PEOPLE_LIGHT";
		public static const GET_ROLE:String = "GET_ROLE";
		public static const GET_RISK_CRITERIA:String = "GET_RISK_CRITERIA";
		public static const GET_RISK_EVALUATION:String = "GET_RISK_EVALUATION";
		public static const GET_RISK_LIGHT:String = "GET_RISK_LIGHT";
		public static const GET_RISK_EXPORT:String = "GET_RISK_EXPORT";
		public static const GET_RISK_MAPPING:String = "GET_RISK_MAPPING";
		public static const GET_RISK_NUMBER:String = "GET_RISK_NUMBER";
		public static const GET_SECURITY_CRITERIA:String = "GET_SECURITY_CRITERIA";
		public static const GET_SECURITY_CRITERIA_BY_ID:String = "GET_SECURITY_CRITERIA_BY_ID";
		public static const GET_SECURITY_CRITERIA_LIGHT:String = "GET_SECURITY_CRITERIA_LIGHT";
		public static const GET_SECURITY_MEASURE:String = "GET_SECURITY_MEASURE";
		public static const GET_SECURITY_MEASURE_IMPORT:String = "GET_SECURITY_MEASURE_IMPORT";
		public static const GET_SECURITY_MEASURE_STATE_E:String = "GET_SECURITY_MEASURE_STATE_E";
		public static const GET_SECURITY_MEASURE_LIGHT:String = "GET_SECURITY_MEASURE_LIGHT";
		public static const GET_SECURITY_MEASURE_BY_ID:String = "GET_SECURITY_MEASURE_BY_ID";
		public static const GET_SECURITY_MEASURE_BY_RISK:String = "GET_SECURITY_MEASURE_BY_RISK";
		public static const GET_SECURITY_MEASURE_BY_RISK_LIGHT:String = "GET_SECURITY_MEASURE_BY_RISK_LIGHT";
		public static const GET_SECURITY_MEASURE_TYPE:String = "GET_SECURITY_MEASURE_TYPE";
		public static const GET_SECURITY_NEEDS:String = "GET_SECURITY_NEEDS";
		public static const GET_STAGES:String = "GET_STAGES";
		public static const GET_STAGES_TREE:String = "GET_STAGES_TREE";
		public static const GET_STAGES_BY_DELIVERABLE:String = "GET_STAGES_BY_DELIVERABLE";
		public static const GET_STATUS:String = "GET_STATUS";
		public static const GET_SUBJECT:String = "GET_SUBJECT";
		public static const GET_SUPPORT_ASSETS_TYPES:String = "GET_SUPPORT_ASSETS_TYPES";
		public static const GET_SUPPORT_ASSETS_XML:String = "GET_SUPPORT_ASSETS_XML";
		public static const GET_SUPPORT_ASSETS_LIGHT:String = "GET_SUPPORT_ASSETS_LIGHT";
		public static const GET_SUPPORTING_ASSET:String = "GET_SUPPORTING_ASSET";
		public static const GET_THREAT:String = "GET_THREAT";
		public static const GET_THREAT_BY_ID:String = "GET_THREAT_BY_ID";
		public static const GET_THREAT_BY_TBS:String = "GET_THREAT_BY_TBS";
		public static const GET_THREAT_SCENARIO_LIGHT:String = "GET_THREAT_SCENARIO_LIGHT";
		public static const GET_THREAT_SOURCE:String = "GET_THREAT_SOURCE";
		public static const GET_THREAT_SOURCE_BY_ID:String = "GET_THREAT_SOURCE_BY_ID";
		public static const GET_THREAT_SOURCE_LIST:String = "GET_THREAT_SOURCE_LIST";
		public static const GET_THREAT_SOURCE_TYPE:String = "GET_THREAT_SOURCE_TYPE";
		public static const GET_THREAT_SOURCE_TYPE_BY_ID:String = "GET_THREAT_SOURCE_TYPE_BY_ID";
		public static const GET_THREAT_SOURCE_WITHOUT_TYPE:String = "GET_THREAT_SOURCE_WITHOUT_TYPE";
		public static const GET_THREAT_TYPE:String = "GET_THREAT_TYPE";
		public static const GET_VULNERABILITY:String = "GET_VULNERABILITY";
		public static const GET_VULNERABILITY_BY_ID:String = "GET_VULNERABILITY_BY_ID";
		public static const GET_VULNERABILITY_BY_THREAT_TYPE:String = "GET_VULNERABILITY_BY_THREAT_TYPE";
		public static const GET_VULNERABILITY_TYPE:String = "GET_VULNERABILITY_TYPE";
		public static const GET_IMPACT_TYPE:String = "GET_IMPACT_TYPE";
		public static const GET_IMPACT_BY_ID:String = "GET_IMPACT_BY_ID";
		public static const GET_THREAT_SCENARIO_BY_ID:String = "GET_THREAT_SCENARIO_BY_ID";
		public static const GET_THREAT_SCENARIO_BY_LIKELIHOOD_LEVEL:String = "GET_THREAT_SCENARIO_BY_LIKELIHOOD_LEVEL";
		public static const GET_THREAT_SCENARIO:String = "GET_THREAT_SCENARIO";
		public static const GET_LIKELIHOOD_LEVEL:String = "GET_LIKELIHOOD_LEVEL";
		public static const GET_RISK:String = "GET_RISK";
		public static const GET_WORK_STRUCTURE:String = "GET_WORK_STRUCTURE";
		public static const GET_WORK_STRUCTURE_LIGHT:String = "GET_WORK_STRUCTURE_LIGHT";
		public static const GET_WORK_STRUCTURE_BY_ACTION_NUMERO:String = "GET_WORK_STRUCTURE_BY_ACTION_NUMERO";
		public static const GET_RISK_BY_ID:String = "GET_RISK_BY_ID";
		
		public static const GET_OPENXML_FROM_STRING:String = "GET_OPENXML_FROM_STRING";
		
		public static const IS_STUDY_STAGES_DEFINED:String = "IS_STUDY_STAGES_DEFINED";
		
		public static const LAUNCH_AUDIT:String="LAUNCH_AUDIT";
		
		public static const MAP_XML_TO_SQL:String="MAP_XML_TO_SQL";
		
		public static const SAVE_PRIMARY_ASSETS:String = "SAVE_PRIMARY_ASSETS";
		public static const SAVE_SUPPORT_ASSETS:String = "SAVE_SUPPORT_ASSETS";
		public static const UPDATE_ACTION_REGLE:String = "UPDATE_ACTION_REGLE";
		public static const UPDATE_COMPLEMENTARY_SECURITY_MEASURE:String = "UPDATE_COMPLEMENTARY_SECURITY_MEASURE";
		public static const UPDATE_DELIVERABLE:String = "UPDATE_DELIVERABLE";
		public static const UPDATE_DELIVERABLE_LIST:String = "UPDATE_DELIVERABLE_LIST";
		public static const UPDATE_FEAREDEVENT:String = "UPDATE_FEAREDEVENT";
		public static const UPDATE_GRAVITY_LEVEL:String = "UPDATE_GRAVITY_LEVEL";
		public static const UPDATE_IMAGE:String = "UPDATE_IMAGE";
		public static const UPDATE_IMPACT:String = "UPDATE_IMPACT";
		public static const UPDATE_INDICATOR:String = "UPDATE_INDICATOR";
		public static const UPDATE_LIKELIHOOD_LEVEL:String = "UPDATE_LIKELIHOOD_LEVEL";
		public static const UPDATE_LINK_BETWEEN_ASSETS:String = "UPDATE_LINK_BETWEEN_ASSETS";
		public static const UPDATE_OBJECTIVE_RISK:String = "UPDATE_OBJECTIVE_RISK";
		public static const UPDATE_PEOPLE:String = "UPDATE_PEOPLE";
		public static const UPDATE_PARAMETER:String = "UPDATE_PARAMETER";
		public static const UPDATE_PARAMETER_LIST:String = "UPDATE_PARAMETER_LIST";
		public static const UPDATE_REQUIREMENT:String = "UPDATE_REQUIREMENT";
		public static const UPDATE_SECURITY_CRITERIA:String = "UPDATE_SECURITY_CRITERIA";
		public static const UPDATE_SECURITY_MEASURE:String = "UPDATE_SECURITY_MEASURE";
		public static const UPDATE_STAGE:String = "UPDATE_STAGE";
		public static const UPDATE_SUBJECT:String = "UPDATE_SUBJECT";
		public static const UPDATE_THREAT_SOURCE:String = "UPDATE_THREAT_SOURCE";
		public static const UPDATE_RISK:String = "UPDATE_RISK";
		public static const UPDATE_RISK_EVALUATION_ASSOCIATION:String = "UPDATE_RISK_EVALUATION_ASSOCIATION";
		public static const UPDATE_RISK_EVALUATION_COLOR:String = "UPDATE_RISK_EVALUATION_COLOR";

		public static const UPDATE_UNRETAINED_RESIDUAL_RISK:String = "UPDATE_UNRETAINED_RESIDUAL_RISK";

		public static const UPDATE_WORK_STRUCTURE:String = "UPDATE_WORK_STRUCTURE";



		public static const UPDATE_THREAT:String = "UPDATE_THREAT";

		public static const UPDATE_THREAT_SOURCE_TYPE:String = "UPDATE_THREAT_SOURCE_TYPE";
		public static const UPDATE_VULNERABILITY:String = "UPDATE_VULNERABILITY";
		public static const UPDATE_THREAT_SCENARIO:String = "UPDATE_THREAT_SCENARIO";

		public static const RESET_RISK_EVALUATION:String = "RESET_RISK_EVALUATION" ;
		
		
		
		
		

		public function AppController() {
			initializeCommands();
		}
		
		public function initializeCommands():void 
		{
			addCommand(ADD_THREATSOURCE_TO_FEAREDEVENT_EVENT, AddThreatSourceToFearedEventCommand);
			addCommand(ADD_ONE_THREATSOURCE_TO_FEAREDEVENT_EVENT, AddOneImpactToFearedEventCommand);
			addCommand(AFFECT_STAGES_TO_DELIVERABLE, AffectStagesToDeliverableCommand);
			addCommand(AFFECT_PEOPLE_TO_STUDY, AffectPeopleToStudyCommand);
			
			addCommand(CREATE_BLANK_STUDY, CreateBlankStudyCommand);
			addCommand(CREATE_PARAMETER, CreateParameterCommand);
			addCommand(CREATE_PEOPLE, CreatePeopleCommand);
			addCommand(CREATE_SECURITY_CRITERIA, CreateSecurityCriteriaCommand);
			addCommand(CREATE_DELIVERABLE, CreateDeliverableCommand);
			addCommand(CREATE_IMPACT, CreateImpactCommand);
			addCommand(CREATE_INDICATOR, CreateIndicatorCommand);
			addCommand(CREATE_REQUIREMENT, CreateRequirementCommand);
			addCommand(CREATE_THREAT, CreateThreatCommand);
			addCommand(CREATE_THREAT_SOURCE, CreateThreatSourceCommand);
			addCommand(CREATE_THREAT_SOURCE_AND_RETAIN_TYPE, CreateThreatSourceAndRetainTypeCommand);
			addCommand(CREATE_SECURITY_MEASURE, CreateSecurityMeasureCommand);
			addCommand(CREATE_COMPLEMENTARY_SECURITY_MEASURE, CreateComplementarySecurityMeasureCommand);
			addCommand(CREATE_IMPORT_SECURITY_MEASURE, CreateImportSecurityMeasureCommand);
			addCommand(CREATE_VULNERABILITY, CreateVulnerabiltyCommand);

			
			addCommand(DELETE_GRAVITY_LEVEL, DeleteGravityLevelCommand);
			addCommand(DELETE_PARAMETER, DeleteParameterCommand);
			addCommand(DELETE_PEOPLE, DeletePeopleCommand);
			addCommand(DELETE_SECURITY_CRITERIA, DeleteSecurityCriteriaCommand);
			addCommand(DELETE_IMAGE, DeleteImageCommand);
			addCommand(DELETE_IMPACT, DeleteImpactCommand);
			addCommand(DELETE_INDICATOR, DeleteIndicatorCommand);
			addCommand(DELETE_INDICATOR_LEVEL, DeleteIndicatorLevelCommand);
			addCommand(DELETE_LIKELIHOOD_LEVEL, DeleteLikelihoodLevelCommand);
			addCommand(DELETE_REQUIREMENT, DeleteRequirementCommand);
			addCommand(DELETE_THREAT, DeleteThreatCommand);
			addCommand(DELETE_THREAT_SOURCE, DeleteThreatSourceCommand);
			addCommand(DELETE_SECURITY_MEASURE, DeleteSecurityMeasureCommand);
			addCommand(DELETE_SECURITY_NEED, DeleteSecurityNeedCommand);
			addCommand(DELETE_VULNERABILITY, DeleteVulnerabilityCommand);
			
			addCommand(DUPLICATE_THREAT_SCENARIO, DuplicateThreatScnenarioCommand);

			
			addCommand(GET_ACTION, GetActionCommand);
			addCommand(GET_ACTION_BY_KEY, GetActionByKeyCommand);
			addCommand(GET_ACTION_PLAN, GetActionPlanCommand);
			addCommand(GET_AUDIT, GetAuditCommand);
			addCommand(GET_AUDIT_LIGHT, GetAuditLightCommand);
			addCommand(GET_COMPLEMENTARY_SECURITY_MEASURE_BY_ID, GetComplementarySecurityMeasureByIdCommand);
			addCommand(GET_DEFENCE_LINE, GetDefenceLineCommand);
			addCommand(GET_DELIVERABLE, GetDeliverableCommand);
			addCommand(GET_DELIVERABLE_BY_ID, GetDeliverableByIdCommand);
			addCommand(GET_DELIVERABLE_TO_PRODUCT, GetDeliverableToProductCommand);
			addCommand(GET_FEARED_EVENT_BY_ID, GetFearedEventByIdCommand);
			addCommand(GET_FEARED_EVENT_BY_GRAVITY, GetFearedEventByGravityCommand);
			addCommand(GET_FEARED_EVENT_LIGHT, GetFearedEventLightCommand);
			addCommand(GET_FEARED_EVENTS, GetFearedEventsCommand);
			addCommand(GET_GRAVITY_LEVEL, GetGravityLevelCommand);
			addCommand(GET_GRAVITY_LEVEL_LIGHT, GetGravityLevelLightCommand);
			addCommand(GET_IMAGE, GetImageCommand);
			addCommand(GET_IMPACT, GetImpactCommand);
			addCommand(GET_INDICATOR_BY_ID, GetIndicatorByIdCommand);
			addCommand(GET_INDICATOR, GetIndicatorCommand);
			addCommand(GET_INFORMATION, GetInformationCommand);
			addCommand(GET_LINK_BETWEEN_ASSETS, GetLinkBetweenAssetsCommand);			
			addCommand(GET_OBJECTIVE, GetObjectiveCommand);
			addCommand(GET_OBJECTIVE_RISK, GetObjectiveRiskCommand);
			addCommand(GET_PARAMETER, GetParameterCommand);
			addCommand(GET_PARAMETER_BY_ID, GetParameterByIdCommand);
			addCommand(GET_PARAMETER_TYPE, GetParameterTypeCommand);
			addCommand(GET_PEOPLE, GetPeopleCommand);			
			addCommand(GET_PEOPLE_BY_ID, GetPeopleByIdCommand);
			addCommand(GET_PRIMARY_ASSET, GetPrimaryAssetCommand);
			addCommand(GET_PRIMARY_ASSET_LIGHT, GetPrimaryAssetLightCommand);
			addCommand(GET_PRIMARY_ASSETS_XML, GetPrimaryAssetsXMLCommand);
			addCommand(GET_REFERENTIEL, GetReferentielCommand);
			addCommand(GET_REQUIREMENT, GetRequirementCommand);
			addCommand(GET_REQUIREMENT_BY_ID, GetRequirementByIdCommand);
			addCommand(GET_RESIDUAL_RISK, GetResidualRiskCommand);
			addCommand(GET_RESIDUAL_RISK_LIGHT, GetResidualRiskLightCommand);
			addCommand(GET_RISK_RESID, GetRiskResidCommand);
			addCommand(GET_RETAINED_PEOPLE, GetRetainedPeopleCommand);
			addCommand(GET_RETAINED_PEOPLE_LIGHT, GetRetainedPeopleLightCommand);
			addCommand(GET_RISK_CRITERIA, GetActionLightCommand);
			addCommand(GET_RISK_EXPORT, GetRiskExportCommand);
			addCommand(GET_RISK_EVALUATION, GetRiskEvaluationCommand);
			addCommand(GET_RISK_LIGHT, GetRiskLightCommand);
			addCommand(GET_RISK_MAPPING, GetRiskMappingCommand);
			addCommand(GET_RISK_NUMBER, GetRiskNumberCommand);
			addCommand(GET_ROLE, GetRoleCommand);
			addCommand(GET_SECURITY_CRITERIA, GetSecurityCriteriaCommand);
			addCommand(GET_SECURITY_CRITERIA_LIGHT, GetSecurityCriteriaLightCommand);
			addCommand(GET_SECURITY_CRITERIA_BY_ID, GetSecurityCriteriaByIdCommand);
			addCommand(GET_SECURITY_MEASURE, GetSecurityMeasureCommand);
			addCommand(GET_SECURITY_MEASURE_IMPORT, GetSecurityMeasureImportCommand);
			addCommand(GET_SECURITY_MEASURE_STATE_E, GetSecurityMeasureStateECommand);
			addCommand(GET_SECURITY_MEASURE_LIGHT, GetSecurityMeasureLightCommand);
			addCommand(GET_SECURITY_MEASURE_BY_ID, GetSecurityMeasureByIdCommand);
			addCommand(GET_SECURITY_MEASURE_BY_RISK, GetSecurityMeasureByRiskCommand);
			addCommand(GET_SECURITY_MEASURE_BY_RISK_LIGHT, GetSecurityMeasureByRiskLightCommand);
			addCommand(GET_SECURITY_MEASURE_TYPE, GetSecurityMeasureTypeCommand);
			addCommand(GET_SECURITY_NEEDS, GetSecurityNeedsCommand);
			addCommand(GET_STAGES, GetStagesCommand);
			addCommand(GET_STAGES_TREE, GetStagesTreeCommand);
			addCommand(GET_STAGES_BY_DELIVERABLE, GetStagesByDeliverableCommand);
			addCommand(GET_STATUS, GetStatusCommand);
			addCommand(GET_SUBJECT, GetSubjectCommand);
			addCommand(GET_SUPPORT_ASSETS_TYPES, GetSupportAssetsTypesCommand);
			addCommand(GET_SUPPORT_ASSETS_XML, GetSupportAssetsXMLCommand);
			addCommand(GET_SUPPORT_ASSETS_LIGHT, GetSupportAssetsLightCommand);
			addCommand(GET_SUPPORTING_ASSET, GetRetainedSupportingAssetCommand);
			addCommand(GET_THREAT, GetThreatCommand);
			addCommand(GET_THREAT_BY_ID, GetThreatByIdCommand);
			addCommand(GET_THREAT_BY_TBS, GetThreatByTBSCommand);
			addCommand(GET_THREAT_SCENARIO_LIGHT, GetThreatScenarioLightCommand);
			addCommand(GET_THREAT_SOURCE, GetThreatSourceCommand);
			addCommand(GET_THREAT_SOURCE_BY_ID, GetThreatSourceByIdCommand);
			addCommand(GET_THREAT_SOURCE_LIST, GetThreatSourceListCommand);
			addCommand(GET_THREAT_SOURCE_TYPE, GetThreatSourceTypeCommand);
			addCommand(GET_THREAT_SOURCE_TYPE_BY_ID, GetThreatSourceTypeByIdCommand);
			addCommand(GET_THREAT_SOURCE_WITHOUT_TYPE, GetThreatSourceWithoutTypeCommand);
			addCommand(GET_THREAT_TYPE, GetThreatTypeCommand);
			addCommand(GET_VULNERABILITY, GetVulnerabilityCommand);
			addCommand(GET_VULNERABILITY_BY_ID, GetVulnerabilityByIdCommand);
			addCommand(GET_VULNERABILITY_BY_THREAT_TYPE, GetVulnerabilityByThreatTypeCommand);
			addCommand(GET_VULNERABILITY_TYPE, GetVulnerabilityTypeCommand);
			addCommand(GET_IMPACT_TYPE, GetImpactTypeCommand);
			addCommand(GET_LIKELIHOOD_LEVEL, GetLikelihoodLevelCommand);
			addCommand(GET_LIKELIHOOD_LEVEL_LIGHT, GetLikelihoodLevelLightCommand);
			addCommand(GET_THREAT_SCENARIO_BY_ID, GetThreatScenarioByIdCommand);
			addCommand(GET_THREAT_SCENARIO_BY_LIKELIHOOD_LEVEL, GetThreatScenarioByLikelihoodLevelCommand);
			addCommand(GET_THREAT_SCENARIO, GetThreatScenarioCommand);
			addCommand(GET_RISK, GetRiskCommand);
			addCommand(GET_WORK_STRUCTURE, GetWorkStructureCommand);
			addCommand(GET_WORK_STRUCTURE_LIGHT, GetWorkStructureLightCommand);
			addCommand(GET_WORK_STRUCTURE_BY_ACTION_NUMERO, GetWorkStructureByActionNumeroCommand);
			addCommand(GET_RISK_BY_ID, GetRiskByIdCommand);
			addCommand(GENERATE_RISK, GenerateRiskCommand);
			addCommand(GET_OPENXML_FROM_STRING, GetOpenXMLFromStringCommand);	
			
			addCommand(LAUNCH_AUDIT, LaunchAuditCommand);
			
			addCommand(MAP_XML_TO_SQL, MapXMLtoSQLcommand);
			
			addCommand(IS_STUDY_STAGES_DEFINED, IsStudyStagesDefinedCommand);			
			addCommand(SAVE_PRIMARY_ASSETS, SavePrimaryAssetsCommand);
			addCommand(SAVE_SUPPORT_ASSETS, SaveSupportAssetsCommand);
			addCommand(UPDATE_ACTION_REGLE, UpdateActionRegleCommand);
			addCommand(UPDATE_COMPLEMENTARY_SECURITY_MEASURE, UpdateComplementarySecurityMeasureCommand);
			addCommand(UPDATE_DELIVERABLE_LIST, UpdateDeliverableListCommand);
			addCommand(UPDATE_DELIVERABLE, UpdateDeliverableCommand);
			addCommand(UPDATE_FEAREDEVENT, UpdateFearedEventCommand);
			addCommand(UPDATE_GRAVITY_LEVEL, UpdateGravityLevelCommand);
			addCommand(UPDATE_IMAGE, UpdateImageCommand);
			addCommand(UPDATE_IMPACT, UpdateImpactCommand);
			addCommand(UPDATE_LIKELIHOOD_LEVEL, UpdateLikehoodLevelCommand);
			addCommand(UPDATE_LINK_BETWEEN_ASSETS, UpdateLinkBetweenAssetsCommand);
			addCommand(UPDATE_OBJECTIVE_RISK, UpdateObjectiveRiskCommand);
			addCommand(UPDATE_PEOPLE, UpdatePeopleCommand);
			addCommand(UPDATE_PARAMETER, UpdateParameterCommand);
			addCommand(UPDATE_PARAMETER_LIST, UpdateParameterListCommand);
			addCommand(UPDATE_REQUIREMENT, UpdateRequirementCommand);			
			addCommand(UPDATE_RISK,UpdateRiskCommand);
			addCommand(UPDATE_RISK_EVALUATION_ASSOCIATION, UpdateRiskEvaluationAssociationCommand);
			addCommand(UPDATE_RISK_EVALUATION_COLOR, UpdateRiskEvaluationColorCommand);
			addCommand(UPDATE_SECURITY_CRITERIA, UpdateSecurityCriteriaCommand);
			addCommand(UPDATE_SECURITY_MEASURE, UpdateSecurityMeasureCommand);
			addCommand(UPDATE_STAGE, UpdateStageCommand);
			addCommand(UPDATE_SUBJECT, UpdateSubjectCommand);

			
			addCommand(UPDATE_INDICATOR, UpdateIndicatorCommand);
			

			addCommand(UPDATE_THREAT, UpdateThreatCommand);
			addCommand(UPDATE_THREAT_SCENARIO, UpdateThreatScenarioCommand);
			addCommand(UPDATE_THREAT_SOURCE, UpdateThreatSourceCommand);
			addCommand(UPDATE_THREAT_SOURCE_TYPE, UpdateThreatSourceTypeCommand);
			addCommand(UPDATE_UNRETAINED_RESIDUAL_RISK, UpdateUnretainedResidualRiskCommand);
			addCommand(UPDATE_VULNERABILITY, UpdateVulnerabilityCommand);
			addCommand(UPDATE_WORK_STRUCTURE, UpdateWorkstructureCommand);
			
			addCommand(GET_IMPACT_BY_ID, GetImpactByIdCommand);

			addCommand(RESET_RISK_EVALUATION, ResetRiskEvaluationCommand);

		}		
	}
}