package com.anssi.ebios.model
{
	import mx.collections.ArrayCollection;

	[Bindable]
	public class FearedEvent
	{
		public var id:String = "-1";
		
		public var primaryAsset:PrimaryAsset;
		
		public var securityCriteria:SecurityCriteria;
		
		public var securityNeed:SecurityNeed;
		
		public var threatSourceList:ArrayCollection;
		
		public var impactList:ArrayCollection;
		
		public var gravityLevel:GravityLevel;
		
		public var label:String;
		
		public var justification:String;
		
		public function FearedEvent()
		{
		}
		
		public function get threatSourceListToString():String
		{
			var str:String = "";
			for each(var obj:ThreatSource in threatSourceList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}
		public function get impactListToString():String
		{
			var str:String = "";
			for each(var obj:Impact in impactList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}
		public function get primaryAssetToString():String
		{
			return primaryAsset.libelle;
		}
		
		public function get securityCriteriaToString():String
		{
			return securityCriteria.libelle;
		}
		
		public function get securityNeedToString():String
		{
			return securityNeed.label;
		}
		
		public function get gravityLevelToString():String
		{
			return gravityLevel.label;
		}
	}
}