package com.anssi.ebios.model
{
	import mx.charts.AreaChart;
	import mx.collections.ArrayCollection;


	[Bindable]
	public class Risk
	{
		public function Risk()
		{
		}
		
		public var id:String = "-1";
		public var short_label:String;
		public var long_label:String;
		
		public var gross_gravity:GravityLevel;
		public var gross_likelihood:LikelihoodLevel;
		public var gross_justification:String;
		
		public var gravityME:GravityLevel;
		public var likelihoodME:LikelihoodLevel;
		public var justificationME:String;
		
		public var gravityMC:GravityLevel;
		public var likelihoodMC:LikelihoodLevel;
		public var justificatioMC:String;
		
		public var gravityPA:GravityLevel;
		
		public var fearedEvent:FearedEvent;
		
		public var threatScenarioList:ArrayCollection;
		public var supportingAssetList:ArrayCollection;

		public var objective:Objective;
		public var objectiveComment:String;
		
		public var securityMeasureList:ArrayCollection;
		public var securityCriteria:SecurityCriteria;
		//Attribut utilisé dans l'écran 4.2.2
		public var isResidualRiskSelected:Boolean;
		
		//attribut utilisé dans l'écran 5.1.1
		public var residualRiskLibelle:String;
		
		public var primaryAssetForDelivrable:PrimaryAsset;
		
		public function get fearedEventToString():String
		{
			return fearedEvent.label;
		}
		
		public function get securityCriterialibelle():String{
			return securityCriteria.libelle;
		}
		public function get primaryAssetLibelle():String
		{
			return primaryAssetForDelivrable.libelle;
		}
		public function get threatScenarioListToString():String
		{
			var str:String = "";
			for each(var obj:ThreatScenario in threatScenarioList)
			{
				str +=obj.label+ " \n";
			}
			return str;
		}
		
		public function get supportingAssetListToString():String
		{
			var str:String = "";
			for each(var obj:SupportingAsset in supportingAssetList){
				str += obj.label + "\n";
			}
			return str;
		}
		public function get gross_gravityToString():String
		{
			return gross_gravity.label;
		}
		public function get gross_likelihoodToString():String
		{
			return gross_likelihood.label;
		}
		public function get gravityMEToString():String
		{
			return gravityME.label;
		}
		
		public function get likelihoodMEToString():String
		{
			return likelihoodME.label;
		}
		public function get gravityMCToString():String
		{
			return gravityMC.label;
		}
		
		public function get likelihoodMCToString():String
		{
			return likelihoodMC.label;
		}
		
		public function get retainedResidualRisk():Boolean
		{
			if (Number(gravityME.order) != 0 && Number(likelihoodME.order) != 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		
		public function get objectiveToString():String
		{
			return objective.label;
		}
		
		/*public function get securityMeasureList():ArrayCollection
		{
			
		}*/
		
		public function get securityMeasureListForDelivrableToString():String
		{
			var str:String = "";
			for each(var obj:SecurityMeasure in securityMeasureList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}
		
	}	
}