package com.anssi.ebios.model
{
	import mx.collections.ArrayCollection;

	[Bindable]
	public class SecurityMeasure
	{
		
		public var id:String = "-1";
		public var label:String;
		public var state:String;
		public var securityMeasureType:SecurityMeasureType;
		public var supportingAssetList:ArrayCollection;
		public var defenceLineList:ArrayCollection;
		public var riskList:ArrayCollection;	
		public var manager:People;
		public var indicatorList:ArrayCollection;
		
		public function SecurityMeasure()
		{
		}
		
		public function get securityMeasureTypeToString():String{
			return securityMeasureType.label;
		}
		
		public function get indicatorListToString():String{
			var str:String = "";
			for each(var obj:Indicator in indicatorList)
			{
				str += obj.libelle+ " \n";
			}
			return str;
		}
		
		public function get indicatorLevelListToString():String{
			var str:String = "";
			for each(var obj:Indicator in indicatorList)
			{
				str += obj.indicatorLevelForSecurityMeasureToStirng+ " \n";
			}
			return str;
		}
		
		public function get supportingAssetListToString():String{
			var str:String = "";
			for each(var obj:SupportingAsset in supportingAssetList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}

		
		public function get riskListToString():String{
			var str:String = "";
			for each(var obj:Risk in riskList){
				str += obj.short_label + " \n";
			}
			return str;
		}
		public function get managerToString():String{
			var str:String= " ";
			if(this.manager.id != null)
			return this.manager.fullName;
			return 	str;
		}

		
		public function get fullPropertyToString():String
		{
			return label;
		}

		public function get fullPropertyBisToString():String
		{
			return label+securityMeasureTypeToString+supportingAssetListToString+managerToString+indicatorLevelListToString;
		}
		
	}
}