package com.anssi.ebios.model
{
	import com.anssi.ebios.model.Requirement;
	
	import mx.collections.ArrayCollection;
	import mx.resources.ResourceManager;

	[Bindable]
	public class Threat
	{
		
		public var id:String = "-1";
		public var label:String;
		public var threatType:ThreatType;
		public var vulnerabilityList:ArrayCollection;
		public var requirementList:ArrayCollection;
		public var likelihoodLevel:LikelihoodLevel;
		public var justification:String;
		
		public function Threat()
		{
		}
		
		public function get threatTypeToString():String{
			return threatType.label;
		}
		
		public function get examplesToString():String{
			return threatType.examples;
		}
		
		public function get vulnerabilityListToString():String{
			var str:String = "";
			for each(var obj:Vulnerability in vulnerabilityList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}

		
		public function get requirementListToString():String{
			var str:String = "";
			for each(var obj:Requirement in requirementList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}
		
		public function get justificationToString():String{
			var str:String;
			
			if (justification != null && justification != ""){
				return justification;
			}else{
				return ResourceManager.getInstance().getString("resources", "threatScenario.form.threat.textArea.Justification");
			}
		}
	}
}