package com.anssi.ebios.model
{
	import com.logica.fwk.utils.ArrayCollectionTool;
	
	import mx.collections.ArrayCollection;
	import mx.resources.ResourceManager;
	
	[Bindable]
	public class ThreatScenario
	{
		public var label:String;
		public var id:String = "-1";
		
		public var threatSourceList:ArrayCollection;
		public var threatList:ArrayCollection;
		public var requirementList:ArrayCollection;
		public var vulnerabilityList:ArrayCollection;
		
		public var likelihoodLevel:LikelihoodLevel;
		public var securityCriteria:SecurityCriteria;
		public var securityMeasureList:ArrayCollection;
		
		public var supportingAsset:SupportingAsset;
		
		public var justification:String;
		public var commonThreatSource:String;
		
		public function ThreatScenario()
		{
		}
		
		
		public function get securityMeasureListToString():String
		{
			var str:String = "";
			for each(var obj:SecurityMeasure in securityMeasureList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}
		public function get threatSourceListToString():String
		{
			var str:String = "";
			for each(var obj:ThreatSource in threatSourceList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}
		public function get threatListToString():String
		{
			var str:String = "";
			for each(var obj:Threat in threatList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}
		
		public function get requirementListToString():String
		{
			var str:String = "";
			for each(var obj:Requirement in requirementList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}
		
		public function get vulnerabilityListListToString():String
		{
			var str:String = "";
			for each(var obj:Vulnerability in vulnerabilityList)
			{
				str += obj.label+ " \n";
			}
			return str;
		}
		
		public function get likelihoodLevelToString():String
		{
			return likelihoodLevel.label;
		}
		
		public function get securityCriteriaToString():String
		{
			return securityCriteria.libelle;
		}
		
		public function get supportingAssetToString():String
		{
			return supportingAsset.label;
		}
		
		public function get supportingAssetWithTypeToString():String
		{
			return supportingAsset.type.title + " - " + supportingAsset.label;
		}

		// sources de menace communes avec un événement redouté
		public function set commonThreatSourceWithFearedEvent(erThreatSourceList:ArrayCollection):void{
			var tooltip:String="";
			var threatSourceCommun:String ="";
			if(erThreatSourceList != null && this.threatSourceList != null){
				for each ( var erThreatSource:ThreatSource in erThreatSourceList){
					if(ArrayCollectionTool.findIndexForId(this.threatSourceList,erThreatSource.id) != -1){
						threatSourceCommun += "- "+erThreatSource.label+"\n";
					}
				}
				if(threatSourceCommun.length >0){
					tooltip += ResourceManager.getInstance().getString("resources","risk.form..commonThreatSource.tooltip")+"\n"; 
					tooltip += threatSourceCommun;
				}
				
			}
			this.commonThreatSource = tooltip;
		}
	}
}