package com.anssi.ebios.services
{
	import com.anssi.ebios.model.ActionPlan;
	import com.anssi.ebios.model.Indicator;
	import com.anssi.ebios.model.IndicatorLevel;
	import com.anssi.ebios.model.People;
	import com.anssi.ebios.model.Risk;
	import com.anssi.ebios.model.SecurityMeasure;
	import com.anssi.ebios.model.SupportingAsset;
	import com.logica.fwk.utils.ArrayCollectionTool;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.ioc.factory.xml.parser.support.nodeparsers.NullNodeParser;
	
	public class ActionPlanService extends AppServices
	{
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		private var _actionPlan:ActionPlan;
		private var _securityMeasure:SecurityMeasure;
		private var _etatC:String="C";
		private var _etatE:String="E";
		private var _primaryKey:Number;
		public function ActionPlanService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		public function getActionPlan():void{
			getComplementarySecurityMeausure();
		}
		
		public function getComplementarySecurityMeausure():void{
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;

			var query:String = constructComplementarySecurityMesureQuery('WHERE MESURE.etat = \"'+_etatC+'\" OR MESURE.etat = \"'+_etatE+'\"');
			//var query:String = constructComplementarySecurityMesureQuery();
			trace("query: "+query);
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getComplementarySecurityMeasureResult);
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		private function getComplementarySecurityMeasureResult(event:SQLEvent):void{
			var result:SQLResult = SQLStatement(event.target).getResult();
			var actionplan:ActionPlan = new ActionPlan();
			actionplan.securityMeasureList = new ArrayCollection();
			if (result != null && result.data != null)
			{
				actionplan.securityMeasureList =  constructComplementarySecurityMesureList(result);
			
			}
			_sqlStatement.sqlConnection.close();
	
			responder.result(actionplan);
		}
		public function getComplementarySecurityMeasureById(id:Number):void{
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			// var query:String = constructComplementarySecurityMesureQuery('WHERE MESURE.etat = \"'+_etatC+'\"'+' AND MESURE.idMESURE = '+id);
			var query:String = constructComplementarySecurityMesureQuery('WHERE MESURE.idMESURE = '+id);
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getComplementarySecurityMeasureByIdResult);
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		private function getComplementarySecurityMeasureByIdResult(event:SQLEvent):void{
			var result:SQLResult = SQLStatement(event.target).getResult();
			var securityMeasure:SecurityMeasure = new SecurityMeasure();
			
			if (result != null && result.data != null)
			{
				securityMeasure =  constructComplementarySecurityMesureList(result).getItemAt(0) as SecurityMeasure ;
				
			}
			_sqlStatement.sqlConnection.close();
			
			responder.result(securityMeasure);
		}
		
		public function updateComplementarySecurityMeasure(securityMeasure:SecurityMeasure):void{
			
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String="UPDATE MESURE  SET idPERSONNE = :idPERSONNE, dateModification = :dateModification " +
				" WHERE idMESURE = :idMESURE";
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":idPERSONNE"] =securityMeasure.manager.id;
			_sqlStatement.parameters[":idMESURE"] = securityMeasure.id;
			_sqlStatement.parameters[":dateModification"] = new Date();
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,updateComplementarySecurityMeasureResult);
			
			_securityMeasure = securityMeasure;
			
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		private function updateComplementarySecurityMeasureResult(event:SQLEvent):void{
			var result:SQLResult = SQLStatement(event.target).getResult();
			// je récupere l'id de la mesure de securité que l'on a updaté
			_primaryKey = SQLStatement(event.target).parameters[":idMESURE"];
			
			_sqlStatement.sqlConnection.close();
			responder.result(_primaryKey);
			// on va mettre à jour la table SUIVRE
			updateIndicatorLevelSelected();
		}
		
		/**
		 * Mise à jour de la table SUIVRE:
		 * On supprime dans un premier temps toutes liaisons avec l'id de notre Mesure de sécurité
		 * puis on insert les nouvelles données.
		 * 
		 * */
		private function updateIndicatorLevelSelected():void{
			setBDDName();
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			openInSyncMode(_sqlStatement);
			
			
			var query:String=" DELETE FROM SUIVRE WHERE idMESURE= :idMESURE";
			_sqlStatement.text=query;
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":idMESURE"] = _primaryKey;
			execStatement(_sqlStatement);
			
			for(var i:int=0; i < _securityMeasure.indicatorList.length; i++){
				var indicateur:Indicator = _securityMeasure.indicatorList.getItemAt(i) as Indicator;
				if(indicateur.indicatorLevelForSecurityMeasure.id != null){
					query="INSERT INTO SUIVRE (idMESURE, idINDICATEUR, idNINDICATEUR, dateCreation, dateModification) " +
						" VALUES (:idMESURE, :idINDICATEUR, :idNINDICATEUR, :dateCreation, :dateModification) ";
					_sqlStatement.parameters[":idINDICATEUR"] = indicateur.id;
					_sqlStatement.parameters[":idNINDICATEUR"] = indicateur.indicatorLevelForSecurityMeasure.id;
					_sqlStatement.parameters[":dateCreation"] =  new Date();
					_sqlStatement.parameters[":dateModification"] = new Date();
					_sqlStatement.text=query;
					execStatement(_sqlStatement);
				}
				
			}
			
			_sqlStatement.sqlConnection.close();
			
			
			
			
		}
		
		public function constructComplementarySecurityMesureQuery(WHERECondition:String = " "):String{
			var str:String="SELECT MESURE.idMESURE as idMESURE, MESURE.libelle as mesure_libelle, MESURE.etat," +
				" BS.idBS as idBS, BS.libelle as bs_libelle, " +
				" PERSONNE.idPERSONNE , PERSONNE.nom, PERSONNE.prenom, " +
				" RISQUE.idRISQUE, RISQUE.libelleCourt, INDICATEUR.idINDICATEUR," +
				" INDICATEUR.libelle as indicateur_libelle," +
				" NINDICATEUR.idNINDICATEUR, NINDICATEUR.libelle as nindicateur_libelle " +
				" FROM MESURE " +
				" LEFT OUTER JOIN PERSONNE ON MESURE.idPERSONNE = PERSONNE.idPERSONNE" +
				" LEFT OUTER JOIN PORTER ON PORTER.idMESURE = MESURE.idMESURE " +
				" LEFT OUTER JOIN BS ON BS.idBS = PORTER.idBS  " +
				" LEFT OUTER JOIN SM ON BS.idBS = SM.idBS " +
				" LEFT OUTER JOIN COMPOSER ON COMPOSER.idSM = SM.idSM " +
				" LEFT OUTER JOIN RISQUE ON RISQUE.idRISQUE = COMPOSER.idRISQUE " +
				" LEFT OUTER JOIN SUIVRE ON SUIVRE.idMESURE = MESURE.idMESURE " +
				" LEFT OUTER JOIN INDICATEUR ON SUIVRE.idINDICATEUR = INDICATEUR.idINDICATEUR " +
				" LEFT OUTER JOIN NINDICATEUR ON SUIVRE.idNINDICATEUR = NINDICATEUR.idNINDICATEUR " +
				WHERECondition +
				" ORDER BY 1,INDICATEUR.idINDICATEUR";
			return str;
		}
		
		// affichage que des mesures à référentiel ETUDE
		
		public function constructComplementarySecurityMeasureForDelivrable():String{
			var str:String="SELECT MESURE.idMESURE as idMESURE, MESURE.libelle as mesure_libelle, MESURE.etat," +
				" BS.idBS as idBS, BS.libelle as bs_libelle, " +
				" PERSONNE.idPERSONNE , PERSONNE.nom, PERSONNE.prenom, " +
				" RISQUE.idRISQUE, RISQUE.libelleCourt, INDICATEUR.idINDICATEUR," +
				" INDICATEUR.libelle as indicateur_libelle," +
				" NINDICATEUR.idNINDICATEUR, NINDICATEUR.libelle as nindicateur_libelle " +
				" FROM MESURE, TMESURES " +
				" LEFT OUTER JOIN PERSONNE ON MESURE.idPERSONNE = PERSONNE.idPERSONNE" +
				" LEFT OUTER JOIN PORTER ON PORTER.idMESURE = MESURE.idMESURE " +
				" LEFT OUTER JOIN BS ON BS.idBS = PORTER.idBS  " +
				" LEFT OUTER JOIN SM ON BS.idBS = SM.idBS " +
				" LEFT OUTER JOIN COMPOSER ON COMPOSER.idSM = SM.idSM " +
				" LEFT OUTER JOIN RISQUE ON RISQUE.idRISQUE = COMPOSER.idRISQUE " +
				" LEFT OUTER JOIN SUIVRE ON SUIVRE.idMESURE = MESURE.idMESURE " +
				" LEFT OUTER JOIN INDICATEUR ON SUIVRE.idINDICATEUR = INDICATEUR.idINDICATEUR " +
				" LEFT OUTER JOIN NINDICATEUR ON SUIVRE.idNINDICATEUR = NINDICATEUR.idNINDICATEUR " +
				" WHERE MESURE.idTMESURES = TMESURES.idTMESURES " +
				" AND TMESURES.idREFERENTIEL = 1 " +
				" ORDER BY 1,INDICATEUR.idINDICATEUR";
			return str;
			
		}
		public function constructComplementarySecurityMesureList(result:SQLResult):ArrayCollection{
			var cpSecurityMeasureList:ArrayCollection = new ArrayCollection();
			
			if (result.data){
			
				var row:Object;
				var numRows:int = result.data.length;		
				var cpSecurityMeasure:SecurityMeasure;
				
				var tmpIdMesure:Number;
				var tmpIdIndicateur:Number;
				var tmpIdRisque:Number;
				var tmpIdBS:Number;
				
				for(var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					if(tmpIdMesure != row["idMESURE"])
					{
						tmpIdMesure = row["idMESURE"];
						
						cpSecurityMeasure = new SecurityMeasure();
						cpSecurityMeasure.id = row["idMESURE"];
						cpSecurityMeasure.label = row["mesure_libelle"];
						cpSecurityMeasure.state = row["etat"];
						
						cpSecurityMeasure.manager = new People();
						cpSecurityMeasure.manager.id = row["idPERSONNE"];
						cpSecurityMeasure.manager.first_name = row["nom"];
						cpSecurityMeasure.manager.last_name =  row["prenom"];
						
						cpSecurityMeasure.indicatorList = new ArrayCollection();
						cpSecurityMeasure.riskList = new ArrayCollection();
						cpSecurityMeasure.supportingAssetList = new ArrayCollection();	
						
						cpSecurityMeasureList.addItem(cpSecurityMeasure);
					}
					tmpIdBS = -1;
					tmpIdRisque = -1;
					tmpIdIndicateur = -1;
					if (tmpIdBS != row["idBS"] && ArrayCollectionTool.findIndexForId(cpSecurityMeasure.supportingAssetList, row["idBS"])==-1 && row["idBS"]>0){
						tmpIdBS = row["idBS"];
						
						var supportingAsset:SupportingAsset = new SupportingAsset();
						supportingAsset.id = row["idBS"];
						supportingAsset.label = row["bs_libelle"];
						cpSecurityMeasure.supportingAssetList.addItem(supportingAsset);
					}
					if(tmpIdRisque != row["idRISQUE"] && ArrayCollectionTool.findIndexForId(cpSecurityMeasure.riskList, row["idRISQUE"])==-1 && row["idRISQUE"]>0){
						tmpIdRisque = row["idRISQUE"];
						
						var risk:Risk= new Risk();
						risk.id = row["idRISQUE"];
						risk.short_label = row["libelleCourt"];
						cpSecurityMeasure.riskList.addItem(risk);
					}
					if(tmpIdIndicateur != row["idINDICATEUR"] && ArrayCollectionTool.findIndexForId(cpSecurityMeasure.indicatorList, row["idINDICATEUR"])==-1 && row["idINDICATEUR"]>0){
						tmpIdIndicateur = row["idINDICATEUR"];
						
						var indicateur:Indicator= new Indicator();
						indicateur.id = row["idINDICATEUR"];
						indicateur.libelle= row["indicateur_libelle"];
						var nindicateur:IndicatorLevel = new IndicatorLevel();
						nindicateur.id = row["idNINDICATEUR"];
						nindicateur.label = row["nindicateur_libelle"];
						indicateur.indicatorLevelForSecurityMeasure = nindicateur;
						cpSecurityMeasure.indicatorList.addItem(indicateur);
					}
				}
			}
			return cpSecurityMeasureList;
		}
	}
}