package com.anssi.ebios.services
{
	
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.utils.Properties;
	import com.anssi.ebios.utils.Resources;
	import com.anssi.ebios.utils.sql.AppSQLConnection;
	import com.anssi.ebios.utils.sql.AppSQLConnectionManager;
	
	import flash.data.SQLMode;
	import flash.data.SQLStatement;
	import flash.errors.SQLError;
	import flash.events.SQLEvent;
	import flash.filesystem.File;
	import flash.errors.SQLError;
	
	public class AppServices
	{
		
		[Bindable]
		[Embed(source="config/config.properties",mimeType ="application/octet-stream")]
		private var config:Class;
		protected var configs:Properties = null;
		
		public static const MODE_SYNCHRONOUS:String 	= "MODE_SYNCHRONOUS";
		public static const MODE_ASYNCHRONOUS:String 	= "MODE_ASYNCHRONOUS";
		
		
		private var _appSQLConnectionManager:AppSQLConnectionManager;
		private var _automaticallyOpenSQLConnection:Boolean = true;
		private var _async:Boolean = false;
		
		public function set appSQLConnectionManager(value:AppSQLConnectionManager):void{
			this._appSQLConnectionManager = value;
		}
		public function get appSQLConnectionManager():AppSQLConnectionManager{
			return this._appSQLConnectionManager;
		}
		public function get sqlConnection():AppSQLConnection{
			return appSQLConnectionManager.getAppSQLConnection(this._automaticallyOpenSQLConnection, this._async);
		}
		
		public function set mode(m:String):void{
			if(m == AppServices.MODE_SYNCHRONOUS){
				this._async = false;
				this._automaticallyOpenSQLConnection = true;
			}
			else if(m == AppServices.MODE_ASYNCHRONOUS){
				this._async = true;
				this._automaticallyOpenSQLConnection = false;
			}
		}
		
		
		public function AppServices()
		{
			// on pointe vers le fichier de config
			configs = Properties.getEmbeddedBundle(config);
		}
		
		protected function setBDDName(bddName:String = null):void{
			if(bddName == null) this.appSQLConnectionManager.name = AppModelLocator.getInstance().currentStudyDbName;
			else  this.appSQLConnectionManager.name = bddName;
		}
		
		
		
		/*******************************/
		/***** MODE ASYNCHRONE *********/
		/*******************************/
		// OUVRE ET EXECUTE
		public function openAndExecStatementInAsyncMode(statement:SQLStatement):void{
			
			// LISTEN THE CONNECTION OPENING
			statement.sqlConnection.addEventListener(SQLEvent.OPEN, function exec(event:SQLEvent):void{
				// QUERY EXECUTION
				statement.execute();
			});
			//trace('BDD:'+File.applicationStorageDirectory.nativePath+Resources.getInstance().getDirectorySeparator()+configs.getValue("app.storage.studies.directory")+Resources.getInstance().getDirectorySeparator()+this.appSQLConnectionManager.name);
			//trace('BDD:'+this.appSQLConnectionManager.name);
			// OPEN CONNECTION
			//statement.sqlConnection.openAsync(new File(File.applicationStorageDirectory.nativePath+Resources.getInstance().getDirectorySeparator()+configs.getValue("app.storage.studies.directory")+Resources.getInstance().getDirectorySeparator()+this.appSQLConnectionManager.name), SQLMode.UPDATE);
			statement.sqlConnection.openAsync(new File(this.appSQLConnectionManager.name), SQLMode.UPDATE);
		}
		
		
		
		/*******************************/
		/***** MODE SYNCHRONE ***********/
		/*******************************/
		// OUVRE
		public function openInSyncMode(statement:SQLStatement):void{
			try {
				//trace('BDD:'+this.appSQLConnectionManager.name);
				statement.sqlConnection.open(new File(this.appSQLConnectionManager.name), SQLMode.UPDATE);
			} catch (error:SQLError) {
				trace("Error message:", error.message);
				trace("Details:", error.details);
			}
		}
		
		// EXECUTE
		public function execStatement(statement:SQLStatement):void{
			try {
				statement.execute();
			} catch (error:SQLError) {
				trace("Error message:", error.message);
				trace("Details:", error.details);
			}
		}
		
		/*
		public function openConnection(statement:SQLStatement):void{		
			trace('BDD:'+File.applicationStorageDirectory.nativePath+Resources.getInstance().getDirectorySeparator()+configs.getValue("app.storage.studies.directory")+Resources.getInstance().getDirectorySeparator()+this.appSQLConnectionManager.name);
			// OPEN CONNECTION
			//statement.sqlConnection.openAsync(new File(File.applicationStorageDirectory.nativePath+Resources.getInstance().getDirectorySeparator()+configs.getValue("app.storage.studies.directory")+Resources.getInstance().getDirectorySeparator()+this.appSQLConnectionManager.name), SQLMode.UPDATE);
			statement.sqlConnection.openAsync(new File(this.appSQLConnectionManager.name), SQLMode.UPDATE);
		}
		*/
		
	}
}