package com.anssi.ebios.services
{
	import com.anssi.ebios.model.AnomalyLight;
	import com.anssi.ebios.model.Audit;
	import com.anssi.ebios.model.FearedEvent;
	import com.anssi.ebios.model.GravityLevel;
	import com.anssi.ebios.model.Impact;
	import com.anssi.ebios.view.fearedevent.FeardEventExport;
	
	import mx.resources.ResourceManager;
	
	import org.as3commons.bytecode.abc.Integer;

	public class AuditService extends AppServices
	{
		import com.anssi.ebios.model.Anomaly;
		
		import flash.data.SQLResult;
		import flash.data.SQLStatement;
		import flash.events.SQLErrorEvent;
		import flash.events.SQLEvent;
		import mx.collections.ArrayCollection;
		import mx.rpc.IResponder;
		
		private var _responder:IResponder;
		private var _sqlStatement:SQLStatement;
		private var _anomalyList:ArrayCollection;
		private var _currentIndex:Number=-1;
		private var _auditList:ArrayCollection;
		private var _auditLightList:ArrayCollection;
		private var _criticite:String;
		
		public function AuditService(responder:IResponder)
		{
			_responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		/**********************************************************/
		/** 		Récuperation de la liste des anomalies    	 **/
		/**********************************************************/
		public function getAudit():void{
			
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			
			var query:String = "SELECT * " +
				" FROM ANOMALIE " +
				" ORDER BY criticite, numero ";
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getAuditResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function getAuditResult(event:SQLEvent):void{
			_auditList= new ArrayCollection();
			var result:SQLResult = SQLStatement(event.target).getResult();
			var numero:Number = -1;
			var row:Object;
			var numRows:int;
			var tempAudit:Audit;
			var tempAnomaly:Anomaly;
			var criticite:Number;
			
			// si nous avons des résultats
			if (result != null && result.data != null){
				numRows = result.data.length;
				for(var i:int=0;i < numRows; i++){
					row=result.data[i];
					if(criticite !=  row["criticite"])
					{
						criticite = row["criticite"];
						tempAudit= new Audit();
						tempAudit.id=row["criticite"];
						if(row["criticite"] == 1){
							tempAudit.criticite = ResourceManager.getInstance().getString('resources', 'audit.anomalyvariety.major');
						}else if(row["criticite"] == 2){
							tempAudit.criticite = ResourceManager.getInstance().getString('resources', 'audit.anomalyvariety.minor');
						}
						tempAudit.anomalyList = new ArrayCollection();
						_auditList.addItem(tempAudit);
					}
					if(row["idANOMALIE"] > 0){
						tempAnomaly = new Anomaly();
						tempAnomaly.id=row["idANOMALIE"];
						tempAnomaly.criticite=row["criticite"];
						tempAnomaly.numero=row["numero"];
						tempAnomaly.label=row["libelle"];
						tempAnomaly.etape=row["etape"];
						tempAnomaly.controle=row["controle"];
						
						tempAudit.anomalyList.addItem(tempAnomaly);
					}
				}
			
			}
			_sqlStatement.sqlConnection.close();
			_responder.result(_auditList);
		}
		
		/**********************************************************/
		/** 		Export de la liste des anomalies    	 **/
		/**********************************************************/
		public function getAnomaly():void{
			
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			
			var query:String = "SELECT * " +
				" FROM ANOMALIE " +
				" ORDER BY etape ";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getAnomalyResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function getAnomalyResult(event:SQLEvent):void{
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			var AnomalyList:ArrayCollection = new ArrayCollection();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var anomalyLight:AnomalyLight;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					if(row["idANOMALIE"]>0){
						
						anomalyLight = new AnomalyLight();
						anomalyLight.criticite = row["criticite"];
						anomalyLight.label = row["libelle"];
						anomalyLight.etape = row["etape"];
						
						AnomalyList.addItem(anomalyLight);
					}
				}
			}
			_sqlStatement.sqlConnection.close();
			_responder.result(AnomalyList);
		}
		
		/**********************************************************/
		/** 		Insertion dans la table Anomalie		   	 **/
		/**********************************************************/
		private function insertAnomaly():void{
			
			_currentIndex++
			if (_currentIndex < _anomalyList.length){
				var anomaly:Anomaly = _anomalyList.getItemAt(_currentIndex) as Anomaly;
				
				setBDDName();				
				_sqlStatement = new SQLStatement();				
				_sqlStatement.sqlConnection = this.sqlConnection;
				var query:String = "INSERT INTO ANOMALIE (numero, criticite, libelle, etape, controle, dateCreation) " +
					" VALUES (:numero, :criticite, :libelle, :etape, :controle, :dateCreation)";
				_sqlStatement.clearParameters();
				_sqlStatement.parameters[":numero"] = anomaly.numero;
				_sqlStatement.parameters[":criticite"] = anomaly.criticite;
				_sqlStatement.parameters[":libelle"] = anomaly.label;
				_sqlStatement.parameters[":etape"] = anomaly.etape;
				_sqlStatement.parameters[":controle"] = anomaly.controle;
				_sqlStatement.parameters[":dateCreation"] = new Date();
				_sqlStatement.text = query;
				_sqlStatement.addEventListener(SQLEvent.RESULT,insertAnomalyResult);
				
				openAndExecStatementInAsyncMode(_sqlStatement);	
			}else{
				_sqlStatement.sqlConnection.close();
				_responder.result(null);
			}
		}
		
		private function insertAnomalyResult(event:SQLEvent):void{
			insertAnomaly();
		}
		
		/**********************************************************/
		/** 				Fonctions de  controle			   	 **/
		/**********************************************************/
		private function formatAnomalyList(result:SQLResult,controle:String, label:String, etape:String):void{
			
			var tempAnomaly:Anomaly;
			var row:Object;
			var numRows:int;		
			//s'il y a quelque chose dans result on parcours le résultat et on ajoute dans la liste _anomalyList
			
			if (result != null && result.data != null){
				numRows = result.data.length;
				var id:int=_anomalyList.length+1;
				for(var i:int = 0; i< numRows; i++){
					row=result.data[i];
					tempAnomaly=new Anomaly();
					tempAnomaly.id=id+"";
					tempAnomaly.criticite=_criticite;
					tempAnomaly.numero=id+"";
					
					tempAnomaly.label=label+" "+row["label"];
					tempAnomaly.etape=etape;
					
					tempAnomaly.controle=controle;
					_anomalyList.addItem(tempAnomaly);
					id++;
				}	
			}
		
		}
		private function formatAnomalyControl6List(result:SQLResult,controle:String, label:String, etape:String):void{
			var tempAnomaly:Anomaly;
			var tempImpact:Impact;
			var tempER:FearedEvent;
			var impactList:ArrayCollection= new ArrayCollection();
			var row:Object;
			var numRows:int;	
			var idImpact:Number;
			
			//s'il y a quelque chose dans result on parcours le résultat et on crée une liste d'impact pour pouvoir comparer les niveaux de gravité des ER
			
			if (result != null && result.data != null){
				numRows = result.data.length;
				for(var i:int=0;i < numRows; i++){
					row=result.data[i];
					if(idImpact !=  row["idIMPACT"])
					{
						idImpact = row["idIMPACT"];
						tempImpact = new Impact();
						tempImpact.id=row["idIMPACT"];
						tempImpact.fearedEventListForAudit = new ArrayCollection();
						impactList.addItem(tempImpact);
					}
					if(row["ider"] > 0){
						tempER =  new FearedEvent();
						tempER.id=row["ider"];
						tempER.label=row["label"];
						tempER.gravityLevel= new GravityLevel();
						tempER.gravityLevel.id	=row["idngrisque"];
						tempImpact.fearedEventListForAudit.addItem(tempER);
					}		
				}	
			}
			var libelle:String;
			var id:int=_anomalyList.length+1;
			// si la liste d'impact n'est pas vide, on va la parcourir et comparer les niveaux de gravité 
			//s'il y en a  1 différent on ajoute dans la liste anomalyList
			if(impactList.length > 0){
				for each(var objImpact:Impact in impactList){
					if(objImpact.fearedEventListForAudit.length>2){
						var u:int =1;
						var found:Boolean=false;
						var firstObjFearedEvent:FearedEvent = objImpact.fearedEventListForAudit.getItemAt(0) as FearedEvent;
						var objFearedEvent:FearedEvent;
						while( u<objImpact.fearedEventListForAudit.length  && !found){
							objFearedEvent = objImpact.fearedEventListForAudit.getItemAt(u) as FearedEvent;
							if(firstObjFearedEvent.gravityLevel.id != objFearedEvent.gravityLevel.id){
								found=true;
								libelle=objImpact.fearedEventListForAuditToString;
								// on ajoute dans la iste _anomalyList
								
								tempAnomaly=new Anomaly();
								tempAnomaly.id=id+"";
								tempAnomaly.criticite=_criticite;
								tempAnomaly.numero=id+"";
								
								tempAnomaly.label=label+" "+libelle;
								tempAnomaly.etape=etape;
								
								tempAnomaly.controle=controle;
								_anomalyList.addItem(tempAnomaly);
								id++;
								break;
							}
							u++;
						}
					}
				}
			}
							
		}
		private function formatAnomalyControl7List(result:SQLResult,controle:String, label:String, etape:String):void{
			var tempAnomaly:Anomaly;
			var row:Object;
			var numRows:int;		
			//s'il y a quelque chose dans result on parcours le résultat et on ajoute dans la liste _anomalyList
			
			if (result != null && result.data != null){
				numRows = result.data.length;
				var id:int=_anomalyList.length+1;
				for(var i:int = 0; i< numRows; i++){
					row=result.data[i];
					tempAnomaly=new Anomaly();
					tempAnomaly.id=id+"";
					tempAnomaly.criticite=_criticite;
					tempAnomaly.numero=id+"";
					
					tempAnomaly.label=label+" "+row["erLabel"]+ " & "+ row["smLabel"];
					tempAnomaly.etape=etape;
					
					tempAnomaly.controle=controle;
					_anomalyList.addItem(tempAnomaly);
					id++;
				}	
			}
			
		}
		public function launchAudit():void{
			// on doit vider la table anomalie avant de lancer le controle1
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			openInSyncMode(_sqlStatement);
			
			var query:String = "DELETE FROM ANOMALIE ";
			_sqlStatement.text = query;
				
			execStatement(_sqlStatement);
			_sqlStatement.sqlConnection.close();
			
			controlOfRiskNotNulWithoutMeasure();
		}
		
		/**********************************************************/
		/** 				Anomalies majeures 				   	 **/
		/**********************************************************/
	
		/*
		 * Controle 1: détection de risque non nul (gravite <> "non retenu" et vraisemblance <> "non retenu") sans mesure
		 * controlRiskNotNulWithoutMeasure
		 **/
		private function controlOfRiskNotNulWithoutMeasure():void{
			_criticite="1";
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			openInSyncMode(_sqlStatement);
			var query:String="SELECT RISQUE.idRISQUE as idRISQUE, libelleCourt as label " +
				" FROM RISQUE, COMPOSER, SM " +
				" WHERE ( graviteBrute not null" +
				" OR graviteME not null " +
				" OR  graviteMC not null " +
				" OR graviteBrute > 1 " +
				" OR  graviteME > 1 " +
				" OR graviteMC > 1) " +
				" AND ( vraisemblanceBrute not null " +
				" OR vraisemblanceME not null " +
				" OR vraisemblanceMC not null " +
				" OR vraisemblanceBrute > 1 " +
				" OR vraisemblanceME > 1 " +
				" OR  vraisemblanceMC > 1) " +
				" AND RISQUE.idRISQUE = COMPOSER.idRISQUE " +
				" AND COMPOSER.idSM = SM.idSM " +
				" AND SM.idBS not IN (SELECT idBS FROM PORTER)";
			
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("Controle1");
			controlOfRiskNotNulWithoutMeasureResult(_sqlStatement.getResult());
		}
		private function controlOfRiskNotNulWithoutMeasureResult(result:SQLResult):void{
			var controle:String="1";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskNotNullWithoutMeasure.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskNotNullWithoutMeasure.step');
			
			_anomalyList=new ArrayCollection();
			// si nous avons des résultats
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			
			controlOfRiskWithoutEstimationMEWithMeasure();
		}
		
		/*
		 * Controle 2 : Risque sans calcul d'un niveau de risque
		 * a) s'il existe une mesure existante associée, pas de niveau de risque ME : controlRiskWithoutEstimationMEWithMeasure
		 * b) s'il existe une mesure complémentaire associée, pas de niveau de risque MC : controlRiskWithoutEstimationMCWithMeasure
		 * */
		private function controlOfRiskWithoutEstimationMEWithMeasure():void{
			_criticite="1";
			var query:String="SELECT DISTINCT  RISQUE.idRISQUE as idRISQUE, risque.libelleCourt  as label " +
				" FROM RISQUE, COMPOSER, SM  " +
				" WHERE (graviteME is null OR vraisemblanceME is null) " +
				" AND RISQUE.idRISQUE = COMPOSER.idRISQUE " +
				" AND COMPOSER.idSM = SM.idSM " +
				" AND SM.idBS in (SELECT PORTER.idBS FROM PORTER, MESURE WHERE MESURE.idMESURE = PORTER.idMESURE AND MESURE.etat = :etat)";
				
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":etat"] ="E";
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle2A");
			controlOfRiskWithoutEstimationMEWithMeasureResult(_sqlStatement.getResult());
		}
		private function controlOfRiskWithoutEstimationMEWithMeasureResult(result:SQLResult):void{
			var controle:String="2";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskWithoutEstimationMEWithMeasure.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskWithoutEstimationMEWithMeasure.step');

			// si nous avons des résultats
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfRiskWithoutEstimationMCWithMeasure();
		}
		private function controlOfRiskWithoutEstimationMCWithMeasure():void{
			_criticite="1";
			var query:String="SELECT DISTINCT  RISQUE.idRISQUE as idRISQUE, risque.libelleCourt  as label " +
				" FROM RISQUE, COMPOSER, SM  " +
				" WHERE (graviteMC is null OR vraisemblanceMC is null) " +
				" AND RISQUE.idRISQUE = COMPOSER.idRISQUE " +
				" AND COMPOSER.idSM = SM.idSM " +
				" AND SM.idBS in (SELECT PORTER.idBS FROM PORTER, MESURE WHERE MESURE.idMESURE = PORTER.idMESURE AND MESURE.etat = :etat)";
			
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":etat"] ="C";
			
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle2B");
			controlOfRiskWithoutEstimationMCWithMeasureResult(_sqlStatement.getResult());
		}
		private function controlOfRiskWithoutEstimationMCWithMeasureResult(result:SQLResult):void{
			var controle:String="2";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskWithoutEstimationMCWithMeasure.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskWithoutEstimationMCWithMeasure.step');
			
			// si nous avons des résultats
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfPrimaryAssetWithoutSupportingAssetLinked();
		}
		/*
		 * Controle 3 : il existe un BE qui n'est lié à aucun BS
		 * */
		private function controlOfPrimaryAssetWithoutSupportingAssetLinked():void{
			_criticite="1";
			var query:String="SELECT idBE, BE.libelle as label FROM BE WHERE idBE not in (SELECT idBE FROM CROISER)";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle3");
			controlOfPrimaryAssetWithoutSupportingAssetLinkedResult(_sqlStatement.getResult());
		}
		private function controlOfPrimaryAssetWithoutSupportingAssetLinkedResult(result:SQLResult):void{
			var controle:String="3";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfPrimaryAssetWithoutSupportingAssetLinked.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfPrimaryAssetWithoutSupportingAssetLinked.step');
			
			// si nous avons des résultats
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfSupportingAssetWithoutPrimaryAssetLinked();
		}
		/*
		 * Controle 4 : il existe un BS qui n'est lié à aucun BE
		 * */
		private function controlOfSupportingAssetWithoutPrimaryAssetLinked():void{
			_criticite="1";
			var query:String="SELECT idBS, BS.libelle as label FROM BS WHERE idBS not in (SELECT idBS FROM CROISER)";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle4");
			controlOfSupportingAssetWithoutPrimaryAssetLinkedResult(_sqlStatement.getResult());
		}
		private function controlOfSupportingAssetWithoutPrimaryAssetLinkedResult(result:SQLResult):void{
			var controle:String="4";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfSupportingAssetWithoutPrimaryAssetLinked.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfSupportingAssetWithoutPrimaryAssetLinked.step');
			
			// si nous avons des résultats
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfRiskEstimation1();
		}
		
		/*
		* Controle 5.1 : on récupere la liste des risques dont:
		-	[Estimation brute ET estimation avec ME = VIDE] OU [estimation MC=VIDE ET risque lié à des mesures]
		* */
		private function controlOfRiskEstimation1():void{
			_criticite="1";
			var query:String="SELECT RISQUE.idRISQUE as idRISQUE, RISQUE.libelleCourt as label " +
				" FROM RISQUE, COMPOSER, SM  " +
				" WHERE ((graviteBrute is null " +
				" OR vraisemblanceBrute is null) " +
				" AND (graviteME is null " +
				" OR  vraisemblanceME is null)) " +
				" OR ((graviteMC is null " +
				" AND vraisemblanceMC is null) " +
				" AND RISQUE.idRISQUE = COMPOSER.idRISQUE AND COMPOSER.idSM = SM.idSM AND SM.idBS in (SELECT idBS FROM PORTER)) ";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle5A");
			controlOfRiskEstimation1Result(_sqlStatement.getResult());
		}
		private function controlOfRiskEstimation1Result(result:SQLResult):void{
			var controle:String="5";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskEstimation1.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskEstimation1.step');
			
			// si nous avons des résultats
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfRiskEstimation2();
		}
		
		/*
		* Controle 5.2 : on récupere la liste des risques dont:
		-	[Estimation BRUTE < estimation ME ] ET estimation ME = VIDE
		* */
		
		private function controlOfRiskEstimation2():void{
			_criticite="1";
			var query:String="SELECT idRISQUE, Risque.libelleCourt as label FROM RISQUE " +
				" WHERE ( graviteBrute < graviteME AND  graviteME <> null) " +
				" OR (vraisemblanceBrute < vraisemblanceME AND vraisemblanceME <> null )";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle5B");
			controlOfRiskEstimation2Result(_sqlStatement.getResult());
		}
		private function controlOfRiskEstimation2Result(result:SQLResult):void{
			var controle:String="5";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskEstimation2.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskEstimation2.step');
			
			// si nous avons des résultats
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfRiskEstimation3();
		}
		
		/*
		* Controle 5.3 : on récupere la liste des risques dont:
		-	[estimation ME < estimation MC ] ET estimation MC = VIDE
		* */
		private function controlOfRiskEstimation3():void{
			_criticite="1";
			var query:String="SELECT idRISQUE, Risque.libelleCourt as label FROM RISQUE " +
				" WHERE ( graviteME < graviteMC AND  graviteMC <> null) " +
				" OR (vraisemblanceME < vraisemblanceMC AND vraisemblanceMC <> null )";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle5C");
			controlOfRiskEstimation3Result(_sqlStatement.getResult());
		}
		private function controlOfRiskEstimation3Result(result:SQLResult):void{
			var controle:String="5";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskEstimation3.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskEstimation3.step');
			
			// si nous avons des résultats
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfFearedEventWithSameImpactAndDifferentGravityLevel();
			
		}
		

		/**********************************************************/
		/** 				Anomalies mineures 				   	 **/
		/**********************************************************/
		
		/*
		* Controle 6: deux évènements redoutés liés au même impact, ayant des niveaux de gravité différents
		* */
		private function controlOfFearedEventWithSameImpactAndDifferentGravityLevel():void{
			_criticite="2";
			var query:String="SELECT  idIMPACT, ER.idER as ider, ER.libelle as label ,  ER.idNGRISQUE as idngrisque " +
				" FROM ENGENDRER a, ER " +
				" WHERE a.idBE = ER.idBE " +
				" AND a.idCRITERE = ER.idCRITERE " +
				" ORDER BY idimpact";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle6");
			controlOfFearedEventWithSameImpactAndDifferentGravityLevelResult(_sqlStatement.getResult());
		}
		private function controlOfFearedEventWithSameImpactAndDifferentGravityLevelResult(result:SQLResult):void{
			var controle:String="6";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfFearedEventWithSameImpactAndDifferentGravityLevel.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfFearedEventWithSameImpactAndDifferentGravityLevel.step');
			
			// si nous avons des résultats on les mets dans un tableau 
			if (result != null && result.data != null){
				formatAnomalyControl6List(result,controle,label,etape);
			}
			
			
			controlOfFearedEventAndThreatScenarioAssociatedWithRisk();
		}
		
		/*
		 * Controle 7 Association d'une ER et d'un SM à un risque qui n'ont pas les mêmes sources de menace 
		 * */
		private function controlOfFearedEventAndThreatScenarioAssociatedWithRisk():void{
			_criticite="2";
			var query:String="Select distinct R.idER,  C.idSM ,R.idRISQUE, ER.libelle as erLabel, SM.libelle as smLabel " +
				" FROM RISQUE R, COMPOSER C,ER, SM, INITIER i, POUVOIR p" +
				" WHERE R.idRISQUE = C.idRISQUE " +
				" AND ER.idER = R.idER " +
				" AND ER.idCRITERE = i.idCRITERE " +
				" AND ER.idBE = i.idBE " +
				" AND C.idSM = p.idSM " +
				" AND p.idSM = SM.idSM  " +
				" AND i.idSOURCE <> p.idSOURCE " +
				" ORDER BY 1,2";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle7");
			controlOfFearedEventAndThreatScenarioAssociatedWithRiskResult(_sqlStatement.getResult());
		}
		private function controlOfFearedEventAndThreatScenarioAssociatedWithRiskResult(result:SQLResult):void{
			var controle:String="7";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfFearedEventAndThreatScenarioAssociatedWithRisk.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfFearedEventAndThreatScenarioAssociatedWithRisk.step');
			
			// si nous avons des résultats on les mets dans un tableau 
			if (result != null && result.data != null){
				formatAnomalyControl7List(result,controle,label,etape);
			}
			controlOfMeasureWithoutRiskLinked();
		}
		
		/*
		* Controle 8: Mesure (de référentiel ETUDE) sans lien avec un risque
		*/
		private function controlOfMeasureWithoutRiskLinked():void{
			_criticite="2";
			var query:String="SELECT M.idMESURE, M.libelle as label FROM MESURE M WHERE M.idTMESURES in " +
				" (SELECT T.idTMESURES FROM TMESURES T , REFERENTIEL RE " +
				" WHERE T.idREFERENTIEL = RE.idREFERENTIEL AND RE.libelle = :reLibelle) " +
				" AND M.idMESURE not in ( SELECT idMESURE FROM PORTER )";
			
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":reLibelle"]="ETUDE";
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle8");
			controlOfMeasureWithoutRiskLinkedResult(_sqlStatement.getResult());
		}
		
		private function controlOfMeasureWithoutRiskLinkedResult(result:SQLResult):void{
			var controle:String="8";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfMeasureWithoutRiskLinked.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfMeasureWithoutRiskLinked.step');
			
			// si nous avons des résultats on les mets dans un tableau 
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfRiskGravityLevel();
			//controlOfObjectIncomplete();
		}
		
		/*
		* Controle 9: Objet dont les caractéristiques sont incomplètes ( A LISTER )
		* */
		private function controlOfIncompleteObject():void{
			_criticite="2";
			var query:String="";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle9");
			controlOfIncompleteObjectResult(_sqlStatement.getResult());
		}
		private function controlOfIncompleteObjectResult(result:SQLResult):void{
			var controle:String="9";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfIncompleteObject.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfIncompleteObject.step');
			
			if (result != null && result.data != null){
				//formatAnomalyList(result,controle,label,etape);
			}
			controlOfRiskGravityLevel();
		}
		
		/*
		 * Controle 10: un risque a une Gravité supérieur à l'ER concerné 
		 * */
		private function controlOfRiskGravityLevel():void{
			_criticite="2";
			var query:String="SELECT idRISQUE,RISQUE.libelleCourt as label FROM RISQUE , ER " +
				" WHERE RISQUE.idER = ER.idER AND RISQUE.graviteBrute > ER.idNGRISQUE";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle10");
			controlOfRiskGravityLevelResult(_sqlStatement.getResult());
		}
		private function controlOfRiskGravityLevelResult(result:SQLResult):void{
			var controle:String="10";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskGravityLevel.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskGravityLevel.step');
			
			// si nous avons des résultats on les mets dans un tableau 
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfRiskLikelihoodLevel();
		}
		/*
		* Controle 11: Un risque a une Vraisemblance différente du MAX des vraisemblances de ses SM constituants
		* */
		private function controlOfRiskLikelihoodLevel():void{
			_criticite="2";
			var query:String="SELECT distinct RISQUE.idRISQUE as monIdRisque, RISQUE.libelleCourt as label " +
				" FROM RISQUE , COMPOSER WHERE RISQUE.idRISQUE = COMPOSER.idRISQUE " +
				" AND RISQUE.vraisemblanceBrute not in (SELECT MAX(idNVRISQUE) FROM SM , COMPOSER " +
				" WHERE SM.idSM = COMPOSER.idSM  AND COMPOSER.idRISQUE = monIdRisque)";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle11");
			controlOfRiskLikelihoodLevelResult(_sqlStatement.getResult());
		}
		private function controlOfRiskLikelihoodLevelResult(result:SQLResult):void{
			var controle:String="11";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskLikelihoodLevel.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfRiskLikelihoodLevel.step');
			
			// si nous avons des résultats on les mets dans un tableau 
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfThreatScenarioWithoutThreatOrThreatSource();
		}
		
		/*
		* Controle 12: Un SM n’a pas de menace ou n’a pas de source de menace
		* */
		private function controlOfThreatScenarioWithoutThreatOrThreatSource():void{
			_criticite="2";
			var query:String="SELECT idSM, SM.libelle as label FROM SM " +
				" WHERE idSM not in ( SELECT idSM FROM MENACER ) " +
				" AND idSM not in ( SELECT idSM FROM POUVOIR)";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle12");
			controlOfThreatScenarioWithoutThreatOrThreatSourceResult(_sqlStatement.getResult());
		}
		private function controlOfThreatScenarioWithoutThreatOrThreatSourceResult(result:SQLResult):void{
			var controle:String="12";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfThreatScenarioWithoutThreatOrThreatSource.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfThreatScenarioWithoutThreatOrThreatSource.step');
			// si nous avons des résultats on les mets dans un tableau 
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfPrimaryAssetNotRetained();
		}
		/*
		* Controle 13: Liste les Biens essentiels  qui ne sont pas retenus
		* */
		private function controlOfPrimaryAssetNotRetained():void{
			_criticite="2";
			var query:String = "SELECT idBE, libelle as label FROM BE WHERE retenu = 0";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle13");
			controlOfPrimaryAssetNotRetainedResult(_sqlStatement.getResult());
			
		}
		
		private function controlOfPrimaryAssetNotRetainedResult(result:SQLResult):void{
			var controle:String = "13";
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfPrimaryAssetNotRetained.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfPrimaryAssetNotRetained.step');
			// si nous avons des résultats on les mets dans un tableau 
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			controlOfSupportingAssetNotRetained();
		}
		/*
		* Controle 14: Liste les Biens supports  qui ne sont pas retenus
		* */
		private function controlOfSupportingAssetNotRetained():void{
			_criticite="2";
			var query:String = "SELECT idBS, libelle as label FROM BS WHERE retenu = 0";
			
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			trace("controle14");
			controlOfSupportingAssetNotRetainedResult(_sqlStatement.getResult());
			
		}
		
		private function controlOfSupportingAssetNotRetainedResult(result:SQLResult):void{
			var controle:String = "14";
			
			var label:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfSupportingAssetNotRetained.label');
			var etape:String=ResourceManager.getInstance().getString('resources', 'audit.controlOfSupportingAssetNotRetained.step');
			// si nous avons des résultats on les mets dans un tableau 
			if (result != null && result.data != null){
				formatAnomalyList(result,controle,label,etape);
			}
			
			_sqlStatement.sqlConnection.close();
			
			if(_anomalyList.length >0){
				_currentIndex=-1;
				insertAnomaly();
			}else{
				_responder.result(null);
			}
		}
		
	}
}