package com.anssi.ebios.services
{
	import com.anssi.ebios.model.DefenceLine;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class DefenceLineService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement; 
			
		public function DefenceLineService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		/****************************************************/
		/** Récupération de la liste des lignes de défense **/
		/****************************************************/
		public function getDefenceLineList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT * FROM LIGNE";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getDefenceLineListResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		public function getDefenceLineListResult(event:SQLEvent):void{
			var defenceLineList:ArrayCollection = new ArrayCollection();
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				defenceLineList = constructDefenceLineList(result);	
			}
			_sqlStatement.sqlConnection.close();
			responder.result(defenceLineList);
		}
		
		public function constructDefenceLineList(result:SQLResult):ArrayCollection{
			
				var defenceLineList:ArrayCollection = new ArrayCollection();
				
				if (result.data){
				
				var row:Object;
				var numRows:int = result.data.length;
				var defenceLine:DefenceLine = null;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					defenceLine = new DefenceLine();
					defenceLine.id = row["idLIGNE"];
					defenceLine.label = row["libelle"];
					defenceLine.description = row["description"];
					defenceLine.export_id = 'd' + row["idLIGNE"];
					
					defenceLineList.addItem(defenceLine);
				}
			}
			return defenceLineList;
		}
		
		public function constructDefenceLineQuery():String
		{
			return  "SELECT * FROM LIGNE";
		}
		
	}
}