package com.anssi.ebios.services
{
	import com.anssi.ebios.model.Image;
	import com.anssi.ebios.utils.CompareCollectionUtil;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class ImageService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		private var _imageList:ArrayCollection;
		private var _imageListToDelete:ArrayCollection;
		private var _currentIndex:Number = -1;

		public function ImageService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		
		/*****************************************/
		/** Récupération de la liste des images **/
		/*****************************************/
		public function getImageList():void{
			
			constructQuerySelectImageList();
			_sqlStatement.addEventListener(SQLEvent.RESULT,getImageListResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function constructQuerySelectImageList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT * FROM IMAGE";
			
			_sqlStatement.text = query;
		} 
		
		private function getImageListResult(event:SQLEvent):void{
			
			var result:SQLResult = SQLStatement(event.target).getResult();
			responder.result(constructImageListResult(result));
		}
		
		private function constructImageListResult(result:SQLResult):ArrayCollection{
			var imageList:ArrayCollection = null;
			if (result != null && result.data != null)
			{
				imageList = new ArrayCollection();
				
				var row:Object;
				var numRows:int = result.data.length;
				var image:Image = null;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];					
					image = new Image();
					image.id = row["idIMAGE"];
					image.label = row["nom"];
					image.url = row["URL"];					
					imageList.addItem(image);
				}
			}			
			_sqlStatement.sqlConnection.close();
			return imageList;
		}
		
		
		/****************************************/
		/** Mise à jour de la liste des images **/
		/****************************************/
		
		public function updateImageList(imageList:ArrayCollection):void{
			_imageList = imageList;
			insertImage();
		}
		
		
		private function insertImage():void{
			var query:String="";
			
			_currentIndex++
				
				setBDDName();
			_sqlStatement = new SQLStatement();				
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			if (_currentIndex < _imageList.length){
				var image:Image = _imageList.getItemAt(_currentIndex) as Image;

				
				if (Number(image.id) <= 0){
					
					query = "INSERT INTO IMAGE (nom, URL, dateCreation, dateModification) VALUES (:nom, :URL, :dateCreation, :dateModification)";
					
					_sqlStatement.parameters[":nom"] = image.label;
					_sqlStatement.parameters[":URL"] = image.url;
					_sqlStatement.parameters[":dateCreation"] = new Date();
					_sqlStatement.parameters[":dateModification"] = new Date();				
				
					_sqlStatement.text = query;
					_sqlStatement.addEventListener(SQLEvent.RESULT,insertImageResult);
					
					openAndExecStatementInAsyncMode(_sqlStatement);	
				}else{
					insertImage();
				}
			}else{
				_sqlStatement.sqlConnection.close();
				responder.result(null);
			}
		}
		
		private function insertImageResult(event:SQLEvent):void{
			insertImage();
		}
	
		/*****************************/
		/** Suppression d'une image **/
		/*****************************/
		
		public function deleteImage(img:Image):void{
			setBDDName();				
			_sqlStatement = new SQLStatement();				
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			var query:String = "DELETE FROM IMAGE WHERE idIMAGE = " + img.id;

			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,deleteImageResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function deleteImageResult(event:SQLEvent):void{
			_sqlStatement.sqlConnection.close();
			responder.result(null);
		}
		
	}
}