package com.anssi.ebios.services
{
	import com.anssi.ebios.model.Objective;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class ObjectiveService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		
		public function ObjectiveService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		/********************************************************/
		/** Récupération de la liste des objectifs de sécurité **/
		/********************************************************/
		public function getObjectifList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT * FROM TOBJECTIFS";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getObjectifListResult);

			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function getObjectifListResult(event:SQLEvent):void{
			var objectiveList:ArrayCollection = new ArrayCollection();
			var result:SQLResult = SQLStatement(event.target).getResult();

			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var objective:Objective = null;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					objective = new Objective();
					objective.id = row["idTOBJECTIFS"];
					objective.label = row["libelle"];
					objective.definition = row["definition"];
					objective.order = row["ordre"];
					
					objectiveList.addItem(objective);
				}
			}
			
			_sqlStatement.sqlConnection.close();
			responder.result(objectiveList);
		}
	}
}