package com.anssi.ebios.services
{
	import com.anssi.ebios.model.DefenceLine;
	import com.anssi.ebios.model.Indicator;
	import com.anssi.ebios.model.People;
	import com.anssi.ebios.model.PrimaryAsset;
	import com.anssi.ebios.model.Risk;
	import com.anssi.ebios.model.SecurityMeasure;
	import com.anssi.ebios.model.Subject;
	import com.anssi.ebios.model.SupportingAsset;
	import com.anssi.ebios.model.WorkStructure;
	import com.anssi.ebios.utils.Constants;
	import com.anssi.ebios.utils.OpenXMLServiceResultVO;
	import com.anssi.ebios.utils.openxml.ColumnOpenXml;
	import com.anssi.ebios.utils.openxml.OpenXMLUtil;
	
	import flash.data.SQLStatement;
	
	import mx.collections.ArrayCollection;
	import mx.resources.ResourceManager;
	import mx.rpc.IResponder;

	public class OpenXMLService extends AppServices
	{
		public var responder:IResponder;
		
		public function OpenXMLService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		
		}
		/**
		 * 
		 * @param baseString la chaine à transformer en openXML.
		 * La fonction parcourt la chaine, quand elle trouve une balise,
		 * elle consrtuit et ajoute les noeud correspondant en openXml grâce aux méthodes static de OpenXMLUtil
		 * Cette fonction gère les balises présentent dans la classe Constants
		 **/
		public  function constructOpenXMLFromString(baseString:String):void
		{
			//AJOUTER DANS CE TABLEAU LA NOUVELLE BALISE A TRAITER
			var openMarkerTypeArray:Array=[Constants.MARKER_TITLE_OPEN,Constants.MARKER_DESCRIPTION_OPEN,
											Constants.MARKER_ER,Constants.MARKER_EVAL_ER,Constants.MARKER_BE,Constants.MARKER_BS,Constants.MARKER_STRUCTURE_TRAVAIL,Constants.MARKER_VRAISEMBLANCE,
											Constants.MARKER_GRAVITE,Constants.MARKER_CRITERE_SECURITE,Constants.MARKER_SOURCE,Constants.MARKER_PARAMETRE,
											Constants.MARKER_CRITERE_GESTION_RISQUE,Constants.MARKER_SM,Constants.MARKER_EVAL_SM,Constants.MARKER_RISQUE,Constants.MARKER_CARTO_RISQUE_SM_ME,
											Constants.MARKER_RISQUE_RESIDUEL,Constants.MARKER_DECLARATION_APPLICABILITE,Constants.MARKER_BE_BS,Constants.MARKER_PLAN_ACTION,
											Constants.MARKER_MATRICE_MESURE_RISQUE,Constants.MARKER_OPTION_TRT_RISQUE,Constants.MARKER_MESURES,Constants.MARKER_OBJECTIF, Constants.MARKER_CONTEXTE, Constants.MARKER_PERIMETRE];
			
			var xml:XML= OpenXMLUtil.baseXMLDocument();
			var documentBody:XML = OpenXMLUtil.documentBody(xml);
			
			setBDDName();
			var sqlStatement:SQLStatement = new SQLStatement();
			sqlStatement.sqlConnection = this.sqlConnection;
			openInSyncMode(sqlStatement);
			
			//Création de l'objet "Resultat" du service
			//C'est cet objet qui sera retourné par le responder du service
			var openXMLServiceResultVO:OpenXMLServiceResultVO = new OpenXMLServiceResultVO();
			openXMLServiceResultVO.statut = OpenXMLServiceResultVO.SUCCES //Par defaut, on init le statut à succès
			
			try
			{
				
			
				while (baseString.length>0)
				{
					
					//AJOUTER ICI UN NOUVEAU CAS A TRAITER
					switch(typeOfNextMarker(baseString,openMarkerTypeArray))
					{
						case Constants.MARKER_TITLE_OPEN:
							
							/*
							//Si on ne trouve pas la balise fermante, on supprime la balise ouvrante
							if (baseString.indexOf(Constants.MARKER_TITLE_CLOSE, baseString.indexOf(Constants.MARKER_TITLE_OPEN)) == -1){
								removeMarker(baseString,Constants.MARKER_TITLE_OPEN);
							}else{
								trace(Constants.MARKER_TITLE_OPEN);
								var title:String = findMarkerValue(baseString,Constants.MARKER_TITLE_OPEN,Constants.MARKER_TITLE_CLOSE);
								documentBody.appendChild(OpenXMLUtil.createOpenXMLTitle(title));
								baseString = removeMarker(baseString,Constants.MARKER_TITLE_OPEN,Constants.MARKER_TITLE_CLOSE);
							}
							break;
							*/
							
							trace(Constants.MARKER_TITLE_OPEN);
							var title:String = findMarkerValue(baseString,Constants.MARKER_TITLE_OPEN,Constants.MARKER_TITLE_CLOSE);
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTitle(title));
							baseString = removeMarker(baseString,Constants.MARKER_TITLE_OPEN,Constants.MARKER_TITLE_CLOSE);
							break
						
						case Constants.MARKER_DESCRIPTION_OPEN:
							/*
							//Si on ne trouve pas la balise fermante, on supprime la balise ouvrante
							if (baseString.indexOf(Constants.MARKER_DESCRIPTION_CLOSE, baseString.indexOf(Constants.MARKER_DESCRIPTION_OPEN)) == -1){
								removeMarker(baseString,Constants.MARKER_DESCRIPTION_OPEN);
							}else{
								trace(Constants.MARKER_DESCRIPTION_OPEN);
								var description:String = findMarkerValue(baseString,Constants.MARKER_DESCRIPTION_OPEN,Constants.MARKER_DESCRIPTION_CLOSE);
								documentBody.appendChild(OpenXMLUtil.createOpenXMLDescription(description));
								baseString = removeMarker(baseString,Constants.MARKER_DESCRIPTION_OPEN,Constants.MARKER_DESCRIPTION_CLOSE);
							}	
							*/
							
							trace(Constants.MARKER_DESCRIPTION_OPEN);
							var description:String = findMarkerValue(baseString,Constants.MARKER_DESCRIPTION_OPEN,Constants.MARKER_DESCRIPTION_CLOSE);
							documentBody.appendChild(OpenXMLUtil.createOpenXMLDescription(description));
							baseString = removeMarker(baseString,Constants.MARKER_DESCRIPTION_OPEN,Constants.MARKER_DESCRIPTION_CLOSE);
							break
						
						case Constants.MARKER_OBJECTIF:
							
							trace(Constants.MARKER_OBJECTIF);
							sqlStatement.clearParameters();
							var subject:SubjectService = new SubjectService(null);
							sqlStatement.text=subject.constructSubjectQuery();
							execStatement(sqlStatement);
							
							var subjectResult:Subject=subject.constructSubjectList(sqlStatement.getResult());
							
							documentBody.appendChild(OpenXMLUtil.createOpenXMLText(subjectResult.gross_purpose));
							baseString = removeMarker(baseString,Constants.MARKER_OBJECTIF);
							break
						
						case Constants.MARKER_CONTEXTE:
							
							trace(Constants.MARKER_CONTEXTE);
							sqlStatement.clearParameters();
							var subject:SubjectService = new SubjectService(null);
							sqlStatement.text=subject.constructSubjectQuery();
							execStatement(sqlStatement);
							
							var subjectResult:Subject=subject.constructSubjectList(sqlStatement.getResult());
							
							documentBody.appendChild(OpenXMLUtil.createOpenXMLText(subjectResult.gross_context));
							baseString = removeMarker(baseString,Constants.MARKER_CONTEXTE);
							break
						
						case Constants.MARKER_PERIMETRE:
							
							trace(Constants.MARKER_PERIMETRE);
							sqlStatement.clearParameters();
							var subject:SubjectService = new SubjectService(null);
							sqlStatement.text=subject.constructSubjectQuery();
							execStatement(sqlStatement);
							
							var subjectResult:Subject=subject.constructSubjectList(sqlStatement.getResult());
							
							documentBody.appendChild(OpenXMLUtil.createOpenXMLText(subjectResult.gross_perimeter));
							baseString = removeMarker(baseString,Constants.MARKER_PERIMETRE);
							break
						
						case Constants.MARKER_STRUCTURE_TRAVAIL:
							
							trace(Constants.MARKER_STRUCTURE_TRAVAIL);
							
							sqlStatement.clearParameters();
							var ws:WorkStructureService = new WorkStructureService(null);
							sqlStatement.text=ws.constructWorkStructureQuery();
							execStatement(sqlStatement);
							
							var workStructureList:ArrayCollection=ws.constructWorkStructureList(sqlStatement.getResult());
							
							sqlStatement.clearParameters();
							var people:PeopleService = new PeopleService(null);
							sqlStatement.text=people.constructRetainedPeopleQuery();
							execStatement(sqlStatement);
							
							
							var peopleList:ArrayCollection=people.constructRetainedPeopleList(sqlStatement.getResult());
							
							
							var col:ArrayCollection = new ArrayCollection();
							
							//Exemple de création de données "à plat" pour les tableaux à colonne dynamic
							//Chaque objet a autant de propriétés que le tableau a de colonne
							
							for each (var wsItem:WorkStructure in workStructureList) 
							{
								var obj:Object = new Object();
								obj.actionFullLabel=wsItem.actionFullLabel;
								obj.deliverableLabel=wsItem.deliverableLabel;
								obj.instruction=wsItem.instruction;
								obj.workload=wsItem.workload;
								obj.duration=wsItem.duration;
							
								//On ajoute à notre objet une propriété par colonne dynamic
								//Cette propriete a pour nom l'id de l'objet people
								//Dans la construction dynamic des colonnes (méthode constructWSColumnList), nous avons précisé que le datafiel de la colonne = id de l'objet Poeple
							
								for each (var peopleItem:People in peopleList)
								{
									//Affectation dynamic d'une nouvelle propriété à notre objet
									//Si peopleItem.id = 44:
									//je peux écrire obj[peopleItem.id] = "bonjour";
									//Si je j'écris obj.44, cela affichera "bonjour";
									//Les colonnes ont pour datafield [peopleItem.id], tous nos objets doivent donc avoir ces proprités (valorisées ou non)
									obj[peopleItem.id] = "";
									for each (var wsPeople:People in wsItem.peopleList)
									{
										if(peopleItem.id == wsPeople.id)
										{
											obj[peopleItem.id]=wsPeople.role.label;
										}
									}
								
								}
								col.addItem( obj );
							}
							
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructWSColumnList(peopleList),col));
							baseString = removeMarker(baseString,Constants.MARKER_STRUCTURE_TRAVAIL);
							break
							
						case Constants.MARKER_PARAMETRE:
							
							trace(Constants.MARKER_PARAMETRE);
							sqlStatement.clearParameters();
							var parameter:ParameterService = new ParameterService(null);
							sqlStatement.text=parameter.constructParameterQuery();
							execStatement(sqlStatement);
							
							var parameterList:ArrayCollection=parameter.constructParameterList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructParameterColumnList(),parameterList));
							baseString = removeMarker(baseString,Constants.MARKER_PARAMETRE);
							break
						
						case Constants.MARKER_SOURCE:
							
							trace(Constants.MARKER_SOURCE);
							sqlStatement.clearParameters();
							var threatSource:ThreatSourceTypeService = new ThreatSourceTypeService(null);
							sqlStatement.text=threatSource.constructThreatSourceTypeQuery();
							execStatement(sqlStatement);
							
							var threatSourceList:ArrayCollection=threatSource.constructThreatSourceTypeList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructThreatSourceColumnList(),threatSourceList));
							baseString = removeMarker(baseString,Constants.MARKER_SOURCE);
							break
						
						case Constants.MARKER_CRITERE_SECURITE:
							
							trace(Constants.MARKER_CRITERE_SECURITE);
							sqlStatement.clearParameters();
							var sc:SecurityCriteriaService = new SecurityCriteriaService(null);
							sqlStatement.text=sc.constructSecurityCriteriaQuery();
							execStatement(sqlStatement);
							
							var securityCriteriaList:ArrayCollection=sc.constructSecurityCriteriaForDelivrable(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructSecurityCriteriaColumnList(),securityCriteriaList));
							baseString = removeMarker(baseString,Constants.MARKER_CRITERE_SECURITE);
							break
						
						case Constants.MARKER_GRAVITE:
							
							trace(Constants.MARKER_GRAVITE);
							sqlStatement.clearParameters();
							var gravityLevel:GravityLevelService = new GravityLevelService(null);
							sqlStatement.text=gravityLevel.constructGravityLevelQuery();
							execStatement(sqlStatement);
							
							var gravityLeveltList:ArrayCollection=gravityLevel.constructGravityLevelListResult(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructGravityLevelColumnList(),gravityLeveltList));
							baseString = removeMarker(baseString,Constants.MARKER_GRAVITE);
							break
						
						case Constants.MARKER_VRAISEMBLANCE:
							
							trace(Constants.MARKER_VRAISEMBLANCE);
							sqlStatement.clearParameters();
							var likelihoodService:LikelihoodService = new LikelihoodService(null);
							sqlStatement.text=likelihoodService.constructLikelihoodLevelQuery();
							execStatement(sqlStatement);
							
							var likelihoodLevelList:ArrayCollection =likelihoodService.constructLikelihoodLevelListResult(sqlStatement.getResult());
							
							/*var montabAuFormatXML:XML = OpenXMLUtil.createOpenXMLTable(constructLikelihoodLevelColumnList(),likelihoodLevelList);
							documentBody.appendChild(montabAuFormatXML);*/
							
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructLikelihoodLevelColumnList(),likelihoodLevelList));
							baseString = removeMarker(baseString,Constants.MARKER_VRAISEMBLANCE);
							break
						
						case Constants.MARKER_CRITERE_GESTION_RISQUE:
							
							trace(Constants.MARKER_CRITERE_GESTION_RISQUE);
							sqlStatement.clearParameters();
							var cgr:ActionService = new ActionService(null);
							sqlStatement.text=cgr.constructActionQuery();
							execStatement(sqlStatement);
							
							var actionList:ArrayCollection=cgr.constructActionList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructActionColumnList(),actionList));
							baseString = removeMarker(baseString,Constants.MARKER_CRITERE_GESTION_RISQUE);
							break
						
						case Constants.MARKER_BE:
							
							trace(Constants.MARKER_BE);
							sqlStatement.clearParameters();
							var be:PrimaryAssetService = new PrimaryAssetService(null);
							sqlStatement.text=be.constructPrimaryAssetQuery();
							execStatement(sqlStatement);
							
							var primaryAssetList:ArrayCollection=be.constructPrimaryAssetList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructBEColumnList(),primaryAssetList));
							baseString = removeMarker(baseString,Constants.MARKER_BE);
							break
						
						case Constants.MARKER_BS:
							
							trace(Constants.MARKER_BS);
							sqlStatement.clearParameters();
							var bs:SupportingAssetService = new SupportingAssetService(null);
							sqlStatement.text=bs.constructSupportingAssetQuery();
							execStatement(sqlStatement);
							
							var supportingAssetList:ArrayCollection=bs.constructSupportingAssetList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructBSColumnList(),supportingAssetList));
							baseString = removeMarker(baseString,Constants.MARKER_BS);
							break
						
						case Constants.MARKER_BE_BS:
							
							trace(Constants.MARKER_BE_BS);
							
							sqlStatement.clearParameters();
							var bsService:SupportingAssetService = new SupportingAssetService(null);
							sqlStatement.text=bsService.constructLinkBetweenAssetsQuery();
							execStatement(sqlStatement);
							
							var BSList:ArrayCollection=bsService.constructLinkBetweenAssetsListLight(sqlStatement.getResult());
							
							sqlStatement.clearParameters();
							var beService:PrimaryAssetService = new PrimaryAssetService(null);
							sqlStatement.text=beService.constructPrimaryAssetQuery();
							execStatement(sqlStatement);
							
							var BEList:ArrayCollection=beService.constructPrimaryAssetList(sqlStatement.getResult());
							
							var col:ArrayCollection = new ArrayCollection();
							
							for each (var bsItem:SupportingAsset in BSList) 
							{
								var obj:Object = new Object();
								obj.label=bsItem.labelAndType;
							
								for each (var beItem:PrimaryAsset in BEList)
								{
									obj[beItem.id] = "";
									
									for each (var bsPrimaryAsset:PrimaryAsset in bsItem.primaryAssetList)
									{
										if(beItem.id == bsPrimaryAsset.id)
										{
											obj[beItem.id]="x";
										}
									}
									
								}
								col.addItem( obj );
							}
									
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructBEBSColumnList(BEList),col));
							baseString = removeMarker(baseString,Constants.MARKER_BE_BS);
							break
						
						case Constants.MARKER_ER:
							
							trace(Constants.MARKER_ER);
							sqlStatement.clearParameters();
							var fe:FearedEventService = new FearedEventService(null);
							sqlStatement.text=fe.constructFearedEventQuery();
							execStatement(sqlStatement);
							
							var fearedEventList:ArrayCollection=fe.constructFearedEventList(sqlStatement.getResult());
							
							//constructERColumnList() => Construit une collection des colonnes qu'on vveut afficher
							//fearedEventList => Résultat de la requête
							//OpenXMLUtil.createOpenXMLTable => Retourne un tableau au format OpenXML
							//appendChild => Ajoute notre tableau au XML Globale
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructERColumnList(),fearedEventList));
							baseString = removeMarker(baseString,Constants.MARKER_ER);
							break
						
						case Constants.MARKER_EVAL_ER:
							
							trace(Constants.MARKER_EVAL_ER);
							sqlStatement.clearParameters();
							var feEval:FearedEventService = new FearedEventService(null);
							sqlStatement.text=feEval.constructFearedEventQuery();
							execStatement(sqlStatement);
							
							var fearedEventEvalList:ArrayCollection=feEval.constructFearedEventList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructErEvalColumnList(),fearedEventEvalList));
							baseString = removeMarker(baseString,Constants.MARKER_EVAL_ER);
							break
						
						case Constants.MARKER_SM:
							
							trace(Constants.MARKER_SM);
							sqlStatement.clearParameters();
							// recuparation de la liste des SM
							var sm:ThreatScenarioService = new ThreatScenarioService(null);
							sqlStatement.text=sm.constructThreatScenarioQueryUnitaire();
							execStatement(sqlStatement);
							var threatScenarioList:ArrayCollection=sm.constructThreatScenarioList(sqlStatement.getResult());
							
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructSMColumnList(),threatScenarioList));
							baseString = removeMarker(baseString,Constants.MARKER_SM);
							break
						
						case Constants.MARKER_EVAL_SM:
							
							trace(Constants.MARKER_EVAL_SM);
							sqlStatement.clearParameters();
							var smEval:ThreatScenarioService = new ThreatScenarioService(null);
							sqlStatement.text=smEval.constructThreatScenarioQueryUnitaire();
							execStatement(sqlStatement);
							
							var threatScenarioEvalList:ArrayCollection=smEval.constructThreatScenarioList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructEvalSMColumnList(),threatScenarioEvalList));
							baseString = removeMarker(baseString,Constants.MARKER_EVAL_SM);
							break
						
						case Constants.MARKER_RISQUE:
							
							trace(Constants.MARKER_RISQUE);
							sqlStatement.clearParameters();
							var risk:RiskService = new RiskService(null);
							sqlStatement.text=risk.buildRiskQueryForDelivrable();
							execStatement(sqlStatement);
							
							var riskList:ArrayCollection=risk.constructRiskListForDelivrable(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructRiskColumnList(),riskList));
							baseString = removeMarker(baseString,Constants.MARKER_RISQUE);
							break
						
						case Constants.MARKER_CARTO_RISQUE_SM_ME:
							
							trace(Constants.MARKER_CARTO_RISQUE_SM_ME);
							sqlStatement.clearParameters();
							var cartoRisk:RiskService = new RiskService(null);
							var arg:String = "";
							sqlStatement.text=cartoRisk.buildGetRiskQuery(arg);
							execStatement(sqlStatement);
							
							var cartoRiskList:ArrayCollection=cartoRisk.constructCartoRiskList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructCartoRiskColumnList(),cartoRiskList));
							baseString = removeMarker(baseString,Constants.MARKER_CARTO_RISQUE_SM_ME);
							break
						
						case Constants.MARKER_OPTION_TRT_RISQUE:
							
							trace(Constants.MARKER_OPTION_TRT_RISQUE);
							sqlStatement.clearParameters();
							var opt:RiskService = new RiskService(null);
							sqlStatement.text=opt.constructObjectiveRiskQuery();
							execStatement(sqlStatement);
							
							var optAppList:ArrayCollection=opt.constructObjectiveRiskList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructOptColumnList(),optAppList));
							baseString = removeMarker(baseString,Constants.MARKER_OPTION_TRT_RISQUE);
							break
						
						case Constants.MARKER_DECLARATION_APPLICABILITE:
							
							trace(Constants.MARKER_DECLARATION_APPLICABILITE);
							sqlStatement.clearParameters();
							var decApp:ParameterService = new ParameterService(null);
							sqlStatement.text=decApp.constructParameterQuery();
							execStatement(sqlStatement);
							
							var decAppList:ArrayCollection=decApp.constructParameterList(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructDecAppColumnList(),decAppList));
							baseString = removeMarker(baseString,Constants.MARKER_DECLARATION_APPLICABILITE);
							break
						
						case Constants.MARKER_PLAN_ACTION:
							
							trace(Constants.MARKER_PLAN_ACTION);
							
							sqlStatement.clearParameters();
							var paService:ActionPlanService = new ActionPlanService(null);
							sqlStatement.text=paService.constructComplementarySecurityMeasureForDelivrable();
							execStatement(sqlStatement);
							
							var actionPlanList:ArrayCollection=paService.constructComplementarySecurityMesureList(sqlStatement.getResult());
							
							sqlStatement.clearParameters();
							var indicatorService:IndicatorService = new IndicatorService(null);
							sqlStatement.text=indicatorService.constructIndicatorQuery();
							execStatement(sqlStatement);
							
							var indicatorList:ArrayCollection=indicatorService.formatIndicatorResult(sqlStatement.getResult());
							
							var col:ArrayCollection = new ArrayCollection();
							
							for each (var paItem:SecurityMeasure in actionPlanList) 
						{
							var obj:Object = new Object();
							obj.label=paItem.label;
							obj.managerToString=paItem.managerToString;
							
							for each (var indicatorItem:Indicator in indicatorList)
							{
								obj[indicatorItem.id] = "";
								
								for each (var paIndicator:Indicator in paItem.indicatorList)
								{
									if(indicatorItem.id == paIndicator.id)
									{
										obj[indicatorItem.id]=paIndicator.indicatorLevelForSecurityMeasureToStirng;
									}
								}
								
							}
							col.addItem( obj );
						}
							
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructActionPlanColumnList(indicatorList),col));
							baseString = removeMarker(baseString,Constants.MARKER_PLAN_ACTION);
							break
						
						case Constants.MARKER_RISQUE_RESIDUEL:
							
							trace(Constants.MARKER_RISQUE_RESIDUEL);
							sqlStatement.clearParameters();
							var residualRisk:RiskService = new RiskService(null);
							sqlStatement.text=residualRisk.builResidualRiskForDelivrable();
							execStatement(sqlStatement);
							
							var residualRiskList:ArrayCollection=residualRisk.constructResidualRiskForDelivrable(sqlStatement.getResult());
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructResidualRiskColumnList(),residualRiskList));
							baseString = removeMarker(baseString,Constants.MARKER_RISQUE_RESIDUEL);
							break
						
						
						case Constants.MARKER_MATRICE_MESURE_RISQUE:
							
							trace(Constants.MARKER_MATRICE_MESURE_RISQUE);
							
							sqlStatement.clearParameters();
							var msService:SecurityMeasureService = new SecurityMeasureService(null);
							sqlStatement.text=msService.buildSecurityMeasureByRiskQuery();
							execStatement(sqlStatement);
							
							var securityMeasureList:ArrayCollection=msService.constructSecurityMesureByRiskList(sqlStatement.getResult());
							
							sqlStatement.clearParameters();
							var riskService:RiskService = new RiskService(null);
							sqlStatement.text=riskService.buildRiskFromMeasureQuery();
							execStatement(sqlStatement);
							
							var riskList:ArrayCollection=riskService.buildRiskFromMeasureList(sqlStatement.getResult());
							
							var col:ArrayCollection = new ArrayCollection();
							
							for each (var msItem:SecurityMeasure in securityMeasureList) 
							{
								var obj:Object = new Object();
								obj.label=msItem.label;
							
								for each (var riskItem:Risk in riskList)
								{
									obj[riskItem.id] = "";
								
									for each (var msRisk:Risk in msItem.riskList)
									{
										if(riskItem.id == msRisk.id)
										{
											obj[riskItem.id]= "x";
										}
									}
								
								}
								col.addItem( obj );
							}
							
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructMeasureByRiskColumnList(riskList),col));
							baseString = removeMarker(baseString,Constants.MARKER_MATRICE_MESURE_RISQUE);
							break
						
						
						case Constants.MARKER_MESURES:
							
							trace(Constants.MARKER_MESURES);
							
							sqlStatement.clearParameters();
							var ms:SecurityMeasureService = new SecurityMeasureService(null);
							sqlStatement.text=ms.constructSecurityMeasureLightQuery();
							execStatement(sqlStatement);
							
							var securityMeasureList:ArrayCollection=ms.constructSecurityMesureLightList(sqlStatement.getResult());
							
							sqlStatement.clearParameters();
							var indicator:IndicatorService = new IndicatorService(null);
							sqlStatement.text=indicator.constructIndicatorQuery();
							execStatement(sqlStatement);
							
							var indicatorList:ArrayCollection=indicator.formatIndicatorResult(sqlStatement.getResult());
							
							sqlStatement.clearParameters();
							var defence:DefenceLineService = new DefenceLineService(null);
							sqlStatement.text=defence.constructDefenceLineQuery();
							execStatement(sqlStatement);
							
							var defenceList:ArrayCollection=defence.constructDefenceLineList(sqlStatement.getResult());
							
							var col:ArrayCollection = new ArrayCollection();
							
							for each (var msItem:SecurityMeasure in securityMeasureList) 
							{
								var obj:Object = new Object();
								obj.label=msItem.label;
								obj.securityMeasureTypeToString=msItem.securityMeasureTypeToString;
								obj.supportingAssetListToString=msItem.supportingAssetListToString;
								obj.managerToString=msItem.managerToString;
								
								for each (var indicItem:Indicator in indicatorList)
								{
									obj['i' + indicItem.id] = "";
									
									for each (var msIndicator:Indicator in msItem.indicatorList)
									{
										if(indicItem.id == msIndicator.id)
										{
											obj['i' + indicItem.id]=msIndicator.indicatorLevelForSecurityMeasure.label;
										}
									}
									
								}
								
								for each (var defenceItem:DefenceLine in defenceList)
								{
									obj['d' + defenceItem.id] = "";
									
									for each (var msDefence:DefenceLine in msItem.defenceLineList)
									{
										if(defenceItem.id == msDefence.id)
										{
											obj['d' + defenceItem.id]= "x";
										}
									}
									
								}
								
								col.addItem( obj );
							}
							
							documentBody.appendChild(OpenXMLUtil.createOpenXMLTable(constructMesureColumnList(defenceList,indicatorList),col));
							baseString = removeMarker(baseString,Constants.MARKER_MESURES);
							break
								
								
								
								
								
								
								
								
								
				//************************************************************************************************************************************				
							
						
						default:
							
							/*
							//soi typeOfNextMarker à retourné une balise qui ne correspond à aucun cas géré dans notre switch case
							//soi typeOfNextMarker à retourné une chaine vide => il n'y pas de prochain type de balise, le traitement est terminé.
							
							//Les caractère retour chariot et espace or balise ne sont pas considérés comme des erreurs, par contre tous les autres caractères le sont,
							//Cela n'empêche pas la génération mais un message d'avertissement sera affiché: Attention tous les textes or balise seront ignorés...
							
							var filterResidualStr:String;
							
							var patternEnter:RegExp =/\n/g;

							var patternSpace:RegExp =/ /g;
							
							//On retire tous les retours chariots entre les balises
							filterResidualStr =  baseString.replace(patternEnter,"");
							//On retire tous les espaces entre les balises
							filterResidualStr =  filterResidualStr.replace(patternSpace,"");
							
							if(filterResidualStr.length>0)
							{
								openXMLServiceResultVO.statut = OpenXMLServiceResultVO.SUCCES_WITH_WARNING;
								openXMLServiceResultVO.helpToFindError = filterResidualStr;
							}
							else
							{
								openXMLServiceResultVO.statut = OpenXMLServiceResultVO.SUCCES;
							}
							*/
							//Il n'y a plus texte balisé à traiter => baseString = "" Nous fait sortir du TANT QUE baseString.length>1
							openXMLServiceResultVO.statut = OpenXMLServiceResultVO.SUCCES;
							baseString = "";
					}
	
				}
			}
			catch(e:Error) 
			{
				trace("ERROR OPENXML GENERATION "+e.toString());
				openXMLServiceResultVO.statut = OpenXMLServiceResultVO.ERROR;
			}
			openXMLServiceResultVO.xml = xml;
			responder.result(openXMLServiceResultVO);
		}
		
		private function constructWSColumnList(columnsToDisplay:ArrayCollection):ArrayCollection{
			
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'workingstructure.list.header.action'),"actionFullLabel"));
			
			for (var i:int = 0; i < columnsToDisplay.length; i++){
				var people:People = columnsToDisplay.getItemAt(i) as People;
				
				listColumn.addItem(new ColumnOpenXml(people.fullName,people.id));
			}
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'workingstructure.list.header.deliverable'),"deliverableLabel"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'workingstructure.list.header.intruction'),"instruction"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'workingstructure.list.header.worload'),"workload"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'workingstructure.list.header.duration'),"duration"));
			
			return listColumn;
		}
		
		private function constructParameterColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'parameter.list.grid.column1'),"libelle"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'parameter.list.grid.column2'),"parameterTypeToString"));
			
			return listColumn;
		}
		
		private function constructThreatSourceColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatSourceType.list.header.threatsourcetype'),"label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatSourceType.list.header.threatsource'),"threatSourceListToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatSourceType.list.header.retained'),"retainedToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatSourceType.list.header.justification'),"justification"));
			
			return listColumn;
		}
		
		private function constructSecurityCriteriaColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.securityCriteria.label'),"libelle"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.securityCriteria.definition'),"definition"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.securityCriteria.level'),"level"));
			
			return listColumn;
		}
		
		private function constructGravityLevelColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'gravityLevel.grid.column2'),"order"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'gravityLevel.grid.column3'),"description"));
			
			return listColumn;	
		}
		
		private function constructLikelihoodLevelColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'likelihoodLevel.grid.column2'),"order"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'likelihoodLevel.grid.column3'),"description"));
			
			return listColumn;	
		}
		
		private function constructActionColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'actionregle.list.header.action'),"libelleWithActionNumber"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'actionregle.list.header.regle'),"regle_libelle"));
			
			return listColumn;	
		}
		
		private function constructBEColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'primaryasset.list.header.primaryasset'),"libelle"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'primaryasset.list.header.depositary'),"depositaryToString"));
			
			return listColumn;
		}
		
		private function constructBSColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.supportAssets.title'),"label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.supportAssets.fullName'),"proprietaireToString"));
			
			return listColumn;
		}
		
		private function constructBEBSColumnList(columnsToDisplay:ArrayCollection):ArrayCollection{
			
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'linksbetweenassets.list.header.supportingasset'),"label"));
			
			for (var i:int = 0; i < columnsToDisplay.length; i++){
				var primaryAsset:PrimaryAsset = columnsToDisplay.getItemAt(i) as PrimaryAsset;
				
				listColumn.addItem(new ColumnOpenXml(primaryAsset.libelle,primaryAsset.id));
			}
			
			return listColumn;
		}
		
		private function constructMesureColumnList(columnsToDisplay:ArrayCollection,columnsDisplay:ArrayCollection):ArrayCollection{
		
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'securitymeasure.list.header.label'),"label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'securitymeasure.list.header.securitymeasuretype'),"securityMeasureTypeToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'securitymeasure.list.header.supportingasset'),"supportingAssetListToString"));
		
			for (var i:int = 0; i < columnsToDisplay.length; i++){
				var defence:DefenceLine = columnsToDisplay.getItemAt(i) as DefenceLine;
		
				listColumn.addItem(new ColumnOpenXml(defence.label,defence.export_id));
			}
		
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'securitymeasure.list.header.people'),"managerToString"));
		
			for (var j:int = 0; j < columnsDisplay.length; j++){
				var indicator:Indicator = columnsDisplay.getItemAt(j) as Indicator;
		
				listColumn.addItem(new ColumnOpenXml(indicator.libelle,indicator.export_id));
			}
		
			return listColumn;
		}
		
		private function constructERColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'fearedEvent.list.header.primaryAsset'),"primaryAssetToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'fearedEvent.list.header.securityCriteria'),"securityCriteriaToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'fearedEvent.list.header.securityNeed'),"securityNeedToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'fearedEvent.list.header.threatSourceList'),"threatSourceListToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'fearedEvent.list.header.impact'),"impactListToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'fearedEvent.list.header.gravityLevel'),"gravityLevelToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'fearedEvent.list.header.justification'),"justification"));
			
			return listColumn;
			
		}
		
		private function constructErEvalColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'fearedEvent.listfearedEventByGravity'),"label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'fearedEvent.list.header.gravityLevel'),"gravityLevelToString"));
			
			return listColumn;
		}
		
		private function constructSMColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.header.assetSupport'),"supportingAssetToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.header.criteria'),"securityCriteriaToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.header.threatSource'),"threatSourceListToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.header.vulnerability'),"vulnerabilityListListToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.header.prerequisites'),"requirementListToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.header.threat'),"threatListToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.header.likelihoodLevel'),"likelihoodLevelToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.header.justification'),"justification"));

			return listColumn;
		}
		
		private function constructEvalSMColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.title'),"label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'threatScenario.list.header.likelihoodLevel'),"likelihoodLevelToString"));
			
			return listColumn;
		}
		
		private function constructRiskColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.shortLabel'),"short_label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.longLabel'),"long_label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.securityCriteria'),"securityCriterialibelle"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.primaryAsset'),"primaryAssetLibelle"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.fearedEvent'),"fearedEventToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.threatScenario'),"threatScenarioListToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.supportingAsset'),"supportingAssetListToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.securityMeasure'),"securityMeasureListForDelivrableToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.gross_gravity'),"gross_gravityToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.gross_likelihood'),"gross_likelihoodToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.gravityME'),"gravityMEToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.likelihoodME'),"likelihoodMEToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.gravityMC'),"gravityMCToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.likelihoodMC'),"likelihoodMCToString"));
			
			return listColumn;	
		}
		
		private function constructCartoRiskColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.shortLabel'),"short_label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.longLabel'),"long_label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.gross_gravity'),"gross_gravityToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.gross_likelihood'),"gross_likelihoodToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.gravityME'),"gravityMEToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.risk.likelihoodME'),"likelihoodMEToString"));
			
			return listColumn;	
		}
		
		private function constructOptColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'risktreatementoption.list.header.label'),"short_label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'risktreatementoption.list.header.securityobjective'),"objectiveToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'risktreatementoption.list.header.comment'),"objectiveComment"));
			
			return listColumn;
		}
		
		private function constructDecAppColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'applicabilitydeclaration.list.header.type'),"parameterTypeToString"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'applicabilitydeclaration.list.header.parameters'),"libelle"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'applicabilitydeclaration.list.header.justification'),"justification"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'applicabilitydeclaration.list.header.state'),"statusToString"));
			
			return listColumn;
		}
		
		private function constructActionPlanColumnList(columnsToDisplay:ArrayCollection):ArrayCollection{
			
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'actionplan.grid.header.security.measure'),"label"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'actionplan.grid.header.manager'),"managerToString"));
			
			for (var i:int = 0; i < columnsToDisplay.length; i++){
				var indicator:Indicator = columnsToDisplay.getItemAt(i) as Indicator;
				
				listColumn.addItem(new ColumnOpenXml(indicator.libelle,indicator.id));
			}
			
			return listColumn;
		}
		
		private function constructResidualRiskColumnList():ArrayCollection
		{
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.residualRisk.residualRisk'),"residualRiskLabel"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.residualRisk.fearedEvent'),"fearedEventLabel"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.residualRisk.threatScenario'),"threatScenarioLabel"));
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.residualRisk.securityMeasure'),"securityMeasureLabel"));
			
			return listColumn;	
		}
		
		private function constructMeasureByRiskColumnList(columnsToDisplay:ArrayCollection):ArrayCollection{
			
			var listColumn:ArrayCollection = new ArrayCollection();
			
			listColumn.addItem(new ColumnOpenXml(ResourceManager.getInstance().getString('resources', 'export.list.securityMeasure.title'),"label"));
			
			for (var i:int = 0; i < columnsToDisplay.length; i++){
				var risk:Risk = columnsToDisplay.getItemAt(i) as Risk;
				
				listColumn.addItem(new ColumnOpenXml(risk.short_label,risk.id));
			}
			
			return listColumn;
		}
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		/**
		 * 
		 * ===============================================================================
		 * ******************METHODE UTILES***********************************************
		 * ===============================================================================
		 * 
		 **/
		
		
		
		

	
		/**
		 * 
		 * @param str la chaine dans laquel on recherche
		 * @param openMarkerTypeArray Liste des balise ouvrantes
		 * @retur nom de la première balise ouvrante dans le texte passé en paramêtre
		 * On recherche toutes les balises dans la chaine, retourne celle don la position est la plus faible.
		 * 
		 **/
		private static function typeOfNextMarker(str:String,openMarkerTypeArray:Array):String
		{
			var findIndex:int = str.length; //Le plus grand au départ
			var typeOfNextMarker:String;
			
			for each (var openMarker:String in openMarkerTypeArray)
			{
				if(str.indexOf(openMarker)<findIndex && str.indexOf(openMarker)!=-1)
				{
					findIndex = str.indexOf(openMarker);
					typeOfNextMarker = openMarker;
				}
			}
			return typeOfNextMarker;
		}
		
		/**
		 * 
		 * @param str la chaine dans laquel on recherche
		 * @param openMarker la balise ouvrante
		 * @param closeMarker la balise fermante
		 * @return si str = <openMarker>hello<closeMarker> la fontion retourne hello
		 * Si la chaine contient plusieurs foi les balises <openMarker> et <closeMarker>, la fonction retourne la valeur du premier couple trouvé
		 * 
		 **/
		private static function findMarkerValue(str:String, openMarker:String,closeMarker:String):String
		{
			
		
			var startIndex:int = str.indexOf(openMarker) + openMarker.length;
			var endIndex:int = str.indexOf(closeMarker, startIndex);
			
			var result:String = str.substr(startIndex,(endIndex-startIndex));
			
			return result;
		}
		
		private function trimWhiteSpace():void
		{
			
		}

		
		private static function removeMarker(str:String, openMarker:String,closeMarker:String=null):String
		{
			var startIndex:int = str.indexOf(openMarker);
			
			var endIndex:int
			
			if(closeMarker!=null)
			{
				endIndex = str.indexOf(closeMarker, startIndex)+closeMarker.length;
			}
			else
			{
				endIndex = str.indexOf(openMarker)+openMarker.length;
			}
			
			var partToRemove:String = str.substr(startIndex,(endIndex-startIndex));
			
			return str.replace(partToRemove,"");
			
		}

	}
}