package com.anssi.ebios.services
{
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.model.People;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;
	
	import org.springextensions.actionscript.context.support.XMLApplicationContext;
	
	public class PeopleService extends AppServices
	{
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement; 
		private var _people:People;
		
		public function PeopleService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		/** ******* PUBLIC SERVICE METHODE ******** **/
		
		public function getPeople():void
		{
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT * FROM PERSONNE";
			_sqlStatement.text = query;	
			_sqlStatement.addEventListener(SQLEvent.RESULT,getPeopleResult);
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		public function getPeopleById(id:Number):void
		{
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = 
				
				"SELECT *  " +
				" FROM PERSONNE" +
				" WHERE PERSONNE.idPERSONNE=\""+id+"\"";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getPeopleByIdResult);
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		
		public function deletePeople(people:People):void
		{
			
			_people = people;
			
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			// OUVERTURE DE LA CONNEXION
			openInSyncMode(_sqlStatement);

			// BE - MISE A NULL DES CHAMPS DEPOSITAIRES
			var queryUpdateBE:String = "UPDATE BE SET DEPOSITAIRE=NULL WHERE DEPOSITAIRE=:idPERSONNEToDelete;";
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":idPERSONNEToDelete"] = people.id;
			_sqlStatement.text = queryUpdateBE;
			execStatement(_sqlStatement);
			
			// BS - MISE A NULL DES CHAMPS PROPRIETAIRES
			var queryUpdateBS:String = "UPDATE BS SET PROPRIETAIRE=NULL WHERE PROPRIETAIRE=:idPERSONNEToDelete;";
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":idPERSONNEToDelete"] = people.id;
			_sqlStatement.text = queryUpdateBS;
			execStatement(_sqlStatement);
			
			_sqlStatement.clearParameters();
			// FERMETURE DE LA CONNEXION SYNCHRONE
			_sqlStatement.sqlConnection.close();
			
			// BE & BS - MAJ DES XML
			var ac:XMLApplicationContext = XMLApplicationContext(AppModelLocator.getInstance().getAttribute("applicationContext"));
			var primaryAssetService:PrimaryAssetService = ac.getObject("primaryAssetService", [null]) as PrimaryAssetService;
			primaryAssetService.deletePeopleHandler(people.id);
			
			var supportAssetService:SupportAssetService = ac.getObject("supportAssetService", [null]) as SupportAssetService;
			supportAssetService.deletePeopleHandler(people.id);
			
			
			// OUVERTURE DE LA CONNEXION
			openInSyncMode(_sqlStatement);
			
			// PARTICIPER - SUPPRESSION DES DONNEES AYANT IDPERSONNE
			var queryDelParticiper:String = "DELETE FROM PARTICIPER WHERE idPERSONNE = :idPERSONNEToDelete";
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":idPERSONNEToDelete"] = people.id;
			_sqlStatement.text = queryDelParticiper;
			execStatement(_sqlStatement);
			
			// MESURE - MISE A NULL DU CHAMP IDPERSONNE
			var queryUpdateMESURE:String = "UPDATE MESURE SET idPERSONNE = NULL WHERE idPERSONNE = :idPERSONNEToDelete";
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":idPERSONNEToDelete"] = people.id;
			_sqlStatement.text = queryUpdateMESURE;
			execStatement(_sqlStatement);
			
			// SUPPRESSION DE LA PERSONNE
			var query:String = 
				"DELETE FROM PERSONNE " +
				" WHERE PERSONNE.idPERSONNE=\""+people.id+"\"";
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			deletePeopleResult(null);
		}
		
		public function updatePeople(people:People):void
		{
			setBDDName();
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String =
				
				"UPDATE  PERSONNE " +
				" SET prenom= :first_name ," +
				" nom= :last_name ," +
				" fonction= :function_title ," +
				" telephone= :phone ," +
				" adresseElectronique= :email ," +
				" adresseGeographique= :adress ," +
				" dateModification = :dateModification " +
				" WHERE PERSONNE.idPERSONNE= :id";
			
			
			_sqlStatement.parameters[":id"] = people.id;
			_sqlStatement.parameters[":first_name"] = people.first_name;
			_sqlStatement.parameters[":last_name"] = people.last_name;
			_sqlStatement.parameters[":function_title"] = people.function_title;
			_sqlStatement.parameters[":phone"] = people.phone;
			_sqlStatement.parameters[":email"] = people.email;
			_sqlStatement.parameters[":adress"] = people.adress;
			_sqlStatement.parameters[":dateModification"] = new Date();
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,updatePeopleResult);
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		/** ******* PRIVATE HANDLER ******** **/
		
		private function getPeopleResult(event:SQLEvent):void
		{
			var peopleList:ArrayCollection = new ArrayCollection();
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			if (result != null && result.data != null)
			{
				
				
				var row:Object;
				var numRows:int = result.data.length;
				var people:People;
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					people = new People();	
					people.id = row["idPERSONNE"];
					people.first_name = row["prenom"];
					people.last_name = row["nom"];
					people.function_title = row["fonction"];
					
					people.phone = row["telephone"];
					people.adress = row["adresseGeographique"];
					people.email = row["adresseElectronique"];
					
					peopleList.addItem(people);
				}
			}
			_sqlStatement.sqlConnection.close();
			responder.result(peopleList);
		}
		
		public function createPeople(people:People):void
		{
			setBDDName();
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = 
				
				"INSERT INTO PERSONNE ( prenom, nom, fonction, telephone, adresseElectronique, adresseGeographique, participe, dateCreation, dateModification) "+
				"VALUES (:first_name, :last_name, :function_title, :phone, :email, :adress, true, :dateCreation, :dateModification)";

			
			_sqlStatement.parameters[":first_name"] = people.first_name;
			_sqlStatement.parameters[":last_name"] = people.last_name;
			_sqlStatement.parameters[":function_title"] = people.function_title;
			_sqlStatement.parameters[":phone"] = people.phone;
			_sqlStatement.parameters[":email"] = people.email;
			_sqlStatement.parameters[":adress"] = people.adress;
			_sqlStatement.parameters[":dateCreation"] = new Date();
			_sqlStatement.parameters[":dateModification"] = new Date();

				
			_sqlStatement.text = query;
			
			
			
			_sqlStatement.addEventListener(SQLEvent.RESULT,createPeopleResult);
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		
		private function getPeopleByIdResult(event:SQLEvent):void
		{
			var result:SQLResult = SQLStatement(event.target).getResult();
			if (result != null && result.data != null)
			{
				var row:Object= result.data[0];
				var people:People = new People();
				people.id = row["idPERSONNE"]
				people.first_name= row["prenom"]
				people.last_name= row["nom"]
				people.function_title= row["fonction"]
				people.phone= row["telephone"]
				people.email= row["adresseElectronique"]
				people.adress= row["adresseGeographique"]
			}
			_sqlStatement.sqlConnection.close();
			responder.result(people);
		}
		
		private function createPeopleResult(event:SQLEvent):void
		{

			var result:SQLResult = SQLStatement(event.target).getResult();
			
			var primaryKey:Number;
			if (result != null)
			{
				primaryKey = result.lastInsertRowID;
			}
			_sqlStatement.sqlConnection.close();
			responder.result(primaryKey);
		}
		
		private function deletePeopleResult(event:SQLEvent):void
		{
			unaffectPeopleFromWorkStructure();
		}
		
		private function unaffectPeopleFromWorkStructure():void{
			setBDDName();
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = 
				
				"DELETE FROM PARTICIPER " +
				" WHERE PARTICIPER.idPERSONNE=\""+_people.id+"\"";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,unaffectPeopleFromWorkStructureResult);
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		
		private function unaffectPeopleFromWorkStructureResult(event:SQLEvent):void{
			_sqlStatement.sqlConnection.close();
			responder.result(null);
		}
		
		private function updatePeopleResult(event:SQLEvent):void
		{
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			var primaryKey:Number;
			primaryKey = SQLStatement(event.target).parameters[":id"];
			
			_sqlStatement.sqlConnection.close();
			responder.result(primaryKey);
		}
		
		public function getRetainedPeople():void{
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = constructRetainedPeopleQuery();
				
			
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getRetainedPeopleResult);
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		
		public function constructRetainedPeopleQuery():String{
			return 	"SELECT *  " +
				" FROM PERSONNE" +
				" WHERE PERSONNE.participe = true";
		}
		
		private function getRetainedPeopleResult(event:SQLEvent):void{
			var peopleList:ArrayCollection = new ArrayCollection();
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			if (result != null && result.data != null)
			{				
				peopleList = constructRetainedPeopleList(result);
			}
			_sqlStatement.sqlConnection.close();
			responder.result(peopleList);
		}
		
		
		public function constructRetainedPeopleList(result:SQLResult):ArrayCollection{
			var row:Object;
			
			var people:People;
			var peopleList:ArrayCollection = new ArrayCollection();
			if(result.data){
			var numRows:int = result.data.length;
			
			for (var i:int = 0; i < numRows; i++)
			{
				row = result.data[i];
				people = new People();	
				people.id = row["idPERSONNE"];
				people.first_name = row["prenom"];
				people.last_name = row["nom"];
				people.function_title = row["fonction"];
				
				peopleList.addItem(people);
			}
			}
			return peopleList;
		}
		
		private var _peopleList:ArrayCollection;
		private var _indexToUpdate:Number = -1;
		
		
		/**
		 * 
		 * La méthode affectPeopleToStudy gère les opérations suivantes: 
		 *  
		 * clearAffectation
		 * affectPeople -->Recursif
		 *
		 **/
		public function affectPeopleToStudy(peopleList:ArrayCollection):void
		{
			_peopleList = peopleList;
			clearAffectation();
		}
		private function clearAffectation():void
		{
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = 
				
				"UPDATE  PERSONNE  "+
				" SET participe = 0, dateModification = :dateModification ";
			
			_sqlStatement.text = query;
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":dateModification"] = new Date();
			
			_sqlStatement.addEventListener(SQLEvent.RESULT,clearAffectationResult);
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
	
		private function clearAffectationResult(event:SQLEvent):void
		{
			affectPeople( _peopleList );
		}
		
		private function affectPeople(peopleList:ArrayCollection):void
		{
			if(peopleList)
				_peopleList = peopleList;
			
			_indexToUpdate ++
			if (_indexToUpdate >= _peopleList.length ) {
				
				_indexToUpdate = -1;
				_sqlStatement.sqlConnection.close();
				
				responder.result(1);
				return;
			}
			
			
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			
			var people:People = _peopleList.getItemAt(_indexToUpdate) as People;
			
			var sql:String;
			
			sql = 
				
				"UPDATE  PERSONNE " +
				" SET participe= :participe , dateModification = :dateModification " +
				" WHERE PERSONNE.idPERSONNE= :id";
			
			
			_sqlStatement.text = sql;
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":participe"] = true;
			_sqlStatement.parameters[":id"] =people.id;
			_sqlStatement.parameters[":dateModification"] = new Date();
			
			_sqlStatement.addEventListener(SQLEvent.RESULT,affectPeopleToStudyResult);
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function affectPeopleToStudyResult(event:SQLEvent):void
		{
			affectPeople(null);
		}
	}
}