package com.anssi.ebios.services
{
	import com.anssi.ebios.model.People;
	import com.anssi.ebios.model.PrimaryAsset;
	import com.anssi.ebios.model.PrimaryAssetLight;
	import com.anssi.ebios.model.SupportAssetType;
	import com.anssi.ebios.model.SupportingAsset;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class PrimaryAssetService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement; 
		
		public function PrimaryAssetService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
	
		/***************************************************/
		/** Récupération de la liste des biens essentiels **/
		/***************************************************/
		public function getPrimaryAssetList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = constructPrimaryAssetQuery('WHERE retenu = true');
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getgetPrimaryAssetListListResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function getgetPrimaryAssetListListResult(event:SQLEvent):void{
			var primaryAssetList:ArrayCollection = new ArrayCollection();
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				primaryAssetList = constructPrimaryAssetList(result);
			}
			_sqlStatement.sqlConnection.close();
			responder.result(primaryAssetList);		
		}
		
		public function constructPrimaryAssetQuery(WHERECondition:String = " "):String{
			return "SELECT BE.idBE as idBE, BE.libelle as libelle, BE.depositaire as idPERSONNE, PERSONNE.nom as nom, PERSONNE.prenom as prenom " +
				" FROM BE " +
				" LEFT OUTER JOIN PERSONNE on BE.depositaire = PERSONNE.idPERSONNE " + WHERECondition;
		}
		
		public function constructPrimaryAssetList(result:SQLResult):ArrayCollection{
			var row:Object;
			
			var primaryAssetList:ArrayCollection = new ArrayCollection();
			if(result.data){
				var numRows:int = result.data.length;
				var primaryAsset:PrimaryAsset = null;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					primaryAsset = new PrimaryAsset();
					primaryAsset.id = row["idBE"];
					primaryAsset.libelle= row["libelle"];
					
					if (row["idPERSONNE"] != null && row["idPERSONNE"] > -1 ){
						var people:People = new People();
						people.id = row["idPERSONNE"];
						people.first_name = row["nom"];
						people.last_name = row["prenom"];
						primaryAsset.depositaire = people;
					}
	
					primaryAssetList.addItem(primaryAsset);
				}
			}
			return primaryAssetList;
		}
		
		
		
		public function getPrimaryAssetsXML():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT b.xml as beXML FROM BE_POSITIONS b WHERE b.idBEPOSITIONS=1" ;
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getPrimaryAssetsXMLResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function getPrimaryAssetsXMLResult(event:SQLEvent):void{
			var bePositions:XML = null;
			
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			// si nous avons des résultats
			if (result != null && result.data != null){
				var row:Object;
				var numRows:int = result.data.length;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					trace('beXML:'+row["beXML"]);
					bePositions = XML(row["beXML"]);
				}
			}
			_sqlStatement.sqlConnection.close();
			responder.result(bePositions);	
		}
		

		public function savePrimaryAssets(bePositions:XML):void{
			// TODO : MAJ de la table BE
			
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			// OUVERTURE DE LA CONNEXION
			openInSyncMode(_sqlStatement);
			
			//trace("XML reçu en param:"+bePositions.toXMLString());
			
			
			
			// Y A-T-IL DES ENTITES ?
			var strSQLEntitiesIds:String = null;
			if(bePositions.entities.children() != null && bePositions.entities.children().length() > 0){

				// ID A METTRE A JOUR
				var entitiesIds:Array = new Array();
				for each (var xmlEntity:XML in bePositions.entities.children()){
					//trace("xmlEntity:"+xmlEntity.toXMLString());
					if(xmlEntity.@id != "-1") entitiesIds[entitiesIds.length] = xmlEntity.@id;
				}

				if(entitiesIds.length > 0){
					strSQLEntitiesIds = "";
					var i:Number = 0;
					for each (var strId:String in entitiesIds){
						if(i < entitiesIds.length-1) strSQLEntitiesIds += strId+", ";
						else strSQLEntitiesIds += strId;
						i++;
					}
				}
			}
			
			/** BE : SUPPRESSION DES ANCIENS BE DE LA BDD **/
			// on récupère les BE qui existent en BDD mais qui ne sont pas dans notre XML
			var query:String = "";
			if(strSQLEntitiesIds != null) query = "SELECT * FROM BE WHERE idBE NOT IN ("+strSQLEntitiesIds+")";
			else query = "SELECT * FROM BE ";
			
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			
			var resultDelete:SQLResult = _sqlStatement.getResult();
			// si nous avons des résultats
			if (resultDelete != null && resultDelete.data != null){
				var row:Object;
				var numRows:int = resultDelete.data.length;
				
				for (var j:int = 0; j < numRows; j++)
				{
					row = resultDelete.data[j];
					trace("DELETE BE:"+row["idBE"]);
					
					// SUPPRESSION DES RESULTATS LA TABLE ENGENDRER
					var query:String = "DELETE FROM ENGENDRER WHERE idBE=:idBEToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBEToDelete"] = row["idBE"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete engendrer:"+query);
					
					// SUPPRESSION DES RESULTATS LA TABLE CROISER
					var query:String = "DELETE FROM CROISER WHERE idBE=:idBEToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBEToDelete"] = row["idBE"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete croiser:"+query);
					
					// SUPPRESSION DES RESULTATS LA TABLE INITIER
					var query:String = "DELETE FROM INITIER WHERE idBE=:idBEToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBEToDelete"] = row["idBE"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete initier:"+query);
					
					// SUPPRESSION DES RESULTATS LA TABLE CONTRIBUER
					var query:String = "DELETE FROM CONTRIBUER " +
						"WHERE EXISTS (" +
						"	SELECT 1" +
						"	FROM RISQUE r" +
						"	WHERE r.idRISQUE=CONTRIBUER.idRISQUE" +
						"	AND EXISTS (" +
						"		SELECT 1      " +
						"		FROM ER e      " +
						"		WHERE e.idBE=:idBEToDelete" +
						"		AND e.idER=r.idER " +
					"		)" +
					"	)";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBEToDelete"] = row["idBE"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete contribuer:"+query);
					
					// SUPPRESSION DES RESULTATS LA TABLE COMPOSER
					var query:String = "DELETE FROM COMPOSER " + 
						"WHERE EXISTS (" +
						"	SELECT 1" +
						"	FROM RISQUE r" +
						"	WHERE r.idRISQUE=COMPOSER.idRISQUE" +
						"	AND EXISTS (" +
						"		SELECT 1      " +
						"		FROM ER e      " +
						"		WHERE e.idBE=:idBEToDelete" +
						"		AND e.idER=r.idER " +
					"		)" +
					"	)";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBEToDelete"] = row["idBE"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete composer:"+query);

					
					// SUPPRESSION DES RESULTATS LA TABLE RISQUE
					var query:String = "DELETE FROM RISQUE" +
						"	WHERE EXISTS (" +
						"		SELECT 1      " +
						"		FROM ER e      " +
						"		WHERE e.idBE=:idBEToDelete" +
						"		AND e.idER=RISQUE.idER " +
						"		)" ;
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBEToDelete"] = row["idBE"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete risque:"+query);
					
					// SUPPRESSION DES RESULTATS LA TABLE ER
					var query:String = "DELETE FROM ER WHERE idBE=:idBEToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBEToDelete"] = row["idBE"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete er:"+query);
					
					
					// SUPPRESSION DU BE
					var query:String = "DELETE FROM BE WHERE idBE=:idBEToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBEToDelete"] = row["idBE"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
				}
			}
				
				
			/** BE : MAJ **/
			if(bePositions.entities.children() != null && bePositions.entities.children().length() > 0){
				for each (var xmlEntity:XML in bePositions.entities.children()){
					//trace("xmlEntity:"+xmlEntity.toXMLString());
					if(xmlEntity.@id != "-1"){
						trace("UPDATE BE:"+xmlEntity.@id);
						var query:String = "UPDATE BE " +
							"SET libelle=:libelle, description=:description, retenu=:retenu, depositaire=:depositaire, dateModification=:dateModification " +
							"WHERE idBE=:idBE";
						_sqlStatement.text = query;
						
						
						_sqlStatement.clearParameters();
						_sqlStatement.parameters[":libelle"] = xmlEntity.@title;
						_sqlStatement.parameters[":description"] = xmlEntity.@description;
						_sqlStatement.parameters[":retenu"] = (xmlEntity.@retenu == "true")?true:false;
						_sqlStatement.parameters[":depositaire"] = xmlEntity.@depositaireid;
						_sqlStatement.parameters[":dateModification"] = new Date();
						_sqlStatement.parameters[":idBE"] = xmlEntity.@id;
						
						execStatement(_sqlStatement);
						
						// SI BE NON RETENU, ON SUPPRIME LES EVENTUELS ER ASSOCIES
						if(xmlEntity.@retenu == "false"){
							trace("BE non retenu - Suppression des ERs associés");
							// SUPPRESSION DES RESULTATS LA TABLE CONTRIBUER
							var query:String = "DELETE FROM CONTRIBUER " +
								"WHERE EXISTS (" +
								"	SELECT 1" +
								"	FROM RISQUE r" +
								"	WHERE r.idRISQUE=CONTRIBUER.idRISQUE" +
								"	AND EXISTS (" +
								"		SELECT 1      " +
								"		FROM ER e      " +
								"		WHERE e.idBE=:idBEToDelete" +
								"		AND e.idER=r.idER " +
								"		)" +
								"	)";
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBEToDelete"] = xmlEntity.@id;
							_sqlStatement.text = query;
							execStatement(_sqlStatement);
							trace("delete contribuer:"+query);
							
							// SUPPRESSION DES RESULTATS LA TABLE COMPOSER
							var query:String = "DELETE FROM COMPOSER " + 
								"WHERE EXISTS (" +
								"	SELECT 1" +
								"	FROM RISQUE r" +
								"	WHERE r.idRISQUE=COMPOSER.idRISQUE" +
								"	AND EXISTS (" +
								"		SELECT 1      " +
								"		FROM ER e      " +
								"		WHERE e.idBE=:idBEToDelete" +
								"		AND e.idER=r.idER " +
								"		)" +
								"	)";
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBEToDelete"] = xmlEntity.@id;
							_sqlStatement.text = query;
							execStatement(_sqlStatement);
							trace("delete composer:"+query);
							
							
							// SUPPRESSION DES RESULTATS LA TABLE RISQUE
							var query:String = "DELETE FROM RISQUE" +
								"	WHERE EXISTS (" +
								"		SELECT 1      " +
								"		FROM ER e      " +
								"		WHERE e.idBE=:idBEToDelete" +
								"		AND e.idER=RISQUE.idER " +
								"		)" ;
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBEToDelete"] = xmlEntity.@id;
							_sqlStatement.text = query;
							execStatement(_sqlStatement);
							trace("delete risque:"+query);
							
							// SUPPRESSION DES RESULTATS LA TABLE ER
							var query:String = "DELETE FROM ER WHERE idBE=:idBEToDelete";
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBEToDelete"] = xmlEntity.@id;
							_sqlStatement.text = query;
							execStatement(_sqlStatement);
							trace("delete er:"+query);
						}
						// SINON, SI BE RETENU, ON CREE LES ER SI CE N'EST PAS DEJA FAIT
						else{
							trace("BE retenu / INSERT ERs pour le BE si n'existe pas déjà  "+xmlEntity.@id);
							var query:String = "INSERT INTO ER (libelle, idCRITERE, idBE, dateCreation, dateModification)  " +
								"SELECT (\""+(""+xmlEntity.@title as String).replace("'","").replace("\"","")+"\" || \" - \" || c.libelle), c.idCRITERE, :idBE, date('now'), date('now')  " +
								"FROM CRITERE as c " +
								"WHERE NOT EXISTS (" +
								" SELECT 1 " +
								"	FROM ER e " +
								"	WHERE e.idBE=:idBE " +
								"	AND e.idCRITERE=c.idCRITERE " +
								");";
							_sqlStatement.text = query;
							
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBE"] = xmlEntity.@id;
							execStatement(_sqlStatement);
							trace("insert ERs:"+query);
						}
						
						
						
						
					}
				}
			}
			
			
			/** BE : CREATION **/
			if(bePositions.entities.children() != null && bePositions.entities.children().length() > 0){
				for each (var xmlEntity:XML in bePositions.entities.children()){
					//trace("xmlEntity:"+xmlEntity.toXMLString());
					if(xmlEntity.@id == "-1"){
						trace("INSERT BE "+xmlEntity.@title);
						// INSERTION DANS LA TABLE BE
						var query:String = "INSERT INTO BE (libelle, description, retenu, depositaire, dateCreation, dateModification) VALUES (:libelle, :description, :retenu, :depositaire, :dateCreation, :dateModification)";
						_sqlStatement.text = query;
						
						
						_sqlStatement.clearParameters();
						_sqlStatement.parameters[":libelle"] = xmlEntity.@title;
						_sqlStatement.parameters[":description"] = xmlEntity.@description;
						_sqlStatement.parameters[":retenu"] = (xmlEntity.@retenu == "true")?true:false;
						_sqlStatement.parameters[":depositaire"] = xmlEntity.@depositaireid;
						_sqlStatement.parameters[":dateCreation"] = new Date();
						_sqlStatement.parameters[":dateModification"] = new Date();
						
						execStatement(_sqlStatement);
						var resultUpdate:SQLResult = _sqlStatement.getResult();
						var lastIdBEInserted:Number = resultUpdate.lastInsertRowID;
						
						xmlEntity.@id = lastIdBEInserted;
						
						
						
						// SI BE RETENU : CREATION DES ER 
						if(xmlEntity.@retenu == "true"){
							trace("BE retenuu / INSERT ERs pour le BE "+xmlEntity.@id);
							var query:String = "INSERT INTO ER (libelle, idCRITERE, idBE, dateCreation, dateModification)  " +
								"SELECT (\""+(""+xmlEntity.@title as String).replace("'","'").replace("\"","")+"\" || \" - \" || c.libelle), c.idCRITERE, :lastIdBe, date('now'), date('now')  " +
								"FROM CRITERE as c;";
							_sqlStatement.text = query;
							
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":lastIdBe"] = lastIdBEInserted;
							execStatement(_sqlStatement);
						}
					}
				}
			}
			
			// MAJ DU XML
			//trace("XML à mettre à jour en BDD :"+bePositions.toXMLString());
			var query:String = "UPDATE BE_POSITIONS SET XML=:bePositions WHERE idBEPOSITIONS=1" ;
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":bePositions"] = bePositions.toXMLString();
			_sqlStatement.text = query;
			
			execStatement(_sqlStatement);
			
			
			
			_sqlStatement.sqlConnection.close();
			responder.result(null);	
		}
		
		public function getPrimaryAssetLightList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = " SELECT BE.idBE, BE.libelle as be_libelle, BE.description as be_description, " +
				" PERSONNE.idPERSONNE, ifnull(PERSONNE.nom,'') as personne_nom, ifnull(PERSONNE.prenom,'') as personne_prenom " +
				" FROM BE " +
				" LEFT OUTER JOIN PERSONNE ON BE.depositaire = PERSONNE.idPERSONNE " +
				" WHERE retenu = true ";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getPrimaryAssetLightListResult);
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
				
		private function getPrimaryAssetLightListResult(event:SQLEvent):void{
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			var primaryAssetLightList:ArrayCollection = new ArrayCollection();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var primaryAssetLight:PrimaryAssetLight;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					if(row["idBE"]>0){
						
						primaryAssetLight = new PrimaryAssetLight();
						primaryAssetLight.libelle = row["be_libelle"];
						primaryAssetLight.nameLabel = row["personne_nom"];
						primaryAssetLight.firstNameLabel = row["personne_prenom"];
						
						primaryAssetLightList.addItem(primaryAssetLight);
					}
				}
			}
			_sqlStatement.sqlConnection.close();
			responder.result(primaryAssetLightList);
		}
		
		
		
		
		
		
		public function deletePeopleHandler(id:String):void{

			// OUVERTURE DE LA CONNEXION
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			openInSyncMode(_sqlStatement);
			
			var query:String = "SELECT b.xml as beXML FROM BE_POSITIONS b WHERE b.idBEPOSITIONS=1";
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			
			
			var bePositions:XML = null;
			// récupération des résultats
			var result:SQLResult = _sqlStatement.getResult();
			// si nous avons des résultats
			if (result != null && result.data != null){
				var row:Object;
				var numRows:int = result.data.length;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					trace('beXML:'+row["beXML"]);
					bePositions = XML(row["beXML"]);
				}
			}
			
			
			if(bePositions != null){
				if(bePositions.entities.children() != null && bePositions.entities.children().length() > 0){
					for each (var xmlEntity:XML in bePositions.entities.children()){
						//trace("xmlEntity:"+xmlEntity.toXMLString());
						if(xmlEntity.@depositaireid == id){
							trace("UPDATE BE:"+xmlEntity.@id);
							xmlEntity.@depositaireid = -1;
						}
					}
					var query:String = "UPDATE BE_POSITIONS SET XML=:bePositions WHERE idBEPOSITIONS=1" ;
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":bePositions"] = bePositions.toXMLString();
					_sqlStatement.text = query;
					
					execStatement(_sqlStatement);
				}
			}
			
			
			
			_sqlStatement.sqlConnection.close();
		}
			
			
			
		
		/*****************************************************************************/
		/** Tableau de croisement entre les biens essentiels et les biens supports  **/
		/*****************************************************************************/
		/*public function getPrimaryAssetBySupportAssetList():void{
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			var query:String = " SELECT BE.idBE, BE.libelle as be_libelle, "
				+ " BS.idBS, BS.libelle as bs_libelle, "
				+ " TBS.idTBS, TBS.libelle as tbs_libelle "
				+ " FROM BS "
				+ " LEFT OUTER JOIN CROISER ON CROISER.idBS = BS.idBS "						 
				+ " LEFT OUTER JOIN BE ON CROISER.idBE = BE.idBE "
				+ " LEFT OUTER JOIN TBS ON TBS.idTBS = BS.idTBS ";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getPrimaryAssetBySupportAssetListResult);
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		
		private function getPrimaryAssetBySupportAssetListResult(event:SQLEvent):void{
			var result:SQLResult = SQLStatement(event.target).getResult();
			var primaryAssetBySupportAssetList:ArrayCollection = new ArrayCollection();
			if (result != null && result.data != null)
			{
				primaryAssetBySupportAssetList =  constructPrimaryAssetBySupportAssetList(result);				
			}
			_sqlStatement.sqlConnection.close();
			responder.result(primaryAssetBySupportAssetList);
		}
		
		private function constructPrimaryAssetBySupportAssetList(result:SQLResult):ArrayCollection{
			var row:Object;
			var numRows:int = result.data.length;
			
			var primaryAssetBySupportAssetList:ArrayCollection = new ArrayCollection();
			var supportingAsset:SupportingAsset;
			
			var tmpIdBE:Number;
			var tmpIdBS:Number;
			var tmpIdTBS:Number;
			
			for (var i:int = 0; i < numRows; i++)
			{
				row = result.data[i];
				
				if (tmpIdBS != row["idBS"]){
					
					tmpIdBS = row["idBS"];
					
					supportingAsset = new SupportingAsset();
					supportingAsset.id = row["idBS"];
					supportingAsset.label = row["bs_libelle"];
					
					var supportAssetType:SupportAssetType = new SupportAssetType();
					supportAssetType.id = row["idTBS"];
					supportAssetType.label = row["tbs_libelle"];
					supportAsset.ty = securityMeasureType;
					
					securityMeasure.riskList = new ArrayCollection();
					
					securityMeasureByRiskList.addItem(securityMeasure);	
				}
				
				if (tmpIdRisque != row["idRISQUE"] && ArrayCollectionTool.findIndexForId(securityMeasure.riskList, row["idRISQUE"])==-1 && row["idRISQUE"]>0){
					
					tmpIdRisque = row["idRISQUE"];
					
					var risk:Risk =new Risk();
					risk.id = row["idRISQUE"];
					risk.short_label = row["libelleCourt"];
					risk.long_label = row["libelleLong"];
					securityMeasure.riskList.addItem(risk);
				}
				
			}
			return securityMeasureByRiskList;
		}*/
	}
}