package com.anssi.ebios.services
{
	import com.anssi.ebios.model.Role;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class RoleService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		
		public function RoleService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		/****************************************/
		/** Récupération de la liste des rôles **/
		/****************************************/
		public function getRoleList():void{				
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT * FROM ROLE";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getRoleListResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}

		private function getRoleListResult(event:SQLEvent):void{
			var roleList:ArrayCollection = new ArrayCollection();
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var role:Role = null;
				
				for (var i:int = 0; i < numRows; i++)
				{					
					row = result.data[i];
					role = new Role();
					role.id = row["idROLE"];
					role.label = row["libelle"];
					role.description = row["description"];
					
					roleList.addItem(role);
				}
			}
			
			_sqlStatement.sqlConnection.close();
			responder.result(roleList);
		}
	
	}
}