package com.anssi.ebios.services
{
	import com.anssi.ebios.model.Referentiel;
	import com.anssi.ebios.model.SecurityMeasureType;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class SecurityMeasureTypeService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		
		public function SecurityMeasureTypeService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		/**************************************************************/
		/** Récupération de la liste des types de mesure de sécurité **/
		/**************************************************************/
		public function getSecurityMeasureTypeList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = " SELECT TMESURES.idTMESURES, TMESURES.libelle as tmesures_libelle, TMESURES.description as tmesures_description, " +
							   " TMESURES.exemples, TMESURES.ordre, " +
							   " REFERENTIEL.idREFERENTIEL, REFERENTIEL.libelle as referentiel_libelle, REFERENTIEL.description as referentiel_description, REFERENTIEL.reference " +
							   " FROM TMESURES " +
							   " LEFT OUTER JOIN REFERENTIEL ON REFERENTIEL.idREFERENTIEL = TMESURES.idREFERENTIEL";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getSecurityMeasureTypeListResult);

			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function getSecurityMeasureTypeListResult(event:SQLEvent):void{
			var securityMeasureTypeList:ArrayCollection = new ArrayCollection();
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var securityMeasureType:SecurityMeasureType = null;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					securityMeasureType = new SecurityMeasureType();
					securityMeasureType.id = row["idTMESURES"];
					securityMeasureType.label = row["tmesures_libelle"];
					securityMeasureType.description = row["tmesures_description"];
					securityMeasureType.examples = row["exemples"];
					securityMeasureType.order = row["ordre"];
					
					var referentiel:Referentiel = new Referentiel();
					referentiel.id = row["idREFERENTIEL"];
					referentiel.label = row["referentiel_libelle"];
					referentiel.reference = row["reference"];
					referentiel.description = row["referentiel_description"];
					
					securityMeasureType.referentiel = referentiel;
					
					securityMeasureTypeList.addItem(securityMeasureType);
				}
			}
			_sqlStatement.sqlConnection.close();
			responder.result(securityMeasureTypeList);	
		}
		
		/**********************************************/
		/** Récupération de la liste des référentiel **/
		/**********************************************/
		
		public function constructReferentielQuery():String{
			return " SELECT * FROM REFERENTIEL " +
					" WHERE REFERENTIEL.idREFERENTIEL > 1 ";
		}
		
		public function getReferentielList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = constructReferentielQuery();
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getReferentielListResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function getReferentielListResult(event:SQLEvent):void{
			var referentielList:ArrayCollection = new ArrayCollection();
			
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			if (result != null && result.data != null)
			{
				referentielList = constructReferentielList(result);	
			}
			_sqlStatement.sqlConnection.close();
			responder.result(referentielList);
		}
		
		public function constructReferentielList(result:SQLResult):ArrayCollection{
			var referentielList:ArrayCollection = new ArrayCollection();
			
			var row:Object;
			var numRows:int = result.data.length;
			var referentiel:Referentiel = null;
			
			for (var i:int = 0; i < numRows; i++)
			{
				row = result.data[i];
				
				referentiel = new Referentiel();
				referentiel.id = row["idREFERENTIEL"];
				referentiel.label = row["libelle"];
				referentiel.description = row["description"];
				referentiel.reference = row["reference"];
				
				referentielList.addItem(referentiel);
			}
			
			return referentielList;
		}
		
	}
}