package com.anssi.ebios.services
{
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.model.SecurityNeed;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class SecurityNeedService extends AppServices
	{
			
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		
		public function SecurityNeedService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}

		
		
		/******************************************************/
		/** Récupération de la liste des besoins de sécurité **/
		/******************************************************/
		public function getSecurityNeeds(idSecurityCriteria:int):void{
			trace('getSecurityNeeds');
			setBDDName();
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT * FROM  NCRITERE WHERE NCRITERE.idCRITERE = :idSecurityCriteria ";
			
			_sqlStatement.text = query;
			_sqlStatement.parameters[":idSecurityCriteria"] = idSecurityCriteria;
			trace('query:'+query);
			_sqlStatement.addEventListener(SQLEvent.RESULT,getSecurityNeedsResult);
				
			
			// Open and Execute the SQL Statement in an aync mode
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function getSecurityNeedsResult(event:SQLEvent):void{
			var items:ArrayCollection = new ArrayCollection();
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				// variables temporaires
				var tmpItem:SecurityNeed = null;
				
				var row:Object;
				var numRows:int = result.data.length;
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					tmpItem = new SecurityNeed();
					tmpItem.id = row["idNCRITERE"];
					tmpItem.label = row["libelle"];
					
					items.addItem(tmpItem);
				}
			}
			_sqlStatement.sqlConnection.close();
			responder.result(items);
		}
		
		/*****************************************/
		/** Suppression d'un besoin de sécurité **/
		/******************************************/
		
		public function deleteSecurityNeed(securityNeed:SecurityNeed):void{
			setBDDName();				
			_sqlStatement = new SQLStatement();				
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			openInSyncMode(_sqlStatement);

			var query:String ="UPDATE ER SET idNCRITERE = null, dateModification = :dateModification " +
				" WHERE idNCRITERE = " + securityNeed.id;
			
			// remise à NULL de idNCRITERE dans ER
			_sqlStatement.text = query;
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":dateModification"] = new Date();
			
			
			execStatement(_sqlStatement);
			
			query="DELETE FROM NCRITERE WHERE idNCRITERE = " + securityNeed.id;
			
			// suppression dans NCRITERE 
			_sqlStatement.text = query;
			_sqlStatement.clearParameters();
			
			execStatement(_sqlStatement);
			
			_sqlStatement.sqlConnection.close();
			responder.result(null);
		}
	}
}