package com.anssi.ebios.services
{
	import com.anssi.ebios.model.Status;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class StatusService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		
		public function StatusService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		/******************************************/
		/** Récupération de la liste des statuts **/
		/******************************************/
		public function constructStatusQuery():String{
			return "SELECT * FROM STATUT";
		}
				
		public function getStatusList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = constructStatusQuery();
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getStatusListResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function getStatusListResult(event:SQLEvent):void{
			var statusList:ArrayCollection = new ArrayCollection();

			var result:SQLResult = SQLStatement(event.target).getResult();
			
			if (result != null && result.data != null)
			{
				statusList = constructStatusList(result);	
			}
			_sqlStatement.sqlConnection.close();
			responder.result(statusList);
		}
		
		public function constructStatusList(result:SQLResult):ArrayCollection{
				var statusList:ArrayCollection = new ArrayCollection();
				
				var row:Object;
				var numRows:int = result.data.length;
				var status:Status = null;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					status = new Status();
					status.id = row["idSTATUT"];
					status.label = row["libelle"];
					
					statusList.addItem(status);
				}
				
			return statusList;
		}

	}
}