package com.anssi.ebios.services
{
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.utils.Resources;
	import com.anssi.ebios.utils.sql.AppSQLConnectionManager;
	
	import flash.data.SQLConnection;
	import flash.data.SQLStatement;
	import flash.errors.SQLError;
	import flash.filesystem.File;
	import flash.utils.ByteArray;
	
	import mx.rpc.IResponder;
	import mx.utils.StringUtil;
	import mx.utils.UIDUtil;
	
	import org.as3commons.lang.StringUtils;

	public class StudyService extends AppServices
	{
		
		public var responder:IResponder;
		
		public function StudyService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		
		
		/**
		 *
		 * Méthode qui permet de créer une étude vide
		 *  
		 * @param studyName
		 * 
		 */			
		public function createBlankStudy(studyName:String):void{
			// TODO : retirer les caractères spéciaux
			//var studyDbFileName:String = studyName+"_"+UIDUtil.createUID()+configs.getValue("app.storage.db.extension");
			var studyDbFileName:String = studyName;
			
			if(StringUtils.isValidFileName(studyDbFileName)){
				trace('Nom de fichier valide');
			
				// ON CREE UN FICHIER BDD SQLite
				trace("base sql : " + File.applicationStorageDirectory.nativePath+Resources.getInstance().getDirectorySeparator()+configs.getValue("app.storage.studies.directory")+Resources.getInstance().getDirectorySeparator()+studyDbFileName)
				var newStudyFile:File = new File(File.applicationStorageDirectory.nativePath+Resources.getInstance().getDirectorySeparator()+configs.getValue("app.storage.studies.directory")+Resources.getInstance().getDirectorySeparator()+studyDbFileName);
				
				// ON OUVRE LA CONNEXION BDD SUR LE FICHIER SQLite
				var sqlConnection:SQLConnection = new SQLConnection();
				sqlConnection.open(newStudyFile);
				
				// ON CREE LA BASE DEPUIS LE FICHIER SQL 
				var studySQLScript:ByteArray = new (Resources.getInstance().StudyBlankSql)();
				var databaseFileString:String = studySQLScript.readUTFBytes(studySQLScript.bytesAvailable);
				
				// EXECUTION DES SCRIPTS DANS LA BASE (CREATION DES TABLES + INSERTION DES DONNEES)
				var sqlStatement:SQLStatement = new SQLStatement();
				sqlStatement.sqlConnection = sqlConnection;
				
				if(databaseFileString != null){
					var queries:Array = databaseFileString.split(";");
					trace('queries:'+queries);
					if(queries != null && queries.length > 0){
						for each(var query:String in queries){
							if(query != ""){
								sqlStatement.text = query+";";
								try {
									sqlStatement.execute();
								} catch (error:SQLError) {
									trace("Error message:", error.message);
									trace("Details:", error.details);
									sqlConnection.close();
									newStudyFile.deleteFile();
									break;
								}
							}
						}
					}
				}
				sqlConnection.close();
				
				
				// ON INDIQUE A L'APPLICATION L'ETUDE COURANTE
				AppModelLocator.getInstance().currentStudyDbName = studyDbFileName;

				responder.result(true);
			}
			else{
				responder.result(false);
			} 
			
			
		}
	}
}