package com.anssi.ebios.services
{
	import com.anssi.ebios.model.Subject;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class SubjectService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		
		public function SubjectService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		public function constructSubjectQuery():String{
			return "SELECT * FROM ETUDE";
		}
		
		public function getSubject():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT * FROM ETUDE";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getSubjectResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function getSubjectResult(event:SQLEvent):void{
			var subject:Subject = new Subject();
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			if (result != null && result.data != null)
			{		
				subject = constructSubjectList(result);	
			}
			_sqlStatement.sqlConnection.close();
			responder.result(subject);
		}
		
		public function constructSubjectList(result:SQLResult):Subject{		
			var row:Object;
			var subject:Subject = new Subject();
				
			row = result.data[0];
			subject.context = row["diversContexte"];
			subject.gross_context = row["diversContexteBrut"];
			subject.perimeter = row["diversPerimetre"];
			subject.gross_perimeter = row["diversPerimetreBrut"];
			subject.purpose = row["but"];	
			subject.gross_purpose = row["butBrut"];
			
			return subject;
		}
		
		public function updateSubject(subject:Subject):void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "UPDATE ETUDE SET but = :but, butBrut = :butBrut , " +
				" diversContexte = :diversContexte, diversContexteBrut = :diversContexteBrut, " +
				" diversPerimetre = :diversPerimetre, diversPerimetreBrut = :diversPerimetreBrut, " +
				" dateModification = :dateModification";
			
			_sqlStatement.parameters[":but"] = subject.purpose;
			_sqlStatement.parameters[":butBrut"] = subject.gross_purpose;
			_sqlStatement.parameters[":diversContexte"] = subject.context;
			_sqlStatement.parameters[":diversContexteBrut"] = subject.gross_context;
			_sqlStatement.parameters[":diversPerimetre"] = subject.perimeter;
			_sqlStatement.parameters[":diversPerimetreBrut"] = subject.gross_perimeter;
			_sqlStatement.parameters[":dateModification"] = new Date();
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,updateSubjectResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		
		private function updateSubjectResult(event:SQLEvent):void{
			_sqlStatement.sqlConnection.close();
			responder.result(null);
		}
			
	}
}