package com.anssi.ebios.services
{
	import com.anssi.ebios.model.PrimaryAsset;
	import com.anssi.ebios.model.SupportingAssetLight;
	import com.anssi.ebios.utils.Constants;

	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class SupportAssetService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement; 
		
		public function SupportAssetService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
	
		
		
		
		public function getSupportAssetsXML():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT b.xml as beXML FROM BS_POSITIONS b WHERE b.idBSPOSITIONS=1" ;
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getSupportAssetsXMLResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function getSupportAssetsXMLResult(event:SQLEvent):void{
			var bsPositions:XML = null;
			
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			// si nous avons des résultats
			if (result != null && result.data != null){
				var row:Object;
				var numRows:int = result.data.length;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					trace('beXML:'+row["beXML"]);
					bsPositions = XML(row["beXML"]);
				}
			}
			_sqlStatement.sqlConnection.close();
			responder.result(bsPositions);	
		}
		

		public function saveSupportAssets(bsPositions:XML):void{
			// TODO : MAJ de la table BS
			
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			// OUVERTURE DE LA CONNEXION
			openInSyncMode(_sqlStatement);
			
			trace("XML reçu en param:"+bsPositions.toXMLString());
			
			
			
			// Y A-T-IL DES ENTITES ?
			var strSQLEntitiesIds:String = null;
			if(bsPositions.entities.children() != null && bsPositions.entities.children().length() > 0){
				
				// ID A METTRE A JOUR
				var entitiesIds:Array = new Array();
				for each (var xmlEntity:XML in bsPositions.entities.children()){
					//trace("xmlEntity:"+xmlEntity.toXMLString());
					if(xmlEntity.@id != "-1") entitiesIds[entitiesIds.length] = xmlEntity.@id;
				}
				
				if(entitiesIds.length > 0){
					strSQLEntitiesIds = "";
					var i:Number = 0;
					for each (var strId:String in entitiesIds){
						if(i < entitiesIds.length-1) strSQLEntitiesIds += strId+", ";
						else strSQLEntitiesIds += strId;
						i++;
					}
				}
			}
			
			trace("strSQLEntitiesIds:"+strSQLEntitiesIds);
			
			/** BS : SUPPRESSION DES ANCIENS BS DE LA BDD **/
			// on récupère les BS qui existent en BDD mais qui ne sont pas dans notre XML
			var query:String = "";
			if(strSQLEntitiesIds != null) query = "SELECT * FROM BS WHERE idBS NOT IN ("+strSQLEntitiesIds+")";
			else query = "SELECT * FROM BS ";
			
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			
			var resultDelete:SQLResult = _sqlStatement.getResult();
			// si nous avons des résultats
			if (resultDelete != null && resultDelete.data != null){
				var row:Object;
				var numRows:int = resultDelete.data.length;
				
				for (var j:int = 0; j < numRows; j++)
				{
					row = resultDelete.data[j];
					trace("DELETE BS:"+row["idBS"]);
					
					
					// SUPPRESSION PORTER
					var query:String = "DELETE FROM PORTER WHERE idBS=:idBSToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete porter:"+query);
					
					
					// SUPPRESSION CROISER
					var query:String = "DELETE FROM CROISER WHERE idBS=:idBSToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete croiser:"+query);
					
					
					// SUPPRESSION LIERBS
					var query:String = "DELETE FROM LIERBS WHERE idBSparent=:idBSToDelete OR idBSenfant=:idBSToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete lierbs:"+query);
					
					
					// SUPPRESSION POUVOIR
					var query:String = "DELETE FROM POUVOIR" +
						"	WHERE EXISTS (" +
						"		SELECT 1      " +
						"		FROM SM s      " +
						"		WHERE s.idBS=:idBSToDelete" +
						"		AND s.idSM=POUVOIR.idSM " +
						"		)" ;
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete pouvoir:"+query);

					
					// SUPPRESSION MENACER
					var query:String = "DELETE FROM MENACER " +
						"	WHERE EXISTS (" +
						"		SELECT 1      " +
						"		FROM SM s      " +
						"		WHERE s.idBS=:idBSToDelete" +
						"		AND s.idSM=MENACER.idSM " +
						"		)" ;
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete menacer:"+query);
					
					// SUPPRESSION COMPOSER
					var query:String = "DELETE FROM COMPOSER " +
						"				WHERE EXISTS (" +
						"					SELECT 1" +
						"					FROM SM s" +
						"					WHERE s.idBS = :idBSToDelete" +
						"					AND COMPOSER.idSM = s.idSM" +
						"				)";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete composer:"+query);
					
					// SUPPRESSION CONTRIBUER
					var query:String = "DELETE FROM CONTRIBUER " +
						"WHERE EXISTS( " +
							"SELECT 1 " +
							"FROM RISQUE r "  +
							"WHERE 0=( " +
								"SELECT COUNT(*) " +
								"FROM COMPOSER c " +
								"WHERE c.idSM NOT IN ( " +
									"SELECT s.idSM " +
									"FROM SM s " +
									"WHERE s.idBS = :idBSToDelete " +
								") " +
								"AND c.idRISQUE=r.idRISQUE " +
							") " +
							"AND CONTRIBUER.idRISQUE=r.idRISQUE " +
						") ";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete contribuer:"+query);
					
					// SUPPRESSION RISQUE
					var query:String = "DELETE FROM RISQUE "  +
										"WHERE 0=( " +
											"SELECT COUNT(*) " +
											"FROM COMPOSER c " +
											"WHERE c.idSM NOT IN ( " +
												"SELECT s.idSM " +
												"FROM SM s " +
												"WHERE s.idBS = :idBSToDelete " +
											") " +
										"AND c.idRISQUE=RISQUE.idRISQUE " +
										") ";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete risque:"+query);
					
					// SUPPRESSION DU SM
					var query:String = "DELETE FROM SM WHERE idBS=:idBSToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete sm:"+query);
					
					// SUPPRESSION DU BS
					var query:String = "DELETE FROM BS WHERE idBS=:idBSToDelete";
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSToDelete"] = row["idBS"];
					_sqlStatement.text = query;
					execStatement(_sqlStatement);
					trace("delete bs:"+query);
				}
			}
			
			
			
			/** BS : MAJ **/
			if(bsPositions.entities.children() != null && bsPositions.entities.children().length() > 0){
				for each (var xmlEntity:XML in bsPositions.entities.children()){
					//trace("xmlEntity:"+xmlEntity.toXMLString());
					if(xmlEntity.@id != "-1"){
						trace("UPDATE BS:"+xmlEntity.@id);
						var query:String = "UPDATE BS " +
							"SET libelle=:libelle, description=:description, retenu=:retenu, proprietaire=:proprietaire, dateModification=:dateModification " +
							"WHERE idBS=:idBS";
						_sqlStatement.text = query;
						
						_sqlStatement.clearParameters();
						_sqlStatement.parameters[":libelle"] = xmlEntity.@title;
						_sqlStatement.parameters[":description"] = xmlEntity.@description;
						_sqlStatement.parameters[":retenu"] = (xmlEntity.@retenu == "true")?true:false;
						_sqlStatement.parameters[":proprietaire"] = xmlEntity.@proprietaireid;
						_sqlStatement.parameters[":dateModification"] = new Date();
						_sqlStatement.parameters[":idBS"] = xmlEntity.@id;
						
						execStatement(_sqlStatement);
						
						
						
						
						// SI BS NON RETENU, ON SUPPRIME LES EVENTUELS ER ASSOCIES
						if(xmlEntity.@retenu == "false"){
							trace("BS non retenu - Suppression des SMs associés");
							// SUPPRESSION COMPOSER
							var query:String = "DELETE FROM COMPOSER " +
								"				WHERE EXISTS (" +
								"					SELECT 1" +
								"					FROM SM s" +
								"					WHERE s.idBS = :idBSToDelete" +
								"					AND COMPOSER.idSM = s.idSM" +
								"				)";
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBSToDelete"] = xmlEntity.@id;
							_sqlStatement.text = query;
							execStatement(_sqlStatement);
							trace("delete composer:"+query);
							
							// SUPPRESSION CONTRIBUER
							var query:String = "DELETE FROM CONTRIBUER " +
								"WHERE EXISTS( " +
								"SELECT 1 " +
								"FROM RISQUE r "  +
								"WHERE 0=( " +
								"SELECT COUNT(*) " +
								"FROM COMPOSER c " +
								"WHERE c.idSM NOT IN ( " +
								"SELECT s.idSM " +
								"FROM SM s " +
								"WHERE s.idBS = :idBSToDelete " +
								") " +
								"AND c.idRISQUE=r.idRISQUE " +
								") " +
								"AND CONTRIBUER.idRISQUE=r.idRISQUE " +
								") ";
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBSToDelete"] = xmlEntity.@id;
							_sqlStatement.text = query;
							execStatement(_sqlStatement);
							trace("delete contribuer:"+query);
							
							// SUPPRESSION RISQUE
							var query:String = "DELETE FROM RISQUE "  +
								"WHERE 0=( " +
								"SELECT COUNT(*) " +
								"FROM COMPOSER c " +
								"WHERE c.idSM NOT IN ( " +
								"SELECT s.idSM " +
								"FROM SM s " +
								"WHERE s.idBS = :idBSToDelete " +
								") " +
								"AND c.idRISQUE=RISQUE.idRISQUE " +
								") ";
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBSToDelete"] = xmlEntity.@id;
							_sqlStatement.text = query;
							execStatement(_sqlStatement);
							trace("delete risque:"+query);
							
							// SUPPRESSION DU SM
							var query:String = "DELETE FROM SM WHERE idBS=:idBSToDelete";
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBSToDelete"] = xmlEntity.@id;
							_sqlStatement.text = query;
							execStatement(_sqlStatement);
							trace("delete sm:"+query);
						}
						// SINON, SI BS RETENU, ON CREE LES SM SI CE N'EST PAS DEJA FAIT
						else if(xmlEntity.@typeid != Constants.TBS_LOC){
							var query:String = "INSERT INTO SM (libelle, idCRITERE, idBS, dateCreation, dateModification)  " +
								"SELECT (\""+(""+xmlEntity.@title as String).replace("'","").replace("\"","")+"\" || \" - \" || c.libelle), c.idCRITERE, :idBS, date('now'), date('now')  " +
								"FROM CRITERE as c " +
								"WHERE NOT EXISTS (" +
								" SELECT 1 " +
								"	FROM SM s " +
								"	WHERE s.idBS=:idBS " +
								"	AND s.idCRITERE=c.idCRITERE " +
								");";
							_sqlStatement.text = query;
							
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":idBS"] = xmlEntity.@id;
							execStatement(_sqlStatement);
							trace("MAJ du BS "+xmlEntity.@id+" / BS retenu / création des SMs:"+query);
						}
					}
				}
			}
			
			
			/** BS : CREATION **/
			if(bsPositions.entities.children() != null && bsPositions.entities.children().length() > 0){
				for each (var xmlEntity:XML in bsPositions.entities.children()){
					//trace("xmlEntity:"+xmlEntity.toXMLString());
					if(xmlEntity.@id == "-1"){
						trace("INSERT BS "+xmlEntity.@title);
						// INSERTION DANS LA TABLE BE
						var query:String = "INSERT INTO BS (libelle, description, retenu, proprietaire, idTBS, dateCreation, dateModification) VALUES (:libelle, :description, :retenu, :proprietaire, :idTBS, :dateCreation, :dateModification)";
						_sqlStatement.text = query;
						
						
						_sqlStatement.clearParameters();
						_sqlStatement.parameters[":libelle"] = xmlEntity.@title;
						_sqlStatement.parameters[":description"] = xmlEntity.@description;
						_sqlStatement.parameters[":retenu"] = (xmlEntity.@retenu == "true")?true:false;
						_sqlStatement.parameters[":proprietaire"] = xmlEntity.@proprietaireid;
						_sqlStatement.parameters[":idTBS"] = xmlEntity.@typeid;
						_sqlStatement.parameters[":dateCreation"] = new Date();
						_sqlStatement.parameters[":dateModification"] = new Date();
						
						execStatement(_sqlStatement);
						var resultUpdate:SQLResult = _sqlStatement.getResult();
						var lastIdBSInserted:Number = resultUpdate.lastInsertRowID;
						
						xmlEntity.@id = lastIdBSInserted;
						
						// SI BS RETENU, CREATION DES SM 
						if(xmlEntity.@retenu == "true" && xmlEntity.@typeid != Constants.TBS_LOC){
							var query:String = "INSERT INTO SM (libelle, idCRITERE, idBS, dateCreation, dateModification)  " +
								"SELECT (\""+(""+xmlEntity.@title as String).replace("'","'").replace("\"","")+"\" || \" - \" || c.libelle), c.idCRITERE, :lastIdBs, date('now'), date('now')  " +
								"FROM CRITERE as c;";
							_sqlStatement.text = query;
							
							_sqlStatement.clearParameters();
							_sqlStatement.parameters[":lastIdBs"] = lastIdBSInserted;
							execStatement(_sqlStatement);
							trace("BS retenu / création des SMs pour ce nouveau BS "+xmlEntity.@id+":"+query);
						}
					}
				}
			}
			

			
			
			/** BS : MAJ DES LIENS **/
			// ON SUPPRIME TOUS
			var query:String = "DELETE FROM LIERBS";
			_sqlStatement.clearParameters();
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			
			// ON LES RECREE
			if(bsPositions.links.children() != null && bsPositions.links.children().length() > 0){
				for each (var xmlLink:XML in bsPositions.links.children()){
					var idFrom:String = ((bsPositions.entities.children().(@iid==xmlLink.@from))[0] as XML).@id;
					trace("idFrom:"+idFrom);
					var idTo:String = ((bsPositions.entities.children().(@iid==xmlLink.@to))[0] as XML).@id;
					trace("idTo:"+idTo);
					
					var query:String = "INSERT INTO LIERBS (idBSparent, idBSenfant, dateCreation, dateModification) VALUES (:idBSparent, :idBSenfant, :dateCreation, :dateModification)";
					_sqlStatement.text = query;
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":idBSparent"] = idTo;
					_sqlStatement.parameters[":idBSenfant"] = idFrom;
					_sqlStatement.parameters[":dateCreation"] = new Date();
					_sqlStatement.parameters[":dateModification"] = new Date();
					execStatement(_sqlStatement);
					trace("LIER BS:"+query);
				}
			}
			
			
			
			
			
			
			// MAJ DU XML
			//trace("XML à mettre à jour en BDD :"+bePositions.toXMLString());
			var query:String = "UPDATE BS_POSITIONS SET XML=:bsPositions WHERE idBSPOSITIONS=1" ;
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":bsPositions"] = bsPositions.toXMLString();
			_sqlStatement.text = query;
			
			execStatement(_sqlStatement);
			
			
			
			_sqlStatement.sqlConnection.close();
			responder.result(null);	
		}
		
		/**********************************************************/
		/** Export de la liste des de BS **/
		/**********************************************************/
		public function getSupportAssets():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = " SELECT BS.idBS, BS.libelle as bs_libelle, BS.description as bs_description, " +
							   " TBS.idTBS, TBS.libelle as tbs_libelle, TBS.titre, TBS.description as tbs_description, TBS.ordre, " +
							   " PERSONNE.idPERSONNE, ifnull(PERSONNE.nom,'') as personne_nom, ifnull(PERSONNE.prenom,'') as personne_prenom " +
							   " FROM BS " +
							   " LEFT OUTER JOIN TBS ON BS.idTBS = TBS.idTBS " +
							   " LEFT OUTER JOIN PERSONNE ON BS.PROPRIETAIRE = PERSONNE.idPERSONNE " +
							   " WHERE retenu = true ";
							   
							   
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getSupportAssetsResult);
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		
		
		private function getSupportAssetsResult(event:SQLEvent):void{
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			var supportAssets:ArrayCollection = new ArrayCollection();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var supportingAssetLight:SupportingAssetLight;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					if(row["idBS"]>0){
						supportingAssetLight = new SupportingAssetLight();
						supportingAssetLight.label = row["bs_libelle"];
						supportingAssetLight.typeLabel = row["tbs_libelle"];
						supportingAssetLight.nameLabel = row["personne_nom"];
						supportingAssetLight.firstNameLabel = row["personne_prenom"];
						
						supportAssets.addItem(supportingAssetLight);
					}
				}
			}
			_sqlStatement.sqlConnection.close();
			responder.result(supportAssets);
		}
		
		
		
		
		
		
		public function deletePeopleHandler(id:String):void{
			trace("SupportAssetService - deletePeopleHandler");
			// OUVERTURE DE LA CONNEXION
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			openInSyncMode(_sqlStatement);
			
			var query:String = "SELECT b.xml as bsXML FROM BS_POSITIONS b WHERE b.idBSPOSITIONS=1" ;
			_sqlStatement.text = query;
			execStatement(_sqlStatement);
			
			
			
			var bsPositions:XML = null;
			// récupération des résultats
			var result:SQLResult = _sqlStatement.getResult();
			// si nous avons des résultats
			if (result != null && result.data != null){
				var row:Object;
				var numRows:int = result.data.length;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					trace('bsXML:'+row["bsXML"]);
					bsPositions = XML(row["bsXML"]);
				}
			}
			
			
			if(bsPositions != null){
				if(bsPositions.entities.children() != null && bsPositions.entities.children().length() > 0){
					for each (var xmlEntity:XML in bsPositions.entities.children()){
						//trace("xmlEntity:"+xmlEntity.toXMLString());
						if(xmlEntity.@proprietaireid == id){
							trace("UPDATE BS:"+xmlEntity.@id);
							xmlEntity.@proprietaireid = -1;
						}
					}
					var query:String = "UPDATE BS_POSITIONS SET XML=:bsPositions WHERE idBSPOSITIONS=1" ;
					_sqlStatement.clearParameters();
					_sqlStatement.parameters[":bsPositions"] = bsPositions.toXMLString();
					_sqlStatement.text = query;
					
					execStatement(_sqlStatement);
				}
			}
			
			
			
			_sqlStatement.sqlConnection.close();
		}
		
		
		
		
	}
}