package com.anssi.ebios.services
{
	import com.anssi.ebios.model.SupportAssetType;
	import com.anssi.ebios.model.VulnerabilityType;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class SupportAssetTypeService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		
		public function SupportAssetTypeService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		/**********************************************************/
		/** Récupération de la liste des types de BS **/
		/**********************************************************/
		public function getSupportAssetsTypes():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT * FROM TBS ORDER BY ORDRE";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getSupportAssetsTypesResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function getSupportAssetsTypesResult(event:SQLEvent):void{
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			var supportAssetsTypes:ArrayCollection = new ArrayCollection();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var supportAssetType:SupportAssetType = null;
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					supportAssetType = new SupportAssetType();
					supportAssetType.id = row["idTBS"];
					supportAssetType.label = row["libelle"];
					supportAssetType.title = row["titre"];
					supportAssetType.description = row["description"];
					
					supportAssetsTypes.addItem(supportAssetType);
				}
			}
			
			_sqlStatement.sqlConnection.close();
			responder.result(supportAssetsTypes);
		}
	}
}