package com.anssi.ebios.services
{
	import com.anssi.ebios.model.AppModelLocator;
	import com.anssi.ebios.model.FearedEvent;
	import com.anssi.ebios.model.GravityLevel;
	import com.anssi.ebios.model.Impact;
	import com.anssi.ebios.model.LikelihoodLevel;
	import com.anssi.ebios.model.PrimaryAsset;
	import com.anssi.ebios.model.Requirement;
	import com.anssi.ebios.model.SecurityCriteria;
	import com.anssi.ebios.model.SecurityMeasure;
	import com.anssi.ebios.model.SecurityNeed;
	import com.anssi.ebios.model.SupportAssetType;
	import com.anssi.ebios.model.SupportingAsset;
	import com.anssi.ebios.model.Threat;
	import com.anssi.ebios.model.ThreatScenario;
	import com.anssi.ebios.model.ThreatScenarioLight;
	import com.anssi.ebios.model.ThreatSource;
	import com.anssi.ebios.model.Vulnerability;
	import com.logica.fwk.component.layout.flipbook.rubenswieringa.book.limited;
	import com.logica.fwk.utils.ArrayCollectionTool;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.Event;
	import flash.events.SQLErrorEvent;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.controls.Alert;
	import mx.rpc.IResponder;
	import mx.utils.ObjectUtil;

	public class ThreatScenarioService extends AppServices
	{
			
		private var _responder:IResponder;
		private var _sqlStatement:SQLStatement;
		
		private var _threatScenario:ThreatScenario;
		private var _threatSourceList:ArrayCollection;
		private var _threatList:ArrayCollection;
		
		private var _indexToUpdate:Number = -1;
		
		public function ThreatScenarioService(responder:IResponder)
		{
			_responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
	
		public function updateThreatScenario(threatScenario:ThreatScenario):void
		{	
			_threatScenario = threatScenario;
			
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			var query:String = 		
				"UPDATE  SM " +
				" SET libelle= :libelle ," +
				" idNVRISQUE= :idNVRISQUE ," +
				" justification = :justification, " +
				" dateModification = :dateModification" +
				" WHERE SM.idSM= :id";
			
			_sqlStatement.parameters[":libelle"] = _threatScenario.label;
			_sqlStatement.parameters[":idNVRISQUE"] = _threatScenario.likelihoodLevel.id;
			_sqlStatement.parameters[":justification"] = _threatScenario.justification;
			_sqlStatement.parameters[":id"] = _threatScenario.id;
			_sqlStatement.parameters[":dateModification"] = new Date();
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, updateThreatScenarioResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function updateThreatScenarioResult(event:SQLEvent):void
		{
			var result:SQLResult = SQLStatement(event.target).getResult();
			if (result != null)
			{
				deleteThreatScenarioThreat();
			}
		}
		
		private function deleteThreatScenarioThreat():void
		{	
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			var query:String = 
			"DELETE FROM MENACER"+               
			" WHERE idSM = :idSM ";
			
			_sqlStatement.parameters[":idSM"] = _threatScenario.id;
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,deleteThreatScenarioThreatResult);
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function deleteThreatScenarioThreatResult(event:SQLEvent):void
		{
			var result:SQLResult = SQLStatement(event.target).getResult();
			if (result != null)
			{
				addThreatScenarioThreat(_threatScenario.threatList);
			}
		}
		
		private function addThreatScenarioThreat(threatList:ArrayCollection):void
		{
			if(threatList)
				_threatList = threatList;
			
			_indexToUpdate ++
			if (_indexToUpdate >= _threatList.length )
			{	
				_indexToUpdate = -1;
				_sqlStatement.sqlConnection.close();
				deleteThreatSourceThreatScenario();
				
				return;
			}
			
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			var threat:Threat= _threatList.getItemAt(_indexToUpdate) as Threat;
			var sql:String;
			sql = "INSERT INTO MENACER (idMENACE, idSM, idNVRISQUE, justification, dateCreation, dateModification) " +
				" VALUES (:idMENACE, :idSM, :idNVRISQUE, :justification, :dateCreation, :dateModification)";

			_sqlStatement.text = sql;
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":idMENACE"] = threat.id;
			_sqlStatement.parameters[":idSM"] = _threatScenario.id;
			var threatLikelihoodlevel:LikelihoodLevel = new LikelihoodLevel();
			if(threat.likelihoodLevel != null){
				threatLikelihoodlevel = threat.likelihoodLevel;
			}
			else
			{
				threatLikelihoodlevel.id = null;
			}
			_sqlStatement.parameters[":idNVRISQUE"] = threatLikelihoodlevel.id;
			var justif:String= new String();
			if(threat.justification != null) 
			{
				justif = threat.justification;
			}
			_sqlStatement.parameters[":justification"] = justif;
			_sqlStatement.parameters[":dateCreation"] = new Date();
			_sqlStatement.parameters[":dateModification"] = new Date();

			_sqlStatement.addEventListener(SQLEvent.RESULT,addThreatScenarioThreatResult);
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
	
		private function addThreatScenarioThreatResult(event:SQLEvent):void
		{
			addThreatScenarioThreat(null);
		}
		
		private function deleteThreatSourceThreatScenario():void
		{	
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			var query:String = "DELETE FROM POUVOIR"+               
				" WHERE idSM = :idSM";
			
			_sqlStatement.parameters[":idSM"] = _threatScenario.id;
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,deleteThreatSourceThreatScenarioResult);
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function deleteThreatSourceThreatScenarioResult(event:SQLEvent):void
		{
			var result:SQLResult = SQLStatement(event.target).getResult();
			if (result != null)
			{
				addThreatSourceToThreatScenario(_threatScenario.threatSourceList);
			}
		}
		
		private function addThreatSourceToThreatScenario(threatSourceList:ArrayCollection):void
		{
			if(threatSourceList)
				_threatSourceList = threatSourceList;
			
			_indexToUpdate ++
			if (_indexToUpdate >= _threatSourceList.length ) 
			{
				_indexToUpdate = -1;
				_sqlStatement.sqlConnection.close();
				_responder.result(_threatScenario.id);
				return;
			}
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			var threatSource:ThreatSource = _threatSourceList.getItemAt(_indexToUpdate) as ThreatSource;			
			var sql:String;
			
			sql = "INSERT INTO POUVOIR (idSOURCE, idSM, dateCreation, dateModification) " +
				" VALUES (:idSOURCE, :idSM, :dateCreation, :dateModification)";
			
			_sqlStatement.text = sql;
			_sqlStatement.clearParameters();
			_sqlStatement.parameters[":idSOURCE"] = threatSource.id;
			_sqlStatement.parameters[":idSM"] = _threatScenario.id;
			_sqlStatement.parameters[":dateCreation"] = new Date();
			_sqlStatement.parameters[":dateModification"] = new Date();

			_sqlStatement.addEventListener(SQLEvent.RESULT,addThreatSourceToThreatScenarioResult);
			openAndExecStatementInAsyncMode(_sqlStatement);			
		}
		
		
		private function addThreatSourceToThreatScenarioResult(event:SQLEvent):void
		{
			addThreatSourceToThreatScenario(null);
		}
				
		public function getThreatScenarioById(id:Number):void
		{	
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
						
			var query:String = constructThreatScenarioQueryUnitaireById(id);

			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getThreatScenarioByIdResult);
			openAndExecStatementInAsyncMode(_sqlStatement);			
		}
		
		private function getThreatScenarioByIdResult(event:SQLEvent):void
		{
			var result:SQLResult = SQLStatement(event.target).getResult();
			if (result != null && result.data != null)
			{
				var threatScenario:ThreatScenario =  constructThreatScenarioList(result)[0];
			}
			_sqlStatement.sqlConnection.close();
			_responder.result(threatScenario);
		}

		
		public function getThreatScenario():void
		{
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			var query:String = constructThreatScenarioQueryUnitaire();
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getThreatScenarioResult);
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		
		/* Construction de la requête de récupération des scenraii de menaces */
		/* requête limitée à SM, BS et CRITERE -> Pas de Produit Cartésien */
		public function constructThreatScenarioQueryUnitaire():String
		{
			return "SELECT SM.idSM, SM.libelle as smlibelle, SM.justification as smjustification, BS.libelle as BS, "
			+ "BS.idBS as BSID, CRITERE.libelle as securityCriteria_libelle, CRITERE.idCRITERE as securityCriteria_id, "
			+ "TBS.idTBS as idtbs, TBS.titre as tbsTitle, NVRISQUE.libelle as vraisemblance, NVRISQUE.idNVRISQUE as idNVRISQUE "
			+ "FROM SM " 
			+ "LEFT OUTER JOIN BS ON (BS.idBS = SM.IdBS) " 
			+ "LEFT OUTER JOIN TBS ON (BS.idTBS=TBS.idTBS) " 
			+ "LEFT OUTER JOIN CRITERE ON (SM.idCRITERE = CRITERE.idCRITERE) " 
			+ "LEFT OUTER JOIN NVRISQUE ON (SM.idNVRISQUE=NVRISQUE.idNVRISQUE) "
			+ "ORDER BY SM.idSM";
		}

		/* Construction de la requête de récupération des scenraii de menaces via un Id de Scenario */
		/* requête limitée à SM, BS et CRITERE -> Pas de Produit Cartésien */
		public function constructThreatScenarioQueryUnitaireById(id:Number):String
		{
			return "SELECT SM.idSM, SM.libelle as smlibelle, SM.justification as smjustification, BS.libelle as BS, "
			+ "BS.idBS as BSID, CRITERE.libelle as securityCriteria_libelle, CRITERE.idCRITERE as securityCriteria_id, "
				+ "TBS.idTBS as idtbs, TBS.titre as tbsTitle, NVRISQUE.libelle as vraisemblance, NVRISQUE.idNVRISQUE as idNVRISQUE "
				+ "FROM BS, TBS, CRITERE LEFT OUTER JOIN SM ON (BS.idBS = SM.IdBS AND SM.idCRITERE = CRITERE.idCRITERE) " 
				+ "LEFT OUTER JOIN NVRISQUE ON SM.idNVRISQUE=NVRISQUE.idNVRISQUE "
				+ "WHERE SM.IdSM="+id+" AND BS.idTBS=TBS.idTBS ORDER BY SM.idSM";
		}
		
		private function getThreatScenarioResult(event:SQLEvent):void
		{
			var threatScenarioList:ArrayCollection = constructThreatScenarioList(SQLStatement(event.target).getResult()) ;
			_responder.result(threatScenarioList);
		}

		/* Construction de la liste de résultats */
		public function constructThreatScenarioList(resultUnitaire:SQLResult):ArrayCollection
		{
			var threatScenarioList:ArrayCollection = new ArrayCollection();
			// Récupération du squelette de réponse : la liste dite "unitaire"
			if (resultUnitaire != null && resultUnitaire.data != null)
			{
				threatScenarioList =  constructThreatScenarioListUnitaire(resultUnitaire);
			}
			_sqlStatement.sqlConnection.close();
			var numRows:int = threatScenarioList.length;
			setBDDName();
			var sqlStatementLocal:SQLStatement = new SQLStatement();
			sqlStatementLocal.sqlConnection = this.sqlConnection;
			openInSyncMode(sqlStatementLocal);
			// Parcours de la liste pour enrichir les informations remontées 
			for (var i:int = 0; i < numRows; i++)
			{
				var threatScenario:ThreatScenario = threatScenarioList.getItemAt(i,0) as ThreatScenario;
				var idSM:String = threatScenario.id ;
				if(idSM!=null)
				{
					// Traitement Pouvoir Source
					sqlStatementLocal.text = constructThreatScenarioQueryPouvoirSource(idSM);
					execStatement(sqlStatementLocal);
					var resultPouvoirSource:SQLResult = sqlStatementLocal.getResult();
					// Traitement Porter Mesure
					sqlStatementLocal.text = constructThreatScenarioQueryPorterMesure(idSM);
					execStatement(sqlStatementLocal);
					var resultPorterMesure:SQLResult = sqlStatementLocal.getResult();
					// Traitement Menacer
					sqlStatementLocal.text = constructThreatScenarioQueryMenacer(idSM) ;
					execStatement(sqlStatementLocal);
					var resultMenacer:SQLResult = sqlStatementLocal.getResult();
					// Traitement Menace Prerequis
					sqlStatementLocal.text = constructThreatScenarioQueryMenacePrerequis(idSM);
					execStatement(sqlStatementLocal);
					var resultMenacePrerequis:SQLResult = sqlStatementLocal.getResult();
					// Traitement Menace Prerequis
					sqlStatementLocal.text = constructThreatScenarioQueryMenaceVulnerabilite(idSM);
					execStatement(sqlStatementLocal);
					var resultMenaceVulnerabilite:SQLResult = sqlStatementLocal.getResult();
					// Construction de la liste multiple sur la base de la liste unitaire
					constructThreatScenarioListMultiple(resultPouvoirSource, resultPorterMesure, resultMenacer, resultMenacePrerequis, resultMenaceVulnerabilite, threatScenario);
				}
			}
			sqlStatementLocal.sqlConnection.close();
			return threatScenarioList ;
		}

		// Construction de la liste de base des informations liées au scenario de menaces
		private function constructThreatScenarioListUnitaire(result:SQLResult):ArrayCollection
		{
			var threatScenarioList:ArrayCollection = new ArrayCollection();
			if (result.data){
				var row:Object;
				var numRows:int = result.data.length;
				var threatScenario:ThreatScenario			
				var utilThreatScenarioID:Number;				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					if(utilThreatScenarioID != row["idSM"])
					{
						utilThreatScenarioID = row["idSM"];
						// Instanciation du scenario
						threatScenario = new ThreatScenario();
						threatScenario.id = row["idSM"];
						threatScenario.label = row["smlibelle"];
						threatScenario.justification = row["smjustification"];
						// Récupération des critères de sécurité
						var securityCriteria:SecurityCriteria = new SecurityCriteria();
						securityCriteria.id = row["securityCriteria_id"];
						securityCriteria.libelle = row["securityCriteria_libelle"];
						threatScenario.securityCriteria = securityCriteria;
						// Récupération des BS						
						var supportingAsset:SupportingAsset = new SupportingAsset();
						supportingAsset.label = row["BS"];
						supportingAsset.id = row["BSID"];
						supportingAsset.type = new SupportAssetType();
						supportingAsset.type.id = row["idtbs"];
						supportingAsset.type.title = row["tbsTitle"] ;
						threatScenario.supportingAsset = supportingAsset;
						// Récupération des vraisemblances
						var likelihoodLevel:LikelihoodLevel = new LikelihoodLevel();
						likelihoodLevel.id = row["idNVRISQUE"];
						likelihoodLevel.label = row["vraisemblance"];
						threatScenario.likelihoodLevel = likelihoodLevel;
						// Construction de la réponse complète
						threatScenario.threatSourceList = new ArrayCollection();
						threatScenario.threatList = new ArrayCollection();
						threatScenario.requirementList = new ArrayCollection();
						threatScenario.vulnerabilityList = new ArrayCollection();
						threatScenario.securityMeasureList = new ArrayCollection();
						// Ajout de l'élément dans la liste
						threatScenarioList.addItem(threatScenario);
					}
				}
			}
			return threatScenarioList;
		}
		
		// Construction de la liste des informations complémentaires liées au scenario de menaces
		private function constructThreatScenarioListMultiple(resultPouvoirSource:SQLResult, resultPorterMesure:SQLResult, resultMenacer:SQLResult, resultMenacePrerequis:SQLResult, resultMenaceVulnerabilite:SQLResult, threatScenario:ThreatScenario):void
		{
			if (resultPouvoirSource.data && resultPorterMesure.data && resultMenacer.data && resultMenacePrerequis.data && resultMenaceVulnerabilite.data)
			{
				var row:Object;
				var numRows:int;			
				// traitement des sources
				numRows = resultPouvoirSource.data.length;
				var sources:ArrayCollection = threatScenario.threatSourceList ;
				//trace("Source - nb lignes = "+numRows);
				for (var i:int = 0; i < numRows; i++)
				{
					// Récupération de la ligne correspondant à la remontée d'informations
					row = resultPouvoirSource.data[i];
					if(sources.length==0 || (ArrayCollectionTool.findIndexForId(sources,row["idSOURCE"])==-1&& row["idSOURCE"]>0))
					{
						// Création de l'objet temporaire
						var threatSource:ThreatSource = new ThreatSource();
						threatSource.label = row["source"];
						threatSource.id = row["idSOURCE"];
						// Ajout de la valeur
						sources.addItem(threatSource);
					}
				}
				// Traitement des menaces
				numRows = resultMenacer.data.length;
				var threatList:ArrayCollection = threatScenario.threatList ;
				//trace("Menaces - nb lignes = "+numRows);
				for (var i:int = 0; i < numRows; i++)
				{
					// Récupération de la ligne correspondant à la remontée d'informations
					row = resultMenacer.data[i];
					if(threatList.length==0 || (ArrayCollectionTool.findIndexForId(threatList, row["idMENACE"])==-1 && row["idMENACE"]>0))
					{
						// Création de l'objet temporaire
						var threat:Threat = new Threat();
						threat.label = row["menace"];
						threat.id = row["idMENACE"];
						var likelihoodLevelMenace:LikelihoodLevel = new LikelihoodLevel();
						likelihoodLevelMenace.id = row["menaceVraisemblance"];
						threat.likelihoodLevel = likelihoodLevelMenace;
						threat.justification = row["menaceJustification"];
						// Ajout de la valeur
						threatList.addItem(threat);
					}
				}
				// Traitements des prerequis
				numRows = resultMenacePrerequis.data.length;
				var requirementList:ArrayCollection = threatScenario.requirementList ;
				//trace("Prérequis - nb lignes = "+numRows);
				for (var i:int = 0; i < numRows; i++)
				{
					// Récupération de la ligne correspondant à la remontée d'informations
					row = resultMenacePrerequis.data[i];
					if(requirementList.length==0 || (ArrayCollectionTool.findIndexForId(requirementList, row["idPREREQUIS"])==-1 && row["idPREREQUIS"]>0))
					{
						// Création de l'objet temporaire		
						var requirement:Requirement = new Requirement();
						requirement.label = row["prerequis"];
						requirement.id = row["idPREREQUIS"];
						// Ajout de la valeur
						requirementList.addItem(requirement);
					}
				}
				// Traitement des vulnerabilités
				numRows = resultMenaceVulnerabilite.data.length;
				var vulnerabilityList:ArrayCollection = threatScenario.vulnerabilityList;
				//trace("Vulnerabilité - nb lignes = "+numRows);
				for (var j:int = 0; j < numRows; j++)
				{
					// Récupération de la ligne correspondant à la remontée d'informations
					row = resultMenaceVulnerabilite.data[j];
					if(vulnerabilityList.length==0 || (ArrayCollectionTool.findIndexForId(vulnerabilityList, row["idVULN"])==-1 && row["idVULN"]>0))
					{
						// Création de l'objet temporaire		
						var vulnerability:Vulnerability = new Vulnerability();
						vulnerability.label = row["vulnerabilite"];
						vulnerability.id = row["idVULN"];
						// Ajout de la valeur
						vulnerabilityList.addItem(vulnerability);
					}
				}
				// Traitement des mesures de sécurité
				numRows = resultPorterMesure.data.length;
				var securityMeasureList:ArrayCollection = threatScenario.securityMeasureList ;
				//trace("Mesures - nb lignes = "+numRows);
				for (var k:int = 0; k < numRows; k++)
				{
					// Récupération de la ligne correspondant à la remontée d'informations
					row = resultPorterMesure.data[k];
					if(securityMeasureList.length==0 || (ArrayCollectionTool.findIndexForId(securityMeasureList, row["mesureID"])==-1 && row["mesureID"]>0))
					{
						// Création de l'objet temporaire
						var securityMeasure:SecurityMeasure = new SecurityMeasure();
						securityMeasure.label = row["mesureLibelle"];
						securityMeasure.id = row["mesureID"];
						// Ajout de la valeur
						securityMeasureList.addItem(securityMeasure);
					}
				}
			}
		}

		// Requete de recuperation des sources de menaces
		public function constructThreatScenarioQueryPouvoirSource(identSM:String = ""):String
		{
			return "SELECT SM.idSM, SOURCE.idSOURCE, SOURCE.libelle as source "
				+ "FROM SM "
				+ "LEFT OUTER JOIN POUVOIR ON POUVOIR.idSM = SM.idSM "
				+ "LEFT OUTER JOIN SOURCE ON POUVOIR.idSOURCE = SOURCE.idSOURCE "
				+ "WHERE SM.idSM="+identSM+" "
				+ "ORDER BY SM.idSM, SOURCE.idSOURCE";
		}
		
		// Requete de recuperation des mesures
		public function constructThreatScenarioQueryPorterMesure(identSM:String = ""):String
		{
			return "SELECT SM.idSM, MESURE.libelle as mesureLibelle, MESURE.idMESURE as mesureID "
				+ "FROM SM "
				+ "LEFT OUTER JOIN PORTER ON PORTER.idBS = SM.idBS "
				+ "LEFT OUTER JOIN MESURE ON MESURE.idMESURE = PORTER.idMESURE "
				+ "WHERE SM.idSM="+identSM+" "
				+ "ORDER BY SM.idSM";
		}

		// Requete de recuperation des justifications
		public function constructThreatScenarioQueryMenacer(identSM:String = ""):String
		{
			return "SELECT MENACER.idSM, MENACER.idNVRISQUE as menaceVraisemblance, MENACER.justification as menaceJustification, "
				+ "MENACE.idMENACE, MENACE.libelle as menace "
				+ "FROM MENACER "
				+ "LEFT OUTER JOIN MENACE ON MENACER.idMENACE = MENACE.idMENACE "
				+ "WHERE MENACER.idSM="+identSM+" "
				+ "ORDER BY MENACER.idSM";
		}
		
		// Requete de recuperation des prerequis
		public function constructThreatScenarioQueryMenacePrerequis(identSM:String = ""):String
		{
			return "SELECT MENACER.idSM, PREREQUIS.idPREREQUIS, PREREQUIS.libelle as prerequis "
				+ "FROM MENACER "
				+ "LEFT OUTER JOIN MENACE ON MENACER.idMENACE = MENACE.idMENACE "
				+ "LEFT OUTER JOIN TMENACES ON TMENACES.idTMENACES = MENACE.idTMENACES "
				+ "LEFT OUTER JOIN PREREQUIS ON PREREQUIS.idTMENACES = TMENACES.idTMENACES "
				+ "WHERE MENACER.idSM="+identSM+" "
				+ "ORDER BY MENACER.idSM, MENACE.idMENACE, PREREQUIS.idPREREQUIS";
		}		
		
		// Requete de recuperation des vulnerabilités
		public function constructThreatScenarioQueryMenaceVulnerabilite(identSM:String = ""):String
		{
			return "SELECT MENACER.idSM, VULN.idVULN, VULN.libelle as vulnerabilite "
				+ "FROM MENACER "
				+ "LEFT OUTER JOIN MENACE ON MENACER.idMENACE = MENACE.idMENACE "
				+ "LEFT OUTER JOIN EXPLOITER ON MENACE.idMENACE = EXPLOITER.idMENACE "
				+ "LEFT OUTER JOIN VULN ON VULN.idVULN = EXPLOITER.idVULN "
				+ "WHERE MENACER.idSM="+identSM+" "
				+ "ORDER BY MENACER.idSM, MENACE.idMENACE, VULN.idVULN";
			}


		public function getThreatScenarioByLikelihoodLevel():void
		{
			setBDDName();
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			//requete a mettre
			var query:String = 
				"SELECT NVRISQUE.libelle, NVRISQUE.idNVRISQUE, SM.idSM, SM.libelle as smLibelle, NVRISQUE.ordre as ordre " +
				"FROM NVRISQUE " +
				"LEFT OUTER JOIN SM ON SM.idNVRISQUE = NVRISQUE.idNVRISQUE " +
				"order by 5 desc ";
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT, getThreatScenarioByLikelihoodLevelResult);
			openAndExecStatementInAsyncMode(_sqlStatement);
		}
		
		private function getThreatScenarioByLikelihoodLevelResult(event:SQLEvent):void
		{
			var result:SQLResult = SQLStatement(event.target).getResult();
			var threatScenarioByLikelihoodLevelList:ArrayCollection = new ArrayCollection();
			if (result!=null && result.data!=null){
				threatScenarioByLikelihoodLevelList = constructThreatScenarioByLikelihoodLevelList(result);
			}
			_sqlStatement.sqlConnection.close();
			_responder.result(threatScenarioByLikelihoodLevelList);
		}
		
		private function constructThreatScenarioByLikelihoodLevelList(result:SQLResult):ArrayCollection
		{
			var threatScenarioByLikelihoodLevelList:ArrayCollection = new ArrayCollection();
			// construction de la collection

			var row:Object;
			var numRows:int = result.data.length;
			var utilLikelihoodLevelID:Number;
			var likelihoodLevel:LikelihoodLevel;
			var threatScenario:ThreatScenario;
		
			for( var i:int=0; i< numRows;i++)
			{
				row=result.data[i];
				if(utilLikelihoodLevelID !=  row["idNVRISQUE"])
				{
					utilLikelihoodLevelID =  row["idNVRISQUE"];
					
					likelihoodLevel= new LikelihoodLevel();
					likelihoodLevel.id=row["idNVRISQUE"];
					likelihoodLevel.label=row["libelle"];
					likelihoodLevel.order = row["ordre"];
					likelihoodLevel.threatScenarioList=new ArrayCollection();
					threatScenarioByLikelihoodLevelList.addItem(likelihoodLevel);
				}
				if(row["idSM"]>0){
					threatScenario = new ThreatScenario();
					threatScenario.id=row["idSM"];
					threatScenario.label=row["smLibelle"];
					likelihoodLevel.threatScenarioList.addItem(threatScenario);
				}
			}
			return threatScenarioByLikelihoodLevelList;
		}

		public function getThreatScenarioLight():void
		{
			_sqlStatement = new SQLStatement();
			_sqlStatement.sqlConnection = this.sqlConnection;
			
			var query:String;
			query= constructThreatScenarioQueryUnitaire();
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getThreatScenarioLightResult);
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function getThreatScenarioLightResult(event:SQLEvent):void
		{
			var result:SQLResult = SQLStatement(event.target).getResult();
			var threatScenarioLightList:ArrayCollection = new ArrayCollection();
			if (result!=null && result.data!=null){
				threatScenarioLightList = constructThreatScenarioLightList(result);
			}
			_sqlStatement.sqlConnection.close();
			_responder.result(threatScenarioLightList);
		}		
		

		private function constructThreatScenarioLightList(resultUnitaire:SQLResult):ArrayCollection
		{
			var threatScenarioList:ArrayCollection = new ArrayCollection();
			if (resultUnitaire != null && resultUnitaire.data != null)
			{
				threatScenarioList =  constructThreatScenarioLightListUnitaire(resultUnitaire);
			}
			_sqlStatement.sqlConnection.close();
			var numRows:int = threatScenarioList.length;
			setBDDName();
			var sqlStatementLocal:SQLStatement = new SQLStatement();
			sqlStatementLocal.sqlConnection = this.sqlConnection;
			openInSyncMode(sqlStatementLocal);
			for (var i:int = 0; i < numRows; i++)
			{
				var threatScenario:ThreatScenario = threatScenarioList.getItemAt(i,0) as ThreatScenario;
				var idSM:String = threatScenario.id ;
				if(idSM!=null)
				{
					// Traitement Pouvoir Source
					sqlStatementLocal.text = constructThreatScenarioQueryPouvoirSource(idSM);
					execStatement(sqlStatementLocal);
					var resultPouvoirSource:SQLResult = sqlStatementLocal.getResult();
					// Traitement Porter Mesure
					sqlStatementLocal.text = constructThreatScenarioQueryPorterMesure(idSM);
					execStatement(sqlStatementLocal);
					var resultPorterMesure:SQLResult = sqlStatementLocal.getResult();
					// Traitement Menacer
					sqlStatementLocal.text = constructThreatScenarioQueryMenacer(idSM) ;
					execStatement(sqlStatementLocal);
					var resultMenacer:SQLResult = sqlStatementLocal.getResult();
					// Traitement Menace Prerequis
					sqlStatementLocal.text = constructThreatScenarioQueryMenacePrerequis(idSM);
					execStatement(sqlStatementLocal);
					var resultMenacePrerequis:SQLResult = sqlStatementLocal.getResult();
					// Traitement Menace Prerequis
					sqlStatementLocal.text = constructThreatScenarioQueryMenaceVulnerabilite(idSM);
					execStatement(sqlStatementLocal);
					var resultMenaceVulnerabilite:SQLResult = sqlStatementLocal.getResult();
					// Construction de la liste multiple sur la base de la liste unitaire
					constructThreatScenarioLightListMultiple(resultPouvoirSource, resultPorterMesure, resultMenacer, resultMenacePrerequis, resultMenaceVulnerabilite, threatScenario);
				}
			}
			var threatScenarioListFinale:ArrayCollection = aplatit(threatScenarioList);
			sqlStatementLocal.sqlConnection.close();
			return threatScenarioListFinale ;
		}
		

		private function aplatit(threatScenarioList:ArrayCollection):ArrayCollection
		{
			var threatScenarioListFinale:ArrayCollection = new ArrayCollection() ;
			var numRows:int = threatScenarioList.length ;
			// Traitement d'un SM
			for (var i:int = 0; i < numRows; i++)
			{
				var i:int=1;
				var threatScenario:ThreatScenario = threatScenarioList.getItemAt(i) as ThreatScenario ;
				aplatitSM(threatScenarioListFinale, threatScenario);
			}
			return threatScenarioListFinale ;
		}
		
		private function aplatitSM(threatScenarioLightList:ArrayCollection, threatScenario:ThreatScenario):void
		{
			var SALabel:String = threatScenario.supportingAsset.label ;
			var justif:String = threatScenario.justification;
			var criter:String = threatScenario.securityCriteria.libelle;
			var vraisem:String = threatScenario.likelihoodLevel.label ;
			// Gestion des sources, des menaces, des prerequis, des vulnérabilités
			var sources:ArrayCollection = threatScenario.threatSourceList ;
			var menaces:ArrayCollection = threatScenario.threatList ;
			var prerequiss:ArrayCollection = threatScenario.requirementList ;
			var vulnerabilites:ArrayCollection = threatScenario.vulnerabilityList ;
			for (var i:int = 0; i < sources.length; i++)
			{
				var threatSource:ThreatSource = sources.getItemAt(i) as ThreatSource;			
				var sourceLabel:String = threatSource.label ;
				for (var j:int = 0; j < menaces.length; j++)
				{
					var menace:Threat = menaces.getItemAt(j) as Threat;
					var menaceLabel:String = menace.label ;
					for (var k:int = 0; k < prerequiss.length; k++)
					{
						var prerequis:Requirement = prerequiss.getItemAt(k) as Requirement ;
						var prerequisLabel:String = prerequis.label ;
						for (var l:int = 0; l < vulnerabilites.length; l++)
						{
							var vulnerabilite:Vulnerability = vulnerabilites.getItemAt(l) as Vulnerability ;							
							var vulnerabiliteLabel:String = vulnerabilite.label ;
							// Création de l'objet
							var threatScenarioLight:ThreatScenarioLight= new ThreatScenarioLight();
							threatScenarioLight.supportingAssetLabel = SALabel ; 
							threatScenarioLight.justification = justif ;
							threatScenarioLight.criteriaLabel = criter ;
							threatScenarioLight.likelihoodLabel = vraisem ; 
							threatScenarioLight.threatSourceLabel = sourceLabel;
							threatScenarioLight.threatLabel = menaceLabel;
							threatScenarioLight.vulnerabilityLabel = vulnerabiliteLabel ;
							threatScenarioLight.requirementLabel = prerequisLabel;		
							threatScenarioLightList.addItem(threatScenarioLight);
						}						
					}					
				}
			}
		}
		
		private function constructThreatScenarioLightListUnitaire(result:SQLResult):ArrayCollection
		{
			var threatScenarioList:ArrayCollection = new ArrayCollection();
			if (result.data)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var threatScenario:ThreatScenario;			
				var utilThreatScenarioID:Number;				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					if(utilThreatScenarioID != row["idSM"])
					{
						utilThreatScenarioID = row["idSM"];
						
						threatScenario = new ThreatScenario();
						threatScenario.id = row["idSM"];
						threatScenario.justification = row["smjustification"];
						
						var securityCriteria:SecurityCriteria = new SecurityCriteria();
						securityCriteria.libelle = row["securityCriteria_libelle"];
						threatScenario.securityCriteria = securityCriteria;
						
						var supportingAsset:SupportingAsset = new SupportingAsset();
						supportingAsset.label = row["BS"];
						threatScenario.supportingAsset = supportingAsset;
						
						var likelihoodLevel:LikelihoodLevel = new LikelihoodLevel();
						likelihoodLevel.label = row["vraisemblance"];
						threatScenario.likelihoodLevel = likelihoodLevel;
						
						threatScenario.threatSourceList = new ArrayCollection();
						threatScenario.threatList = new ArrayCollection();
						threatScenario.requirementList = new ArrayCollection();
						threatScenario.vulnerabilityList = new ArrayCollection();
						
						threatScenarioList.addItem(threatScenario);
					}
				}
			}
			return threatScenarioList;
		}
		
		private function constructThreatScenarioLightListMultiple(resultPouvoirSource:SQLResult, resultPorterMesure:SQLResult, resultMenacer:SQLResult, resultMenacePrerequis:SQLResult, resultMenaceVulnerabilite:SQLResult, threatScenario:ThreatScenario):void
		{
			if (resultPouvoirSource.data && resultPorterMesure.data && resultMenacer.data && resultMenacePrerequis.data && resultMenaceVulnerabilite.data)
			{
				var row:Object;
				var numRows:int;			
				// traitement des sources
				numRows = resultPouvoirSource.data.length;
				var sources:ArrayCollection = threatScenario.threatSourceList ;
				for (var i:int = 0; i < numRows; i++)
				{
					// Récupération de la ligne correspondant à la remontée d'informations
					row = resultPouvoirSource.data[i];
					if(sources.length==0 || (ArrayCollectionTool.findIndexForId(sources,row["idSOURCE"])==-1&& row["idSOURCE"]>0))
					{
						// Création de l'objet temporaire
						var threatSource:ThreatSource = new ThreatSource();
						threatSource.label = row["source"];
						// Ajout de la valeur
						sources.addItem(threatSource);
					}
				}
				// Traitement des menaces
				numRows = resultMenacer.data.length;
				var threatList:ArrayCollection = threatScenario.threatList ;
				for (var i:int = 0; i < numRows; i++)
				{
					// Récupération de la ligne correspondant à la remontée d'informations
					row = resultMenacer.data[i];
					if(threatList.length==0 || (ArrayCollectionTool.findIndexForId(threatList, row["idMENACE"])==-1 && row["idMENACE"]>0))
					{
						// Création de l'objet temporaire
						var threat:Threat = new Threat();
						threat.label = row["menace"];
						// Ajout de la valeur
						threatList.addItem(threat);
					}
				}
				// Traitements des prerequis
				numRows = resultMenacePrerequis.data.length;
				var requirementList:ArrayCollection = threatScenario.requirementList ;
				for (var i:int = 0; i < numRows; i++)
				{
					// Récupération de la ligne correspondant à la remontée d'informations
					row = resultMenacePrerequis.data[i];
					if(requirementList.length==0 || (ArrayCollectionTool.findIndexForId(requirementList, row["idPREREQUIS"])==-1 && row["idPREREQUIS"]>0))
					{
						// Création de l'objet temporaire		
						var requirement:Requirement = new Requirement();
						requirement.label = row["prerequis"];
						// Ajout de la valeur
						requirementList.addItem(requirement);
					}
				}
				// Traitement des vulnerabilités
				numRows = resultMenaceVulnerabilite.data.length;
				var vulnerabilityList:ArrayCollection = threatScenario.vulnerabilityList;
				for (var i:int = 0; i < numRows; i++)
				{
					// Récupération de la ligne correspondant à la remontée d'informations
					row = resultMenaceVulnerabilite.data[i];
					if(vulnerabilityList.length==0 || (ArrayCollectionTool.findIndexForId(vulnerabilityList, row["idVULN"])==-1 && row["idVULN"]>0))
					{
						// Création de l'objet temporaire		
						var vulnerability:Vulnerability = new Vulnerability();
						vulnerability.label = row["vulnerabilite"];
						// Ajout de la valeur
						vulnerabilityList.addItem(vulnerability);
					}
				}
			}
		}
		

	}
}