package com.anssi.ebios.services
{
	import com.anssi.ebios.model.Action;
	import com.anssi.ebios.model.Deliverable;
	import com.anssi.ebios.model.People;
	import com.anssi.ebios.model.Role;
	import com.anssi.ebios.model.WorkStructure;
	import com.logica.fwk.utils.ArrayCollectionTool;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class WorkStructureService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		private var _actionIndex:Number = -1;
		private var _peopleIndex:Number = -1;
		private var _ws:WorkStructure;
		private var _workStructureList:ArrayCollection;
		
		public function WorkStructureService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		
		/***************************************************/
		/** Récupération de la liste structure de travail **/
		/***************************************************/	
		public function getWorkStructureList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = constructWorkStructureQuery();
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getWorkStructureListResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		public function constructWorkStructureQuery():String{
			return " SELECT ACTION.idACTION as idACTION, ACTION.numero, ACTION.libelle as action_libelle, ifnull(ACTION.charges,'') as charges, ifnull(ACTION.duree, '') as duree, ifnull(ACTION.consignes,'') as consignes, ACTION.idLIVRABLE as idLIVRABLE, "
				+ " PARTICIPER.idPERSONNE as idPERSONNE, PARTICIPER.idROLE as idROLE, PERSONNE.participe as personne_participe, "
				+ " ROLE.libelle as role_libelle, ifnull(LIVRABLE.libelle,'') as livrable_libelle "
				+ " FROM ACTION "
				+ " LEFT OUTER JOIN PARTICIPER ON PARTICIPER.idACTION = ACTION.idACTION "
				+ " LEFT OUTER JOIN PERSONNE ON PARTICIPER.idPERSONNE = PERSONNE.idPERSONNE "
				+ " LEFT OUTER JOIN LIVRABLE ON ACTION.idLIVRABLE = LIVRABLE.idLIVRABLE "
				+ " LEFT OUTER JOIN ROLE ON PARTICIPER.idROLE = ROLE.idROLE "
				+ " WHERE ACTION.retenu = true "
				+ " ORDER BY ACTION.idACTION, idPERSONNE ";
		}
		
		public function constructWorkStructureList(result:SQLResult):ArrayCollection{
			var row:Object;
			
			var workStructure:WorkStructure;
			var workStructureList:ArrayCollection = new ArrayCollection();
			
			if(result.data){
			var numRows:int = result.data.length;
			var tmpActionId:Number;
			var tmpPeopleId:Number;
			
			for (var i:int = 0; i < numRows; i++)
			{
				row = result.data[i];
				
				if (tmpActionId != row["idACTION"]){
					
					tmpActionId = row["idACTION"];
					tmpPeopleId = -1;
					
					workStructure = new WorkStructure();
					
					var action:Action = new Action();
					action.id = row["idACTION"];
					action.actionKey = row["numero"];
					action.libelle = row["action_libelle"];
					action.duration = row["duree"];
					action.workload = row["charges"];
					action.instruction = row["consignes"];
					
					var deliverable:Deliverable = new Deliverable();
					deliverable.id = row["idLIVRABLE"];
					deliverable.label = row["livrable_libelle"];
					action.deliverable = deliverable;
					
					workStructure.action = action;
					
					workStructure.peopleList = new ArrayCollection();
					
					workStructureList.addItem(workStructure);
				}
				
				if (tmpPeopleId != row["idPERSONNE"] && ArrayCollectionTool.findIndexForId(workStructure.peopleList, row["idPERSONNE"])==-1 && row["idPERSONNE"]>0 && row["personne_participe"] == true){
					
					tmpPeopleId = row["idPERSONNE"];
					
					var people:People = new People();
					people.id = row ["idPERSONNE"];
					
					var role:Role= new Role();
					role.id = row["idROLE"];
					role.label = row["role_libelle"];
					people.role= role;
					workStructure.peopleList.addItem(people);
				}
				
			}
			}
			return workStructureList;
		}
		
		private function getWorkStructureListResult(event:SQLEvent):void{
			var workStructureList:ArrayCollection = new ArrayCollection();
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				workStructureList = constructWorkStructureList(result);
			}
			
			_sqlStatement.sqlConnection.close();
			responder.result(workStructureList);
		}
		
		public function getWorkStructureListLight():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = " SELECT ACTION.idACTION as idACTION, ACTION.numero, ACTION.libelle as action_libelle, ifnull(ACTION.charges,'') as charges, ifnull(ACTION.duree,'') as duree, ifnull(ACTION.consignes,'') as consignes, ACTION.idLIVRABLE as idLIVRABLE, LIVRABLE.libelle as livrable_libelle, "
				+ " PARTICIPER.idPERSONNE as idPERSONNE, PARTICIPER.idROLE as idROLE, ROLE.libelle as role_libelle "
				+ " FROM ACTION "
				+ " LEFT OUTER JOIN PARTICIPER ON PARTICIPER.idACTION = ACTION.idACTION "
				+ " LEFT OUTER JOIN PERSONNE ON PARTICIPER.idPERSONNE = PERSONNE.idPERSONNE "
				+ " LEFT OUTER JOIN LIVRABLE ON ACTION.idLIVRABLE = LIVRABLE.idLIVRABLE "
				+ " LEFT OUTER JOIN ROLE ON PARTICIPER.idROLE = ROLE.idROLE "
				+ " WHERE ACTION.retenu = true "
				+ " ORDER BY ACTION.idACTION, idPERSONNE ";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getWorkStructureListLightResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function getWorkStructureListLightResult(event:SQLEvent):void{
			var workStructureList:ArrayCollection = new ArrayCollection();
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var workStructure:WorkStructure;
				var tmpActionId:Number;
				var tmpPeopleId:Number;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					if (tmpActionId != row["idACTION"]){
						
						tmpActionId = row["idACTION"];
						tmpPeopleId = -1;
						
						workStructure = new WorkStructure();
						
						var action:Action = new Action();
						action.id = row["idACTION"];
						action.actionKey = row["numero"];
						action.libelle = row["action_libelle"];
						action.duration = row["duree"];
						action.workload = row["charges"];
						action.instruction = row["consignes"];
						
						var deliverable:Deliverable = new Deliverable();
						deliverable.id = row["idLIVRABLE"];
						deliverable.label = row["livrable_libelle"];
						action.deliverable = deliverable;
						
						workStructure.action = action;
						
						workStructure.peopleList = new ArrayCollection();
						
						workStructureList.addItem(workStructure);
					}
					
					if (tmpPeopleId != row["idPERSONNE"] && ArrayCollectionTool.findIndexForId(workStructure.peopleList, row["idPERSONNE"])==-1 && row["idPERSONNE"]>0){
						
						tmpPeopleId = row["idPERSONNE"];
						
						var people:People = new People();
						people.id = row ["idPERSONNE"];
						
						var role:Role= new Role();
						role.id = row["idROLE"];
						role.label = row["role_libelle"];
						people.role= role;
						workStructure.peopleList.addItem(people);
					}
					
				}
			}
			
			_sqlStatement.sqlConnection.close();
			responder.result(workStructureList);
		}
		
		
		public function getWorkStructureByActionNumero(numero:String):void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = " SELECT ACTION.idACTION as idACTION, ACTION.numero, ACTION.libelle as action_libelle, ACTION.charges, ACTION.duree, ACTION.consignes, ACTION.idLIVRABLE as idLIVRABLE, "
				+ " PARTICIPER.idPERSONNE as idPERSONNE, PARTICIPER.idROLE as idROLE, PERSONNE.NOM as nomPersonne, PERSONNE.PRENOM as prenomPersonne "
				+ " FROM ACTION "
				+ " LEFT OUTER JOIN PARTICIPER ON PARTICIPER.idACTION = ACTION.idACTION "
				+ " LEFT OUTER JOIN PERSONNE ON PARTICIPER.idPERSONNE = PERSONNE.idPERSONNE "
				+ " LEFT OUTER JOIN LIVRABLE ON ACTION.idLIVRABLE = LIVRABLE.idLIVRABLE "
				+ " LEFT OUTER JOIN ROLE ON PARTICIPER.idROLE = ROLE.idROLE "
				+ " WHERE ACTION.retenu = true "
				+ " AND ACTION.numero = :key "
				+ " ORDER BY ACTION.idACTION, idPERSONNE ";
			
			_sqlStatement.text = query;
			_sqlStatement.parameters[":key"] = numero;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getWorkStructureByActionNumeroResult);
			
			trace(query);
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		
		private function getWorkStructureByActionNumeroResult(event:SQLEvent):void{
			var workStructure:WorkStructure = null;
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				//var workStructure:WorkStructure;
				var tmpActionId:Number;
				var tmpPeopleId:Number;
				
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					
					if (tmpActionId != row["idACTION"]){
						
						tmpActionId = row["idACTION"];
						tmpPeopleId = -1;
						
						workStructure = new WorkStructure();
						
						var action:Action = new Action();
						action.id = row["idACTION"];
						action.actionKey = row["numero"];
						action.libelle = row["action_libelle"];
						action.duration = row["duree"];
						action.workload = row["charges"];
						action.instruction = row["consignes"];
						
						var deliverable:Deliverable = new Deliverable();
						deliverable.id = row["idLIVRABLE"];
						action.deliverable = deliverable;
						
						workStructure.action = action;
						
						workStructure.peopleList = new ArrayCollection();
					}
					
					if (tmpPeopleId != row["idPERSONNE"] && row["idPERSONNE"]>0){
						
						tmpPeopleId = row["idPERSONNE"];
						
						var people:People = new People();
						people.id = row ["idPERSONNE"];
						people.first_name = row ["prenomPersonne"];
						people.last_name = row ["nomPersonne"];
						
						var role:Role= new Role();
						role.id = row["idROLE"];
						people.role= role;
						workStructure.peopleList.addItem(people);
					}
					
				}
			}
			
			_sqlStatement.sqlConnection.close();
			responder.result(workStructure);
		}
		
		
		/*******************************************************/
		/** Mise à jour de la liste des structures de travail **/
		/*******************************************************/
		/** 1)Delete de la table participer
		 *  2)Mise à jour de la table ACTION pour chaque action contenu dans la liste de structure de travail
		 *  3)Insertion dans la table PARTICIPER pour chaque personne ayant un rôle */
		
		public function updateWorkStructureList(workStructureList:ArrayCollection):void{
			_workStructureList = workStructureList;
			deleteWorkStructure();
		}
			
		
		private function deleteWorkStructure():void{
			setBDDName();
			_sqlStatement = new SQLStatement();				
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "DELETE FROM PARTICIPER ";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,deleteWorkStructureResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);		
		}
		
		private function deleteWorkStructureResult(event:SQLEvent):void{
			_actionIndex = -1;
			updateAction();
		}
		
		private function updateAction():void{
			_actionIndex++
				
			if (_actionIndex < _workStructureList.length){
				
				_ws = _workStructureList.getItemAt(_actionIndex) as WorkStructure;
				
				setBDDName();
				_sqlStatement = new SQLStatement();				
				_sqlStatement.sqlConnection = this.sqlConnection;
				var query:String = " UPDATE ACTION set idLIVRABLE = :idLIVRABLE, charges = :charges, duree = :duree, consignes = :consignes, dateModification = :dateModification " +
								   " WHERE idACTION = :idACTION";
				
				_sqlStatement.parameters[":idLIVRABLE"] = _ws.action.deliverable.id;
				_sqlStatement.parameters[":charges"] = _ws.action.workload;
				_sqlStatement.parameters[":duree"] = _ws.action.duration;
				_sqlStatement.parameters[":consignes"] = _ws.action.instruction;
				_sqlStatement.parameters[":idACTION"] = _ws.action.id;
				_sqlStatement.parameters[":dateModification"] = new Date();
				
				_sqlStatement.text = query;
				_sqlStatement.addEventListener(SQLEvent.RESULT,updateActionResult);
				
				openAndExecStatementInAsyncMode(_sqlStatement);	
			}else{
				_sqlStatement.sqlConnection.close();
				responder.result(null);
			}
		}
		
		private function updateActionResult(event:SQLEvent):void{
			_peopleIndex = -1;
			affectRole();
		}
		
		private function affectRole():void{
			
			_peopleIndex ++
				
			if (_peopleIndex < _ws.peopleList.length){
				
				var people:People = _ws.peopleList.getItemAt(_peopleIndex) as People;
				
				setBDDName();
				_sqlStatement = new SQLStatement();				
				_sqlStatement.sqlConnection = this.sqlConnection;
				var query:String = " INSERT INTO PARTICIPER (idACTION, idPERSONNE, idROLE, dateCreation, dateModification) VALUES (:idACTION, :idPERSONNE, :idROLE, :dateCreation, :dateModification)";
				
				_sqlStatement.parameters[":idACTION"] = _ws.action.id;
				_sqlStatement.parameters[":idPERSONNE"] = people.id;
				_sqlStatement.parameters[":idROLE"] = people.role.id;
				_sqlStatement.parameters[":dateCreation"] = new Date();
				_sqlStatement.parameters[":dateModification"] = new Date();
				
				_sqlStatement.text = query;
				_sqlStatement.addEventListener(SQLEvent.RESULT,affectRoleResult);
				
				openAndExecStatementInAsyncMode(_sqlStatement);				
			}else{
				updateAction();
			}
		}
		
		private function affectRoleResult(event:SQLEvent):void{
			affectRole();
		}
	}
}