package com.anssi.ebios.utils
{
	import flash.events.Event;
	
	import mx.controls.Tree;
	import mx.events.ListEvent;
	import mx.events.TreeEvent;

	public class AdvancedTree extends Tree
	{
		
		protected var savedSelectedIndices:Array;
		protected var openItemIndices:Array = new Array();
		[Bindable] public var contextMenuEnabled:Boolean = true;
		 
		public function AdvancedTree()
		{
			super();
			addEventListener(TreeEvent.ITEM_OPEN, itemClickHandler);
			addEventListener(TreeEvent.ITEM_CLOSE, itemClickHandler);
			addEventListener(ListEvent.ITEM_CLICK, itemClickHandler);
		}
		

		protected function itemClickHandler(event:Event):void{
			saveOpenedItems();
			saveSelectedItems();
		}
		
		public function saveOpenedItems():void{
			openItemIndices = new Array();
			for each(var openItem:* in this.openItems){
				openItemIndices.push(this.getItemIndex(openItem));
			}
		}
		
		public function saveSelectedItems():void{
			savedSelectedIndices = this.selectedIndices;
		}
		
	    public function openItemByIndices(indices:Array):void{
	    	if(indices != null && indices.length > 0){
		    	validateProperties(); // **** mandatory ***/
	    		indices = indices.sort(Array.NUMERIC);
	
	    		for each(var index:* in indices){
		    		selectedIndex = index;
	    			var node:* = selectedItem;
	    			expandItem(XML(node), true);
	    		}
				//loadSavedSelectedIndices();
	    	}
	    }
	    
	    public function openPreviousOpenedItems():void{
	    	if(null == this.openItemIndices || this.openItemIndices.length == 0) this.openRoot();
	    	else this.openItemByIndices(this.openItemIndices);
	    }
	    
	    public function loadSavedSelectedIndices():void{
	    	if(savedSelectedIndices != null)
	    		this.selectedIndices = savedSelectedIndices;
	    	else
	    		this.selectedIndices = [];
	    }
	    
	    public function openRoot():void{
	    	validateProperties(); // **** mandatory ***/
	    	expandItem(dataProvider[0],true);
	    }
	    
	    public function clearOpenedIndices():void{
	    	this.openItemIndices = null;
	    }
	    
	}
}