package com.anssi.ebios.utils
{
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.utils.ByteArray;
	
	public class Properties
	{

		private var properties:Array = new Array();
		
		public function Properties()
		{
		}
		
		/**
		 * 
		 * @param path : absolute path
		 * @return a Properties object
		 * 
		 */
		public static function getBundle(path:String) : Properties
		{
			var props:Properties = new Properties();
			
			var file:File = new File(path);
			var fileStream:FileStream = new FileStream();
			fileStream.open(file, FileMode.READ);
			var line:String = "";
			var currentChar:String = null;
			while(fileStream.bytesAvailable){
				currentChar = fileStream.readUTFBytes(1);
				if(currentChar == String.fromCharCode(10)){
					
				}else if(currentChar == String.fromCharCode(13))
				{
					props.addProperty(line);
					line = "";
				} else{
					line += currentChar;
					if(fileStream.position == file.size){
						props.addProperty(line);
						line = "";
					}
				}
			}
			fileStream.close();
			return props;
		}
		
		/**
		 * 
		 * @param file
		 * @return 
		 * 
		 */
		public static function getEmbeddedBundle(file:Class) : Properties {
			var props:Properties = new Properties();
			var fileInstance:ByteArray = new file();
			var line:String = "";
			var currentChar:String = null;
			while(fileInstance.bytesAvailable){
				currentChar = fileInstance.readUTFBytes(1);
				if(currentChar == "\n")
				{
					props.addProperty(line);
					line = "";
				} else{
					line += currentChar;
					if(fileInstance.position == fileInstance.length){
						props.addProperty(line);
						line = "";
					}
				}
			}

			return props;
		}
		
		
		/**
		 * 
		 * @param key
		 * @param replace
		 * @return the value associated at the given key
		 * 
		 */
		public function getValue(key:String, replace:Array = null):String
		{
			if(properties[key] == null){
				return "";
			}
			var value:String = properties[key];
			if(replace != null && replace.length>0)
			{
				for (var i :int = 0 ; i<replace.length;i++){
					value = value.replace("{"+i+"}", replace[i]);
				}
			}
			return value.replace("\r","");
		}
		
		/**
		 * 
		 * @param line
		 * add property using given line
		 * 
		 */
		private function addProperty(line:String):void
		{
			if(line != null && line.length>0 && (line.indexOf("#")>0 || line.indexOf("#") == -1)){
				var i:int = line.indexOf("=");
				var key:String = line.substr(0,i);
				var value:String = line.substr(i+1);
				properties[key] = value;
			}
		}

	}
}