package com.anssi.ebios.utils
{
	import com.adobe.cairngorm.control.CairngormEventDispatcher;
	import com.anssi.ebios.event.objectiveevent.GetObjectiveEvent;
	import com.anssi.ebios.event.parameterevent.GetParameterTypeEvent;
	import com.anssi.ebios.event.roleevent.GetRoleEvent;
	import com.anssi.ebios.event.securitymeasuretypeevent.GetSecurityMeasureTypeEvent;
	import com.anssi.ebios.event.securityneed.GetSecurityNeedsEvent;
	import com.anssi.ebios.event.statusevent.GetStatusEvent;
	import com.anssi.ebios.event.supportassettype.GetSupportAssetsTypesEvent;
	import com.anssi.ebios.event.threatevent.GetThreatTypeEvent;
	import com.anssi.ebios.event.threatsourcetypeevent.GetThreatSourceTypeEvent;
	import com.anssi.ebios.event.vulnerabilitytypeevent.GetVulnerabilityTypeEvent;
	import com.anssi.ebios.model.AppModelLocator;
	
	import flash.events.Event;
	import flash.events.EventDispatcher;
	
	import mx.collections.ArrayCollection;

	[Event(name="refDataLoaded", type="flash.events.Event")]
	public class ReferencesDataManager extends EventDispatcher
	{
		private static var _instance:ReferencesDataManager = null;
		private const NB_REFERENCES_DATA_COLLECTION_TO_LOAD:Number = 11;
		// nb de collections de données de réf à charger avant de charger l'objet
		private var _nbReferencesDataCollectionToLoad:Number = NB_REFERENCES_DATA_COLLECTION_TO_LOAD;
		
		public function ReferencesDataManager()
		{
		}
		
		public static function getInstance():ReferencesDataManager{
			if(null == _instance) _instance = new ReferencesDataManager();
			return _instance;
		}
		
		
		public function loadAllReferencesData():void{
			_nbReferencesDataCollectionToLoad = NB_REFERENCES_DATA_COLLECTION_TO_LOAD;
			//loadSecurityNeeds();
			loadThreatSources();
			loadImpacts();
			loadParameterType();
			loadThreatType();
			loadVulnerabilityType();
			loadObjectives();
			loadThreatSourceType();
			loadSecurityMeasureType();
			loadRoles();
			loadStatus();
			loadSupportAssetsTypes();
			
			// TODO : toutes les chargées
		}
		
		
		
		/*private function loadSecurityNeeds():void{
			var getSecurityNeedsEvent:GetSecurityNeedsEvent = new GetSecurityNeedsEvent(loadSecurityNeedsSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getSecurityNeedsEvent);
		}
		private function loadSecurityNeedsSuccessHandler(back:*):void{
			AppModelLocator.getInstance().securityNeeds = (back as ArrayCollection);
			referencesDataLoaded();
		}*/
		
		private function loadParameterType():void{
			var getParameterTypeEvent:GetParameterTypeEvent = new GetParameterTypeEvent(loadParameterTypeSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getParameterTypeEvent);
		}
		private function loadParameterTypeSuccessHandler(back:*):void{
			AppModelLocator.getInstance().parameterType = (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function loadThreatType():void{
			var getThreatTypeEvent :GetThreatTypeEvent = new GetThreatTypeEvent(loadThreatTypeSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getThreatTypeEvent);
		}
		
		private function loadThreatTypeSuccessHandler(back:*):void{
			AppModelLocator.getInstance().threatType = (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function loadVulnerabilityType():void{
			var getVulnerabilityTypeEvent:GetVulnerabilityTypeEvent = new GetVulnerabilityTypeEvent(loadVulnerabilityTypeSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getVulnerabilityTypeEvent);
		}
		
		private function loadVulnerabilityTypeSuccessHandler(back:*):void{
			AppModelLocator.getInstance().vulnerabilityType = (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function loadObjectives():void{
			var getObjectiveEvent:GetObjectiveEvent = new GetObjectiveEvent(loadObjectivesSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getObjectiveEvent);
		}
		
		private function loadObjectivesSuccessHandler(back:*):void{
			AppModelLocator.getInstance().objectives = (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function loadThreatSourceType():void{
			var getThreatSourceTypeEvent:GetThreatSourceTypeEvent = new GetThreatSourceTypeEvent(loadThreatSourceTypeSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getThreatSourceTypeEvent);
		}
		
		private function loadThreatSourceTypeSuccessHandler(back:*):void{
			AppModelLocator.getInstance().threatSourceType= (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function loadSecurityMeasureType():void{
			var getSecurityMeasureTypeEvent:GetSecurityMeasureTypeEvent = new GetSecurityMeasureTypeEvent(loadSecurityMeasureTypeSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getSecurityMeasureTypeEvent);
		}
		
		private function loadSecurityMeasureTypeSuccessHandler(back:*):void{
			AppModelLocator.getInstance().securityMeasureType = (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function loadRoles():void{
			var getRoleEvent:GetRoleEvent = new GetRoleEvent(loadRolesSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getRoleEvent);
		}
		
		private function loadRolesSuccessHandler(back:*):void{
			AppModelLocator.getInstance().role = (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function loadStatus():void{
			var getStatusEvent:GetStatusEvent = new GetStatusEvent(loadStatusSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getStatusEvent);
		}
		
		private function loadStatusSuccessHandler(back:*):void{
			AppModelLocator.getInstance().status = (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function loadThreatSources():void{
			// TODO : faire l'appel
			loadThreatSourcesSuccessHandler(new ArrayCollection());
		}
		private function loadThreatSourcesSuccessHandler(back:*):void{
			AppModelLocator.getInstance().threatSources = (back as ArrayCollection);
			referencesDataLoaded();
		}			
		private function loadImpacts():void{
			// TODO : faire l'appel
			loadImpactsSuccessHandler(new ArrayCollection());
		}
		private function loadImpactsSuccessHandler(back:*):void{
			AppModelLocator.getInstance().impacts = (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function loadSupportAssetsTypes():void{
			var getSupportAssetsTypesEvent:GetSupportAssetsTypesEvent = new GetSupportAssetsTypesEvent(loadSupportAssetsTypesSuccessHandler);
			CairngormEventDispatcher.getInstance().dispatchEvent(getSupportAssetsTypesEvent);
		}
		private function loadSupportAssetsTypesSuccessHandler(back:*):void{
			AppModelLocator.getInstance().supportAssetsTypes = (back as ArrayCollection);
			referencesDataLoaded();
		}
		
		private function referencesDataLoaded():void{
			this._nbReferencesDataCollectionToLoad--;
			if(this._nbReferencesDataCollectionToLoad == 0){
				dispatchEvent(new Event("refDataLoaded"));
			}
		}
		
		
		
		
	}
}