package com.anssi.ebios.utils
{
	import com.anssi.ebios.model.Action;
	import com.anssi.ebios.model.Study;
	
	import mx.collections.ArrayCollection;

	public class StageUtil
	{
		
		[Bindable] public static var studyStagesDefined:Boolean = false;
		public static var stages:ArrayCollection = null;
		
		
		
		
		public function StageUtil()
		{
		}
		
		
		// Méthode qui retourne True si l'étape est accessible pour cette étude
		public static function isAccessibleStageForThisStudy(numStage:String):Boolean{
			var accessible:Boolean = false;
			if(stages != null && numStage != ""){
				
				for each (var stage:Action in stages){
					if(stage.numero == numStage){
						accessible = true;
						break;
					}
				}
			}
			return accessible;
		}
		
		// Méthode qui retourne la prochaine action accessible
		public static function getNextStage(numCurrentStage:String):Action{
			var nextStage:Action = null;
			var currentStageFound:Boolean = false;
			if(stages != null && numCurrentStage != ""){
				
				for each (var stage:Action in stages){					
					// ON S'ARRETE QUAND ON TROUVE UNE ETAPE ULTERIEURE
					if(stage.numero > numCurrentStage){
						nextStage = stage;
						break;
					}
				}
			}
			return nextStage;
		}
		
		public static function getPreviousStage(numCurrentStage:String):Action{
			var nextStage:Action = null;
			var currentStageFound:Boolean = false;
			
			if(stages != null && numCurrentStage != ""){
				var reversedStages:ArrayCollection = new ArrayCollection(stages.toArray().reverse());
				for each (var stage:Action in reversedStages){					
					// ON S'ARRETE QUAND ON TROUVE UNE ETAPE PRECEDENTE
					if(stage.numero < numCurrentStage){
						nextStage = stage;
						break;
					}
				}
			}
			return nextStage;
		}

		
	}
}