package com.anssi.ebios.utils.language
{
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.SecurityErrorEvent;
	import flash.filesystem.File;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.utils.Dictionary;

	[Bindable]
	public class DictionaryUtil
	{
		protected var additionalFiles:Dictionary = new Dictionary();
		
		
		
		public var currentKey:String;
		
		public function DictionaryUtil()
		{
			
		}
		
		public function createDictionary(key:String):Object
		{
			return getObjectFromContent(additionalFiles[key]);
		}
		
		protected function getObjectFromContent(content:String):Object
		{
			var object:Object = new Object();
			var pattern:RegExp = /\\n/g;
			

			for each(var line:String in content.split("\n"))
			{
				var split:Array = line.split("=");
				var key:String = split[0];
				var value:String = line.substr(key.length+1);
				object[key] = value.replace(pattern,'\n');
			}
			return object;
		}

		public function onLoadAdditionalFileCompleted(event:Event):void
		{
			var content:String = event.target.data;
			additionalFiles[currentKey] = content
			dispatchEvent(new Event('loadLanguageCompleted'));
		}
		
		protected function onLoadError(event:Event):void
		{
			throw Error("Error during loading the file ("+event.toString()+")");
		}
		
		public function loadFile(filename:String,path:String):void
		{
			var file:File = new File(path+filename); //Fix Mac OS and Linux bug whith paths (path must be start with file://)
			
			currentKey = filename;
			var xmlLoader:URLLoader = new URLLoader();
			var request:URLRequest = new URLRequest(file.url);
			xmlLoader.addEventListener(Event.COMPLETE, onLoadAdditionalFileCompleted);
			xmlLoader.addEventListener(IOErrorEvent.IO_ERROR, onLoadError);
			xmlLoader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, onLoadError);
			xmlLoader.load(request);
		}


	}
}