package com.anssi.ebios.utils.openxml
{
	import mx.collections.ArrayCollection;
	
	public class OpenXMLUtil
	{
		public static const NAMESPACE_VALUE:String = "http://schemas.openxmlformats.org/wordprocessingml/2006/main";
		
		public function OpenXMLUtil()
		{
			
		}
		
		/**
		 * 
		 * @param listColumOpenXml Collection d'objet ColumnOpenXml. Liste des colonnes du tableaux
		 * @param data Dataprovider du tableau
		 * @return Retourne un tableau au format OpenXML
		 * 
		 **/
		public static function createOpenXMLTable(listColumOpenXml:ArrayCollection,data:ArrayCollection):XML
		{
			var w:Namespace = new Namespace("w", NAMESPACE_VALUE);
			
			var xml:XML=<w:tbl xmlns:w={w.uri}>
							<w:tblPr>
								<w:tblBorders>
								  <w:top w:val="single" w:sz="1" />
								  <w:left w:val="single" w:sz="1" />
								  <w:bottom w:val="single" w:sz="1" />
								  <w:right w:val="single" w:sz="1" />
								  <w:insideH w:val="single" w:sz="1" />
								  <w:insideV w:val="single" w:sz="1" />
								</w:tblBorders>
							</w:tblPr>
							<w:tr></w:tr>
						</w:tbl>;
			
			//Création des entête
			for each (var columnOpenXml:ColumnOpenXml in listColumOpenXml)
			{
				(xml.w::tr[0]).appendChild(<w:tc xmlns:w={w.uri}> <w:p> <w:r> <w:t>{columnOpenXml.header}</w:t></w:r></w:p></w:tc>);
			}
				
			//Création du contenu
			var i:int=0;
			for each (var row:Object in data)
			{
				i++		
				xml.appendChild(<w:tr xmlns:w={w.uri}></w:tr>);
				for each (var columnOpenXml1:ColumnOpenXml in listColumOpenXml)
				{
					(xml.w::tr[i]).appendChild(<w:tc xmlns:w={w.uri}> <w:p> <w:r> <w:t>{row[columnOpenXml1.datafield]}</w:t></w:r></w:p></w:tc>)
				}
			}
			xml.appendChild(createOpenXMLText(""));
			return xml;
		}
		

		public static function createOpenXMLTitle(titleValue:String):XML
		{
			var w:Namespace = new Namespace("w", NAMESPACE_VALUE);
			// creation des objets XML
			var xml:XML = <w:p xmlns:w={w.uri}></w:p> ;
			var structR:XML = <w:r xmlns:w={w.uri}></w:r>;
			var structRPR:XML = <w:rPr xmlns:w={w.uri}><w:color w:val="FF0000"/></w:rPr>
			// recuperation de la liste des objets à afficher
			var list:XMLList = applyCarriageReturn(titleValue) ;
			// creation de la strcuture finale
			structR.appendChild(structRPR);
			for(var i:int=0;i<list.length();i++)
			{
				structR.appendChild(list[i]);	
			}
			xml.appendChild(structR);
			// retour du resultat
			return xml;
		}
		
		public static function createOpenXMLText(text:String):XML
		{
			var w:Namespace = new Namespace("w", NAMESPACE_VALUE);
			// creation des objets XML
			var xml:XML = <w:p xmlns:w={w.uri}></w:p> ;
			var structR:XML = <w:r xmlns:w={w.uri}></w:r>;
			var structRPR:XML = <w:rPr xmlns:w={w.uri}><w:b /></w:rPr>
			// recuperation de la liste des objets à afficher
			var list:XMLList = applyCarriageReturn(text) ;
			// creation de la structure finale
			structR.appendChild(structRPR);
			for(var i:int=0;i<list.length();i++)
			{
				structR.appendChild(list[i]);	
			}
			xml.appendChild(structR);
			// retour du resultat
			return xml;
		}

		
		public static function createOpenXMLDescription(descriptionValue:String):XML
		{
			var w:Namespace = new Namespace("w", NAMESPACE_VALUE);
			// creation des objets XML
			var xml:XML = <w:p xmlns:w={w.uri}></w:p> ;
			var structR:XML = <w:r xmlns:w={w.uri}></w:r>;
			var structRPR:XML = <w:rPr xmlns:w={w.uri}><w:b /></w:rPr>
			// recuperation de la liste des objets à afficher
			var list:XMLList = applyCarriageReturn(descriptionValue) ;
			// creation de la strcuture finale
			structR.appendChild(structRPR);
			for(var i:int=0;i<list.length();i++)
			{
				structR.appendChild(list[i]);	
			}
			xml.appendChild(structR);
			// retour du resultat
			return xml;
		}

		
		public static function baseXMLDocument():XML
		{
			var w:Namespace = new Namespace("w", NAMESPACE_VALUE);
			
			var xml:XML = <w:document xmlns:w={w.uri}>
							<w:body></w:body>
							</w:document>;
			return xml;
			
		}
		
		public static function applyCarriageReturn(str:String):XMLList
		{
			var w:Namespace = new Namespace("w", NAMESPACE_VALUE);
			
			var xml:XMLList = new XMLList();
			var split:Array = str.split('\n');
			for each (var oneStr:String in split)
			{
				xml += new XML(<w:t xmlns:w={w.uri}>{oneStr}</w:t>);
				xml+= new XML(<w:cr xmlns:w={w.uri} />);
			}
			return xml;
		}
		
		
		public static function documentBody(xml:XML):XML
		{
			var w:Namespace = new Namespace("w", NAMESPACE_VALUE);
			return xml.w::body[0] as XML;
		}
	}
}