package com.anssi.ebios.utils.sql
{
	import com.anssi.ebios.utils.Properties;
	import com.anssi.ebios.utils.Resources;
	import com.logica.fwk.event.SystemEventDispatcher;
	
	import flash.data.SQLConnection;
	import flash.data.SQLMode;
	import flash.events.SQLErrorEvent;
	import flash.events.SQLEvent;
	import flash.filesystem.File;

	public class AppSQLConnection extends SQLConnection
	{
		private var _name:String = null;
		private var _async:Boolean = false;
		
		[Bindable]
		[Embed(source="config/config.properties",mimeType ="application/octet-stream")]
		private var config:Class;
		private var configs:Properties = null;
		
		public function AppSQLConnection(name:String, open:Boolean = true, async:Boolean = false)
		{
			super();
			
			this._async = async;
			this._name = name;
			
			/* ********* CONFIG ********** */
			// on pointe vers le fichier de config
			configs = Properties.getEmbeddedBundle(config);
			
			if(open) openConnection();
		}
		
		protected function openConnection():void{

			var path:String = File.applicationStorageDirectory.nativePath+Resources.getInstance().getDirectorySeparator()+configs.getValue("app.storage.studies.directory")+Resources.getInstance().getDirectorySeparator()+this._name;
			
			
			if(!this._async)
				this.open(new File(path),SQLMode.UPDATE);
			else{
				this.addEventListener(SQLEvent.OPEN, 		openSuccess);
				this.addEventListener(SQLErrorEvent.ERROR, 	errorHandler);
				
				this.openAsync(new File(path), SQLMode.UPDATE);
			}
		}
		
		private function openSuccess(e:SQLEvent):void{
			trace('Open BDD in async mode');
		}
		
		private function errorHandler(e:SQLErrorEvent):void{
			trace('SQL Query error:'+e.error.message);
		}
		
		
	}
}