package com.anssi.ebios.view.component
{
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import mx.containers.HBox;
	import mx.controls.List;
	
	public class AbstractBasculeList extends HBox
	{
		public function AbstractBasculeList()
		{
			super();
		}
		import mx.collections.ArrayCollection;
		import mx.core.DragSource;
		import mx.core.IUIComponent;
		import mx.events.DragEvent;
		import mx.managers.DragManager;
		
		[Bindable] public var dataLeftList:ArrayCollection = new ArrayCollection();
		[Bindable] public var dataRightList:ArrayCollection = new ArrayCollection();
		
		[Bindable] public var dataFieldLeftList:String = 'label';
		[Bindable] public var dataFieldRightList:String = 'label';
		
		
		public static const FULL_SIZE_STATE:String = 'fullSizeState';
		public static const DELIVRABLE_STATE:String = 'delivrableState';
		
		protected function leftToRight(itemsSelected:Array):void
		{
			if(itemsSelected)
			{
				
				var items:Array =  itemsSelected;
				
				addItemsOnCollection( items, dataRightList);
				removeItemsOnCollection(items, dataLeftList);
				changeEventDispatcher();
				leftToRightEventDispatcher();
				
			}
		}
		
		protected function rightToLeft(itemsSelected:Array):void
		{
			if(itemsSelected)
			{
				
				var items:Array =  itemsSelected;
				
				addItemsOnCollection( items, dataLeftList);
				removeItemsOnCollection(items, dataRightList);
				changeEventDispatcher();
			}
		}
		
		
		protected function addItemsOnCollection(items:Array,targetCollection:ArrayCollection):void
		{
			for each (var item:Object in items)
			{
				targetCollection.addItem( item );
			}
		}
		
		protected function removeItemsOnCollection(items:Array,targetCollection:ArrayCollection):void
		{
			for each (var item:Object in items)
			{
				targetCollection.removeItemAt( targetCollection.getItemIndex(item) );
			}
		}
		
		public function leftToRightEventDispatcher():void{
			dispatchEvent(new Event('leftToRight'));
		}
		
		public function changeEventDispatcher():void
		{
			dispatchEvent(new Event('change'));
		}
		 
		protected function dragCompleteHandler(event:DragEvent):void
		{
			changeEventDispatcher();
		}
		
		public var lastObjectSelected:Object;
		
		public function clickHandlerDelivrableRight(event:MouseEvent):void
		{
			if(event.currentTarget is List)
			{
				lastObjectSelected = (event.currentTarget as List).selectedItem;
				dispatchEvent(new Event('delivrableSelectedRight',true));
			}
		}
		public function clickHandlerDelivrableLeft(event:MouseEvent):void{
			if(event.currentTarget is List){
				lastObjectSelected = (event.currentTarget as List).selectedItem;
				dispatchEvent(new Event('delivrableSelectedLeft',true));
			}
		}
	}
}