package com.anssi.ebios.view.supportasset.link
{
	import com.anssi.ebios.utils.graphicutil.GraphicsUtil;
	import com.logica.component.tree.Entity;
	import com.logica.component.tree.SimpleLinkEntity;
	import com.logica.fwk.component.control.AdvancedButton;
	import com.logica.fwk.component.layout.canvas.ZoomableCanvas;
	import com.logica.fwk.event.ItemEvent;
	import com.logica.fwk.event.SystemEventDispatcher;
	
	import flash.display.BitmapData;
	import flash.display.CapsStyle;
	import flash.display.GradientType;
	import flash.display.JointStyle;
	import flash.display.LineScaleMode;
	import flash.events.ContextMenuEvent;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.text.TextFormat;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	
	import mx.controls.Alert;
	import mx.core.UIComponent;
	import mx.core.UITextField;
	import mx.effects.Glow;
	import mx.events.CloseEvent;
	import mx.graphics.ImageSnapshot;
	import mx.utils.GraphicsUtil;
	
	public class SupportAssetLinkEntity extends SimpleLinkEntity
	{
		
		
		/**
		 * EVENEMENTS LANCES PAR LE SYSTEM EVENT DISPATCHER 
		 * [Event(name="highlightSupportAssetEntity", type="com.logica.fwk.event.ItemEvent")]
		 * [Event(name="supportAssetLinkChangesToSave", type="flash.events.Event")]
		 * 
		 * 
		 * 
		 * 
		 **/
		
		
		
		
		
		
		
		private var deleteButton:AdvancedButton;
		public function SupportAssetLinkEntity(fromEnt:Entity, toEnt:Entity, xml:XML=null)
		{
			super(fromEnt, toEnt, xml);
			this.x = (fromEntity.x+toEntity.x)/2;
			this.y = (fromEntity.y+toEntity.y)/2;
			this.xmlNode.@x = this.x;
			this.xmlNode.@y = this.y;
			this.LINE_COLOR = 0x00B9FF;
			
			
			// BOUTON SUPPRESSION
			deleteButton = new AdvancedButton();
			deleteButton.toolTip = resourceManager.getString("resources", "supportasset.action.link.deletebutton.tooltip");
			deleteButton.styleName = "cancel";
			deleteButton.addEventListener(MouseEvent.ROLL_OVER, rollOverHandler);
			deleteButton.addEventListener(MouseEvent.ROLL_OUT, rollOutHandler);
			deleteButton.addEventListener(MouseEvent.CLICK, clickHandler);
			this.addChild(deleteButton);
			
			// ECOUTE EVENEMENTS
			SystemEventDispatcher.getInstance().addEventListener("supportAssetEntityDeleted", supportAssetEntityDeletedHandler);
		}
		
		override public function linkTo(fakeEntity:Entity):void{
			var myCurrentContainer:UIComponent = this.manager.container;
			if(this.manager.container is ZoomableCanvas) myCurrentContainer = (this.manager.container as ZoomableCanvas).internalCanvas;
			
			
			var origin:Point = null;
			var destination:Point = null;
			var lineThickness:Number = 2;
			var lineColor:Number = LINE_COLOR;
			var lineAlpha:Number = 1
			var xButton:Number = 0;
			var yButton:Number = 0;
			
			
			// FLECHE = ENFANT VERS PARENT
			// ENFANT AU-DESSUS DU PARENT
			if((fromEntity.y + fromEntity.height) <= toEntity.y){
				// milieu bas vers milieu haut
				origin = new Point(fromEntity.x+fromEntity.width/2, fromEntity.y+fromEntity.height);
				xButton = origin.x + 5;
				yButton = origin.y + 5;
				destination = new Point(toEntity.x+toEntity.width/2, toEntity.y);
			}
			// ENFANT EN-DESSOUS DU PARENT
			else if(fromEntity.y >= (toEntity.y + toEntity.height)){
				// milieu haut vers milieu bas
				origin = new Point(fromEntity.x+fromEntity.width/2, fromEntity.y);
				xButton = origin.x + 5;
				yButton = origin.y - 30;
				destination = new Point(toEntity.x+toEntity.width/2, toEntity.y+toEntity.height);
			}
			// ENFANT A GAUCHE DU PARENT
			else if((fromEntity.x + fromEntity.width) <= toEntity.x){
				// milieu droit vers milieu gauche
				origin = new Point(fromEntity.x+fromEntity.width, fromEntity.y+fromEntity.height/2);
				xButton = origin.x + 5;
				yButton = origin.y + 5;
				destination = new Point(toEntity.x, toEntity.y+toEntity.height/2);
			}
			// ENFANT A DROITE DU PARENT
			else{
				// milieu gauche vers milieu droit
				origin = new Point(fromEntity.x, fromEntity.y+fromEntity.height/2);
				xButton = origin.x - 30;
				yButton = origin.y + 5;
				destination = new Point(toEntity.x+toEntity.width, toEntity.y+toEntity.height/2);
			}
			
			// FLECHE
//			trace("origin:"+origin.x+";"+origin.y+" vers destination:"+destination.x+";"+destination.y);
			myCurrentContainer.graphics.lineStyle(2, LINE_COLOR, 1, true, LineScaleMode.NORMAL, CapsStyle.ROUND, JointStyle.MITER, 1);
			myCurrentContainer.graphics.beginFill(LINE_COLOR);
			com.anssi.ebios.utils.graphicutil.GraphicsUtil.drawArrow(myCurrentContainer.graphics, origin, destination,
				{shaftThickness:lineThickness, headWidth:10, headLength:15,
					shaftPosition:.20, edgeControlPosition:.5
				}
			);
			
			
			// BOUTON SUPPRIMER
			if(this.manager.container.contains(this)) this.manager.container.removeChild(this);
			this.x = xButton;
			this.y = yButton;
			this.manager.container.addChild(this);
			this.parent.setChildIndex(this,0);
		}
			
		
		
		// When we roll over the delete button
		private function rollOverHandler(event:MouseEvent):void{
			this.parent.setChildIndex(this,this.parent.numChildren-1);
			SystemEventDispatcher.getInstance().dispatchEvent(new ItemEvent("highlightSupportAssetEntity", this.xmlNode.@from+""));
			SystemEventDispatcher.getInstance().dispatchEvent(new ItemEvent("highlightSupportAssetEntity", this.xmlNode.@to+""));
		}
		
		// When we roll out the delete button
		private function rollOutHandler(event:MouseEvent):void{
			this.parent.setChildIndex(this,0);
		}
		
		// When we click on the delete button
		private function clickHandler(event:Event):void{
			this.parent.setChildIndex(this,this.parent.numChildren-1);
			askDeleteConfirmation();
		}
		
		private function askDeleteConfirmation():void{
			Alert.yesLabel = resourceManager.getString("resources", "common.alert.yeslabel");
			Alert.noLabel = resourceManager.getString("resources", "common.alert.nolabel");
			Alert.show(resourceManager.getString("resources", "supportasset.action.link.delete"), resourceManager.getString("resources", "common.alert.title.save"), Alert.YES | Alert.NO, this, deleteConfirmationHandler);
		}
		
		private function deleteConfirmationHandler(event:CloseEvent):void{
			if(event.detail == Alert.YES)
			{
				SystemEventDispatcher.getInstance().dispatchEvent(new Event("supportAssetLinkChangesToSave"));
				if(this.manager.container.contains(this)) this.manager.container.removeChild(this);
				this.deleteLinkEntity();
			}
		}
		
		
		private function supportAssetEntityDeletedHandler(event:ItemEvent):void{
			// Si le lien a une liaison avec l'entité supprimée
			if(event != null && ((event.item+"") == this.xmlNode.@from || (event.item+"") == this.xmlNode.@to)){
				// on le supprime également
				if(this.manager.container.contains(this)) this.manager.container.removeChild(this);
				this.deleteLinkEntity();
			}
		}
		
	}
}