package com.anssi.ebios.services
{
	import com.anssi.ebios.model.VulnerabilityType;
	
	import flash.data.SQLResult;
	import flash.data.SQLStatement;
	import flash.events.SQLEvent;
	
	import mx.collections.ArrayCollection;
	import mx.rpc.IResponder;

	public class VulnerabilityTypeService extends AppServices
	{
		
		public var responder:IResponder;
		private var _sqlStatement:SQLStatement;
		
		public function VulnerabilityTypeService(responder:IResponder)
		{
			this.responder = responder;
			this.mode = AppServices.MODE_ASYNCHRONOUS;
		}
		
		/**********************************************************/
		/** Récupération de la liste des types de vulnérabilités **/
		/**********************************************************/
		public function getVulnerabilityTypeList():void{
			setBDDName();
			
			_sqlStatement = new SQLStatement();
			
			_sqlStatement.sqlConnection = this.sqlConnection;
			var query:String = "SELECT * FROM TVULN";
			
			_sqlStatement.text = query;
			_sqlStatement.addEventListener(SQLEvent.RESULT,getVulnerabilityTypeListResult);
			
			openAndExecStatementInAsyncMode(_sqlStatement);	
		}
		
		private function getVulnerabilityTypeListResult(event:SQLEvent):void{
			// récupération des résultats
			var result:SQLResult = SQLStatement(event.target).getResult();
			
			var vulnerabilityTypeList:ArrayCollection = new ArrayCollection();
			
			// si nous avons des résultats
			if (result != null && result.data != null)
			{
				var row:Object;
				var numRows:int = result.data.length;
				var vulnerabilityType:VulnerabilityType;
				for (var i:int = 0; i < numRows; i++)
				{
					row = result.data[i];
					vulnerabilityType = new VulnerabilityType();
					vulnerabilityType.id = row["idTVULN"];
					vulnerabilityType.label = row["libelle"];
					
					vulnerabilityTypeList.addItem(vulnerabilityType);
				}
			}
			
			_sqlStatement.sqlConnection.close();
			responder.result(vulnerabilityTypeList);
		}
	}
}